
#ifndef __HSCAL_BLACS_BIMPISUM_HSCALFUNC_HH
#define __HSCAL_BLACS_BIMPISUM_HSCALFUNC_HH

#include "../../../../include/scalapack.h"

void hscal_BI_MPI_SUM(
     int N,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
)
{
   if (tcomp != NULL)
   {
      HSCAL_DEBUG(
           __FILE__, __FUNCTION__,__LINE__, 
           "(%d, %d) MPI_SUM of N %d", 
           myrow, mycol, N
      );
      TCOMP(myrow, mycol, nprow, npcol) += N;
   }
}

#endif

