
#ifndef __HSCAL_BLACS_BISEND_HSCALFUNC_HH
#define __HSCAL_BLACS_BISEND_HSCALFUNC_HH

/*
*  The implementation here depends on the MPI package
*  Currently using only the simple method
*/
#include "../../../../include/scalapack.h"

void hscal_BI_MPI_Send_nocomm(
     int N, int rdest, int cdest,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp, int *tcomm
)
{
   if (tcomm != NULL)
   {
      HSCAL_DEBUG(
           __FILE__, __FUNCTION__,__LINE__, 
           "SEND N %d (%d, %d)->(%d, %d)", 
           N, myrow, mycol, rdest, cdest
      );

      TCOMM(myrow, mycol, rdest, cdest, nprow, npcol) += N;
   }
} 

#endif
