/*****************************************************************************/
/* mpCtriv - contains set of trivial topology functions                      */
/* Coded by Dm. Arapov for A.Lastovtsky 1995-1996                            */
/* Release 1.10.96                                                           */
/* generateg by mpcc compiler from nettype trivial(n) { coord I=n;}; 27.10.05*/
    
/*****************************************************************************/
#include "mpCinternal.h"
#include "mpCtriv.h"
/****************** MPC_NetType_trivial_node *********************************/
int MPC_NetType_trivial_node(int pnum,const int *ppar,int ppower,int **pnodes,int **plinks){
  MPC_Source_position_set(0,0);
  return 2;
}
/***************** MPC_NetType_trivial_link **********************************/
int MPC_NetType_trivial_link(int pnum1,int pnum2,const int *ppar,int ppower,int **pnodes,int **plinks){
  MPC_Source_position_set(0,0);
  return 0;
}
/**************** MPC_NetType_trivial_parent *********************************/
int MPC_NetType_trivial_parent(const int *ppar,int ppower,int **pnodes,int **plinks){
  
/**/
  int coordinate[1];
  {
/*begin asynch elementwise (line 0)*/
    coordinate[(0)] = 0;
/*end asynch elementwise*/
  }
  MPC_Source_position_set(0,0);
  return MPC_NetType_trivial_coord2num(coordinate,ppar,ppower,pnodes,plinks);
}
/*************** MPC_NetType_trivial_power ***********************************/
int MPC_NetType_trivial_power(const int *ppar,int ppower,int **pnodes,int **plinks){
  MPC_Source_position_set(0,0);
  return  * ppar;
}
/************** MPC_NetType_trivial_num2coord ********************************/
void MPC_NetType_trivial_num2coord(int pnum,const int *ppar,int *pcoord,int ppower,int **pnodes,int **plinks){
  {
/*begin asynch elementwise (line 0)*/
     * pcoord = pnum;
/*end asynch elementwise*/
  }
}
/************** MPC_NetType_trivial_coord2num ********************************/
int MPC_NetType_trivial_coord2num(const int *pcoord,const int *ppar,int ppower,int **pnodes,int **plinks){
  MPC_Source_position_set(0,0);
  return  * pcoord;
}

                                     
