#ifndef _MPC_TRIV
#define _MPC_TRIV
/*****************************************************************************/
/* mpCtriv.h - header file for set of trivial topology functions             */
/* Coded by Dm. Arapov for A.Lastovtsky 1995-1996                            */
/* Release 1.10.96                                                           */
/*****************************************************************************/
#include "mpCinternal.h"
Int MPC_NetType_trivial_node( Int num, const Int* aparams,
                              Int ppower, Int ** pnodes, Int ** plinks);
Int MPC_NetType_trivial_link(Int fromnum, Int tonum, const Int* aparams,
                             Int ppower, Int ** pnodes, Int ** plinks);
Int MPC_NetType_trivial_parent(const Int* params,
                               Int ppower, Int ** pnodes, Int ** plinks);
Int MPC_NetType_trivial_power(const Int *p1,
                              Int ppower, Int ** pnodes, Int ** plinks);
void MPC_NetType_trivial_num2coord(Int num, const Int* params, Int *coord,
                                   Int ppower, Int ** pnodes, Int ** plinks);
Int MPC_NetType_trivial_coord2num(const Int* coord, const Int *params,
                                  Int ppower, Int ** pnodes, Int ** plinks); 
#endif
