# define DEP(a, b) a
# define SELF yyt
# include "mpcAttr.h"
/* line 35 "../../../../HeteroMPI/mpC/front/mpc.ag" */


# include "gnu_kw.h"
# define EMPTY_SON	mMPC_FreeNode(SELF)
# define SET_ERROR_TYPE SELF->MPC_Expr.Type=ErrorType
# define NET_ARG_LIST_DIAGNOSTIC(expr)	if(agContext==NET_ARG_LIST){Make_Message(285,xxError,expr->MPC_Expr.Pos,expr);};
		/* "This expression can't be used in net type argument" */

# define _NO_	0
# define _SRC_	1
# define _INH_	2

#define SU_Member_Possible  ParentNode!=NoTree&&(ParentNode->MPC_BinaryExpr.OpCode==DOT||ParentNode->MPC_BinaryExpr.OpCode==ARROW)&&ParentNode->MPC_BinaryExpr.Roperand==SELF

static tTree ParentNode;
static tTree NetCast_Node=NoTree;  /* for check of Ident distribution inside of predicate; */
static bool  Undeclared_Ident_Possible;

static tTree op1_type, op2_type;   /* used to get operand types without typedef nodes; */


  /***************************/
  static void Check_NetworkArgs    /* in call of network function; */
  /***************************/
# if defined __STDC__ || defined __cplusplus
	(tTree expr)
# else
	(expr) tTree expr;
# endif
  {
    tTree type, nettype, parnet, par=NoTree, argnet, arg;
    tPosition Pos;

    type = expr->MPC_CallExpr.Function->MPC_Expr.Type;
    if(type->Kind==kMPC_PointerType)
      type = type->MPC_PointerType.ElementType;
    nettype = type->MPC_FunctionType.NetParamType;
    if(nettype!=NoTree && nettype->Kind==kMPC_NetTypeSpecifier) {
      nettype = nettype->MPC_NetTypeSpecifier.NetType;
      par = nettype->MPC_NetType.ParamList;
    }
    parnet = type->MPC_FunctionType.NetParam;
    argnet = expr->MPC_CallExpr.StoreNet;
    arg = expr->MPC_CallExpr.NetworkArgList;

    if(nettype!=NoTree && nettype->Kind!=kMPC_FreeNode &&
       par!=NoTree     && par->Kind!=kMPC_FreeNode) {          /* the generic case: */
      Pos = arg->MPC_Exprs.Pos;
      while(par!=NoTree && par->Kind!=kMPC_FreeNode &&
	    arg!=NoTree && arg->Kind!=kMPC_FreeNode) {
	expr->MPC_Expr.Flag.Ignore |= Check_ArgumentType(NETWORK_ARG_LIST,
							 par, arg->MPC_Exprs.Expr
				      );
        par = par->MPC_Var.Next;
        arg = arg->MPC_Exprs.Next;
	Pos = arg->MPC_Exprs.Pos;
      }
      if(par!=NoTree && par->Kind!=kMPC_FreeNode) {
	Make_Message(286, xxError, expr->MPC_Expr.Pos, expr);
		/* "Too few network arguments in function call" */
	expr->MPC_Expr.Flag.Ignore = YES;
      }
      if(arg!=NoTree && arg->Kind!=kMPC_FreeNode) {
	Make_Message(287, xxError, Pos, expr);
		/* "Too many network arguments in function call" */
	expr->MPC_Expr.Flag.Ignore = YES;
      }
    }
    if(nettype==NoTree || nettype->Kind==kMPC_FreeNode) {
      /* this function should be called ONLY on the specified net: */
      if(argnet!=parnet) {
	expr->MPC_Expr.Flag.Ignore = YES;
	Make_Message(288, xxError, expr->MPC_Expr.Pos, expr);
		/* "Network function call incompatible with prototype (invalid net argument)" */
      }
    }

  }   /* end Check_NetworkArgs() */




static char yyb;

char * yyCheck1_passed; // = & Tree_module_does_not_match_evaluator_module_51042;
char * yyCheck2 = & generate_Tree_module_without_option_0;

static void yyVisit1 ARGS((register tTree yyt));

void mpcAttr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{ yyVisit1 (yyt); }

static void yyVisit1
# if defined __STDC__ | defined __cplusplus
 (register tTree yyt)
# else
 (yyt) register tTree yyt;
# endif
{
/* line 116 "../../../../HeteroMPI/mpC/front/mpc.ag" */


  int Prev_agContext;



 switch (yyt->Kind) {

case kMPC_Expr:
if(yyt->MPC_Expr.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 197 "../../../../HeteroMPI/mpC/front/mpc.ag" */

yyVisit1 (yyt->MPC_Expr.Type);
/* line 197 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 197 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 197 "../../../../HeteroMPI/mpC/front/mpc.ag" */

break;

case kMPC_IndirectExpr:
yyVisit1 (yyt->MPC_IndirectExpr.Expr);
/* line 221 "../../../../HeteroMPI/mpC/front/mpc.ag" */
 yyt->MPC_IndirectExpr.Flag = yyt->MPC_IndirectExpr.Expr->MPC_Expr.Flag;
if(yyt->MPC_IndirectExpr.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 1291 "../../../../HeteroMPI/mpC/front/mpc.ag" */
 yyt->MPC_IndirectExpr.Type = yyt->MPC_IndirectExpr.Expr->MPC_Expr.Type;
yyVisit1 (yyt->MPC_IndirectExpr.Type);
/* line 520 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			yyt->MPC_IndirectExpr.Repl     = yyt->MPC_IndirectExpr.Expr->MPC_Expr.Repl;
/* line 519 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			yyt->MPC_IndirectExpr.StoreNet = yyt->MPC_IndirectExpr.Expr->MPC_Expr.StoreNet;
/* line 518 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			yyt->MPC_IndirectExpr.EvalNet  = yyt->MPC_IndirectExpr.Expr->MPC_Expr.EvalNet;
break;

case kMPC_Const:
/* line 223 "../../../../HeteroMPI/mpC/front/mpc.ag" */
 if(yyt->MPC_Const.Flag.Ignore) { SET_ERROR_TYPE; return;} 
if(yyt->MPC_Const.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 1293 "../../../../HeteroMPI/mpC/front/mpc.ag" */
 yyt->MPC_Const.Flag.Const = YES; 
yyVisit1 (yyt->MPC_Const.Type);
/* line 528 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			yyt->MPC_Const.Repl = true;
/* line 523 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			  if(!yyt->MPC_Const.StoreNet || !yyt->MPC_Const.EvalNet)
			    CompilerError("StoreNet/EvalNet not set for MPC_Const", yyt->MPC_Const.Pos);
			  yyt->MPC_Const.Flag.Asynchr = YES;
			
break;

case kMPC_IntConst:
/* line 223 "../../../../HeteroMPI/mpC/front/mpc.ag" */
 if(yyt->MPC_IntConst.Flag.Ignore) { SET_ERROR_TYPE; return;} 
if(yyt->MPC_IntConst.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 1293 "../../../../HeteroMPI/mpC/front/mpc.ag" */
 yyt->MPC_IntConst.Flag.Const = YES; 
yyVisit1 (yyt->MPC_IntConst.Type);
/* line 528 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			yyt->MPC_IntConst.Repl = true;
/* line 523 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			  if(!yyt->MPC_IntConst.StoreNet || !yyt->MPC_IntConst.EvalNet)
			    CompilerError("StoreNet/EvalNet not set for MPC_Const", yyt->MPC_IntConst.Pos);
			  yyt->MPC_IntConst.Flag.Asynchr = YES;
			
break;

case kMPC_UIntConst:
/* line 223 "../../../../HeteroMPI/mpC/front/mpc.ag" */
 if(yyt->MPC_UIntConst.Flag.Ignore) { SET_ERROR_TYPE; return;} 
if(yyt->MPC_UIntConst.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 1293 "../../../../HeteroMPI/mpC/front/mpc.ag" */
 yyt->MPC_UIntConst.Flag.Const = YES; 
yyVisit1 (yyt->MPC_UIntConst.Type);
/* line 528 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			yyt->MPC_UIntConst.Repl = true;
/* line 523 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			  if(!yyt->MPC_UIntConst.StoreNet || !yyt->MPC_UIntConst.EvalNet)
			    CompilerError("StoreNet/EvalNet not set for MPC_Const", yyt->MPC_UIntConst.Pos);
			  yyt->MPC_UIntConst.Flag.Asynchr = YES;
			
break;

case kMPC_FloatConst:
/* line 223 "../../../../HeteroMPI/mpC/front/mpc.ag" */
 if(yyt->MPC_FloatConst.Flag.Ignore) { SET_ERROR_TYPE; return;} 
if(yyt->MPC_FloatConst.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 1293 "../../../../HeteroMPI/mpC/front/mpc.ag" */
 yyt->MPC_FloatConst.Flag.Const = YES; 
yyVisit1 (yyt->MPC_FloatConst.Type);
/* line 528 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			yyt->MPC_FloatConst.Repl = true;
/* line 523 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			  if(!yyt->MPC_FloatConst.StoreNet || !yyt->MPC_FloatConst.EvalNet)
			    CompilerError("StoreNet/EvalNet not set for MPC_Const", yyt->MPC_FloatConst.Pos);
			  yyt->MPC_FloatConst.Flag.Asynchr = YES;
			
break;

case kMPC_StringLiteral:
/* line 225 "../../../../HeteroMPI/mpC/front/mpc.ag" */

				if(yyt->MPC_StringLiteral.Flag.Ignore) { SET_ERROR_TYPE; return;}
				if(!SELF->MPC_Expr.StoreNet)
				  SELF->MPC_Expr.StoreNet = CONST_NET;
				if(!SELF->MPC_Expr.EvalNet) 
				  SELF->MPC_Expr.EvalNet = CONST_NET_LIST;
				if(!SELF->MPC_Expr.Type) 
				  SELF->MPC_Expr.Type = VoidType;  
			    
if(yyt->MPC_StringLiteral.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

yyVisit1 (yyt->MPC_StringLiteral.Next);
/* line 197 "../../../../HeteroMPI/mpC/front/mpc.ag" */

yyVisit1 (yyt->MPC_StringLiteral.Type);
/* line 533 "../../../../HeteroMPI/mpC/front/mpc.ag" */

		      yyt->MPC_StringLiteral.Repl = true;
/* line 532 "../../../../HeteroMPI/mpC/front/mpc.ag" */
 yyt->MPC_StringLiteral.Flag.Asynchr = YES; 
break;

case kMPC_Ident:
/* line 236 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			if(yyt->MPC_Ident.Store!=NoTree && yyt->MPC_Ident.Store->Kind==kMPC_Var && yyt->MPC_Ident.Store->MPC_Var.Flag.Ignore) {
			  
			  SET_ERROR_TYPE;
			  yyt->MPC_Ident.Flag.Ignore = YES;
			  
			}
			if( agContext==PREDICATE) { 
			  tTree p;
			  p = agNetContext;
			  while(p->Kind==kMPC_Subnet)
			    p = p->MPC_Subnet.Distribution;
			  p = p->MPC_Net.NetType;
                          while(p->Kind==kMPC_NetTypeSpecifier)
                            p = p->MPC_NetTypeSpecifier.NetType;
                          p = p->MPC_NetType.CoordDecl;
			  while(p->Kind==kMPC_CoordDecl) {
			    if(yyt->MPC_Ident.Ident==p->MPC_CoordDecl.Ident && !MPF_SRC)
			      { yyt->MPC_Ident.Store = p; break; }     
			    p = p->MPC_CoordDecl.Next;
			  }
			}
			if(!yyt->MPC_Ident.Store && agContext==PREDICATE &&
			   agFKind==NETWORK && agNetworkParamList!=NoTree) {
			  tTree npar = agNetworkParamList;
			  while(npar!=NoTree && npar->Kind==kMPC_Var) {
			    if(yyt->MPC_Ident.Ident==npar->MPC_Var.Ident) { yyt->MPC_Ident.Store = npar; break; }
			    npar = npar->MPC_Var.Next;
			  }
			}
			if( !yyt->MPC_Ident.Store && !((agContext==STATS || agContext==SCHEME_DECL) &&
					Undeclared_Ident_Possible ||
					SU_Member_Possible ||
					agContext==PREDICATE && MPF_SRC) && !yyt->MPC_Ident.Flag.Ignore ) {
			  SET_ERROR_TYPE;
			  yyt->MPC_Ident.Flag.Ignore = YES;
			  Make_MessageI(289, xxError, yyt->MPC_Ident.Pos, xxIdent,
                                        (char*)&yyt->MPC_Ident.Ident, SELF);
					
			  ParentNode = NoTree;
			  return; 
			}
			if(SU_Member_Possible) ParentNode = NoTree;
		  
if(yyt->MPC_Ident.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 1295 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			if(yyt->MPC_Ident.Flag.Ignore) return;
			if(yyt->MPC_Ident.Store) {
			  if(yyt->MPC_Ident.Store->Kind==kMPC_Var) {
			    Push_PurePattern(yyt->MPC_Ident.Store->MPC_Var.Type);
			    yyt->MPC_Ident.Type = Make_Type();
			    if(!(
				 yyt->MPC_Ident.Type->Kind==kMPC_ArrayType ||
				 yyt->MPC_Ident.Type->Kind==kMPC_FunctionType)) yyt->MPC_Ident.Flag.Lvalue = YES;
				 if(agContext==SCHEME_DECL && yyt->MPC_Ident.Store->MPC_Var.Flag.Parameter &&
				    TerminalType(yyt->MPC_Ident.Type)->Kind==kMPC_BasicType &&
				    TerminalType(yyt->MPC_Ident.Type)->MPC_BasicType.TypeConstructor==DOUBLE)
				   yyt->MPC_Ident.Flag.FixPoint = YES;
			    if(agContext==SCHEME_DECL && yyt->MPC_Ident.Store->MPC_Var.Flag.Parameter &&
			       yyt->MPC_Ident.Type->Kind==kMPC_ArrayType &&
			       yyt->MPC_Ident.Type->MPC_ArrayType.NumberOfComponents==0) {
			      
			      
			      while(yyt->MPC_Ident.Type->Kind==kMPC_ArrayType) {
				Push_Pattern(
					mMPC_PointerType(yyt->MPC_Ident.Type->MPC_ArrayType.Pos, 
						NoTree, NoTree, yyt->MPC_Ident.Type->MPC_ArrayType.Flag, 1,
						yyt->MPC_Ident.Type->MPC_ArrayType.Step, yyt->MPC_Ident.Type->MPC_ArrayType.ElementType
					)
				);
				yyt->MPC_Ident.Type = yyt->MPC_Ident.Type->MPC_ArrayType.ElementType;
			      }
			      yyt->MPC_Ident.Type = Make_Type();
			    }
			  }
			  else if(yyt->MPC_Ident.Store->Kind==kMPC_CoordDecl) {
			    yyt->MPC_Ident.Type = IntType;
			    yyt->MPC_Ident.Flag.Lvalue = NO;
			  }
			  else if(yyt->MPC_Ident.Store->Kind==kMPC_EnumConst) {
			    yyt->MPC_Ident.Type = IntType;
			    yyt->MPC_Ident.Flag.Lvalue = NO;
			  }
			  else if(yyt->MPC_Ident.Store->Kind==kMPC_SU_Member) {
			    Push_PurePattern(yyt->MPC_Ident.Store->MPC_SU_Member.Type);
			    yyt->MPC_Ident.Type = Make_Type();
			  }
			  else {
			    CompilerError("Invalid 'Store' for MPC_Ident", yyt->MPC_Ident.Pos);
			    yyt->MPC_Ident.Flag.Ignore = YES;
			  }
			}
			else {  
			  yyt->MPC_Ident.Type = Default_FunctionType;
			  yyt->MPC_Ident.Flag.Lvalue = NO;
			}
			yyt->MPC_Ident.Flag.Const = NO; 
			if(yyt->MPC_Ident.Flag.Ignore) return;
		    
yyVisit1 (yyt->MPC_Ident.Type);
/* line 198 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 198 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 536 "../../../../HeteroMPI/mpC/front/mpc.ag" */

                          if(yyt->MPC_Ident.StoreNet!=NoTree && yyt->MPC_Ident.EvalNet!=NoTree) 
                            return;  
			  yyt->MPC_Ident.Repl = false;
			  if(yyt->MPC_Ident.Flag.Ignore) return;
			  if(yyt->MPC_Ident.Store!=NoTree) {
			    if(yyt->MPC_Ident.Store->Kind==kMPC_Var) {
                              extern tTree CurrentFunction;
			      yyt->MPC_Ident.StoreNet = yyt->MPC_Ident.Store->MPC_Var.Distribution;
			      
			      
			      
                              
			      
			      if((agFKind==NETWORK || MPF_SRC) &&
                                 Is_Subnet(agNetContext,yyt->MPC_Ident.StoreNet))
				yyt->MPC_Ident.StoreNet = agNetContext;
                              else if(agFKind==NETWORK &&
                                     Is_Subnet(yyt->MPC_Ident.StoreNet,CurrentFunction->MPC_Function.Distribution))
                                ;  
			      else if(agFKind==NODAL && yyt->MPC_Ident.StoreNet==COMPUTING_SPACE)
				yyt->MPC_Ident.StoreNet = SINGLE_NODE;
			      else if(agFKind==NODAL && yyt->MPC_Ident.StoreNet!=SINGLE_NODE ||
				      agFKind==NETWORK &&
					!(yyt->MPC_Ident.StoreNet->Kind==kMPC_Net &&
					 yyt->MPC_Ident.StoreNet->MPC_Net.Topology==PARAMETER) &&
					 !Is_Subnet(yyt->MPC_Ident.StoreNet,agNetContext)) {
				Make_MessageI( 290, xxError, yyt->MPC_Ident.Pos,
					xxIdent, (char*)&yyt->MPC_Ident.Ident, SELF);
		
				yyt->MPC_Ident.Flag.Ignore = YES;
			      } 
			      if(agContext==PREDICATE &&
				 !(yyt->MPC_Ident.StoreNet==agNetContext || yyt->MPC_Ident.StoreNet==COMPUTING_SPACE ||
				   yyt->MPC_Ident.StoreNet==SINGLE_NODE ||
                                   NetCast_Node!=NoTree &&
                                     (NetCast_Node->MPC_NetCastExpr.StoreNet==agNetContext ||
                                      NetCast_Node->MPC_NetCastExpr.StoreNet==COMPUTING_SPACE ||
                                      NetCast_Node->MPC_NetCastExpr.StoreNet==SINGLE_NODE))) {
				
				tTree supernet=agNetContext;
				int ERR=1;
				for(supernet=agNetContext;supernet->Kind!=kMPC_Subnet;
				    supernet=supernet->MPC_Subnet.Distribution) {
				  if(yyt->MPC_Ident.StoreNet==supernet) ERR = 0;
				  break;
				}
				if(ERR) {
				  tPosition decl_pos, RealPosition(tPosition);
				  yyt->MPC_Ident.Flag.Ignore = YES;
				  Make_MessageI( 487 , xxError, yyt->MPC_Ident.Pos, xxIdent, (char*)&yyt->MPC_Ident.Ident, SELF);
		
				  decl_pos = RealPosition(yyt->MPC_Ident.Store->MPC_Var.Pos);
				  Make_MessageI(28, xxInformation, yyt->MPC_Ident.Pos, xxShort,
						(char*)&(decl_pos.Line), SELF);
		
				}
			      }
			      {  
				tTree term_type;
			        if(yyt->MPC_Ident.Store->MPC_Var.Type->Kind==kMPC_FunctionType)
				  term_type = yyt->MPC_Ident.Store->MPC_Var.Type->MPC_FunctionType.ResultType;
			        else
				  term_type = yyt->MPC_Ident.Store->MPC_Var.Type;
				if(!term_type->MPC_Type.Flag.Repl) { 
				  Push_PurePattern(term_type);
				  term_type = Make_Type();
				  term_type = TerminalType(term_type);
				}
				yyt->MPC_Ident.Repl = term_type->MPC_Type.Flag.Repl;
			      } 
			      
			      if(yyt->MPC_Ident.StoreNet==SINGLE_NODE && agContext!=PREDICATE
				 )
				yyt->MPC_Ident.StoreNet = agFKind==NODAL ? SINGLE_NODE : agNetContext;
			    }
			    else if(yyt->MPC_Ident.Store->Kind==kMPC_CoordDecl)
			      if(agContext==PREDICATE)  
				yyt->MPC_Ident.StoreNet = agNetContext;
			      else
				yyt->MPC_Ident.StoreNet = SINGLE_NODE;
			    else if(yyt->MPC_Ident.Store->Kind==kMPC_SU_Member) {
			      yyt->MPC_Ident.StoreNet = agNetContext;  
			    }
			    else if(yyt->MPC_Ident.Store->Kind==kMPC_EnumConst) {
			      yyt->MPC_Ident.StoreNet = CONST_NET;
			      yyt->MPC_Ident.Repl = true;
			    }
			    else
			      CompilerError("Invalid 'Store' for MPC_Ident", yyt->MPC_Ident.Pos);
			    
			    if(yyt->MPC_Ident.StoreNet!=NoTree && yyt->MPC_Ident.StoreNet->Kind==kMPC_Subnet &&
			     yyt->MPC_Ident.StoreNet->MPC_Subnet.Flexible) {
			      int Save_agContext=agContext;
			      tTree Save_agNetContext=agNetContext;
			      yyt->MPC_Ident.Flag.Ignore |= Go(yyt->MPC_Ident.StoreNet,agContext,false,agNetContext,agFKind);
			      agContext = Save_agContext;
			      agNetContext = Save_agNetContext;
			    }

			    if(agContext==PREDICATE && yyt->MPC_Ident.Repl==false &&
			       yyt->MPC_Ident.Store->Kind!=kMPC_CoordDecl) {
			      yyt->MPC_Ident.Flag.Ignore = YES;
			      Make_Message(322, xxError, yyt->MPC_Ident.Pos, SELF);
					   
                            }

			    
			    yyt->MPC_Ident.EvalNet = Make_NetList(yyt->MPC_Ident.StoreNet);
			    yyt->MPC_Ident.EvalNet->MPC_NetList.Prev->MPC_FreeNode.Parent = SELF;
			    if(yyt->MPC_Ident.StoreNet!=SINGLE_NODE && yyt->MPC_Ident.StoreNet!=HOST &&
			       yyt->MPC_Ident.StoreNet!=NO_NET && !yyt->MPC_Ident.StoreNet->MPC_NetOrSubnet.SingleNode)
			      yyt->MPC_Ident.Flag.Distributed = YES;
			    yyt->MPC_Ident.Flag.Asynchr = YES;
			    if(agFKind==NODAL && yyt->MPC_Ident.StoreNet!=SINGLE_NODE &&
			       yyt->MPC_Ident.StoreNet!=COMPUTING_SPACE && yyt->MPC_Ident.StoreNet!=CONST_NET) {
			      yyt->MPC_Ident.Flag.Ignore = YES;
			      DISTR_WarningI(( 313, xxWarning, yyt->MPC_Ident.Pos, xxIdent,
						(char*)&yyt->MPC_Ident.Ident, SELF));
		
			    }
			  }
			  else {  
			    yyt->MPC_Ident.StoreNet = agFKind==NODAL ? SINGLE_NODE : agNetContext;
			    yyt->MPC_Ident.EvalNet = Make_NetList(yyt->MPC_Ident.StoreNet);
			    yyt->MPC_Ident.Flag.Distributed = agFKind!=NODAL;
			    yyt->MPC_Ident.Flag.Asynchr = YES;
			  }
			  if(yyt->MPC_Ident.Flag.Ignore) return;
			
break;

case kMPC_CastExpr:
/* line 281 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			if(yyt->MPC_CastExpr.TypeName->MPC_Type.Flag.Ignore ||
			   yyt->MPC_CastExpr.Operand->MPC_Expr.Flag.Ignore) {
			  SET_ERROR_TYPE;
			  yyt->MPC_CastExpr.Flag.Ignore = YES;
			  return;
			}
		  
if(yyt->MPC_CastExpr.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

yyVisit1 (yyt->MPC_CastExpr.Operand);
yyVisit1 (yyt->MPC_CastExpr.TypeName);
/* line 1352 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			yyt->MPC_CastExpr.Flag.Ignore |= yyt->MPC_CastExpr.Operand->MPC_Expr.Flag.Ignore;
			if(yyt->MPC_CastExpr.Flag.Ignore) return;
			if(Is_VoidType(yyt->MPC_CastExpr.TypeName) && !Is_VoidType(yyt->MPC_CastExpr.Operand->MPC_Expr.Type) ||
			   Is_ScalarType(yyt->MPC_CastExpr.TypeName) && Is_ScalarType(yyt->MPC_CastExpr.Operand->MPC_Expr.Type) &&
				!Is_PointerType(yyt->MPC_CastExpr.TypeName) && !(Is_PointerType(yyt->MPC_CastExpr.Operand->MPC_Expr.Type)) ||
			   Is_PointerType(yyt->MPC_CastExpr.TypeName) && Is_IntegralType(yyt->MPC_CastExpr.Operand->MPC_Expr.Type) ||
			   Is_IntegralType(yyt->MPC_CastExpr.TypeName) && Is_PointerType(yyt->MPC_CastExpr.Operand->MPC_Expr.Type) ||
			   Is_PointerType(yyt->MPC_CastExpr.TypeName) && Is_PointerType(yyt->MPC_CastExpr.Operand->MPC_Expr.Type) ||
			   Is_ScalarType(yyt->MPC_CastExpr.TypeName) && yyt->MPC_CastExpr.Operand->MPC_Expr.Type->Kind==kMPC_ArrayType &&
			   !yyt->MPC_CastExpr.Operand->MPC_Expr.Flag.Lvalue)
			  yyt->MPC_CastExpr.Type = yyt->MPC_CastExpr.TypeName;
			else {
			  SET_ERROR_TYPE;
			  yyt->MPC_CastExpr.Flag.Ignore = YES;
			  Make_Message(109, xxError, yyt->MPC_CastExpr.Pos, SELF);
		
			}
			if(yyt->MPC_CastExpr.Flag.Ignore) return;
			yyt->MPC_CastExpr.Flag.Const = yyt->MPC_CastExpr.Operand->MPC_Expr.Flag.Const;
			REMAKE_IF_BLOCKING(&yyt->MPC_CastExpr.Operand);
		    
yyVisit1 (yyt->MPC_CastExpr.Type);
 yyt->MPC_CastExpr.Flag.Peculiarity = yyt->MPC_CastExpr.Operand->MPC_Expr.Flag.Peculiarity ? _INH_ : _NO_; ;
 yyt->MPC_CastExpr.Flag.SideEffects = yyt->MPC_CastExpr.Operand->MPC_Expr.Flag.SideEffects; ;
 yyt->MPC_CastExpr.Flag.DistrComma = yyt->MPC_CastExpr.Operand->MPC_Expr.Flag.DistrComma; ;
/* line 670 "../../../../HeteroMPI/mpC/front/mpc.ag" */


                          if(yyt->MPC_CastExpr.StoreNet!=NoTree && yyt->MPC_CastExpr.EvalNet!=NoTree) 
                            return;  


			  if(yyt->MPC_CastExpr.Operand->MPC_Expr.Flag.Ignore) {
			    yyt->MPC_CastExpr.Flag.Ignore = YES;
			    return;
			  }
			  Set_FunctionKind(yyt->MPC_CastExpr.Type, NODAL);
			  yyt->MPC_CastExpr.EvalNet = yyt->MPC_CastExpr.Operand->MPC_Expr.EvalNet;
			  yyt->MPC_CastExpr.StoreNet = yyt->MPC_CastExpr.Operand->MPC_Expr.StoreNet;
			  yyt->MPC_CastExpr.Repl = yyt->MPC_CastExpr.Operand->MPC_Expr.Repl || yyt->MPC_CastExpr.TypeName->MPC_Type.Flag.Repl;
			  yyt->MPC_CastExpr.Flag.Distributed = yyt->MPC_CastExpr.Operand->MPC_Expr.Flag.Distributed;
			  yyt->MPC_CastExpr.Flag.Asynchr = yyt->MPC_CastExpr.Operand->MPC_Expr.Flag.Asynchr;
			
break;

case kMPC_NetCastExpr:
yyVisit1 (yyt->MPC_NetCastExpr.Operand);
/* line 290 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			if(yyt->MPC_NetCastExpr.Operand->MPC_Expr.Flag.Ignore) {
			  SET_ERROR_TYPE;
			  yyt->MPC_NetCastExpr.Flag.Ignore = YES;
			  return;
			}
			if(agFKind==NODAL) {
			  SET_ERROR_TYPE;
			  yyt->MPC_NetCastExpr.Flag.Ignore = YES;
			  Make_Message(112, xxError, yyt->MPC_NetCastExpr.Pos, SELF);
			  
			  return;
			}
			if(yyt->MPC_NetCastExpr.Operand->MPC_Expr.Type!=NoTree &&
			   (yyt->MPC_NetCastExpr.Operand->MPC_Expr.Type->Kind==kMPC_FunctionType &&
			    yyt->MPC_NetCastExpr.Operand->MPC_Expr.Type->MPC_FunctionType.Flag.Basic ||
			    yyt->MPC_NetCastExpr.Operand->MPC_Expr.Type->Kind==kMPC_PointerType &&
                            yyt->MPC_NetCastExpr.Operand->MPC_Expr.Type->MPC_PointerType.ElementType!=NoTree &&
			    yyt->MPC_NetCastExpr.Operand->MPC_Expr.Type->MPC_PointerType.ElementType->Kind==kMPC_FunctionType &&
			    yyt->MPC_NetCastExpr.Operand->MPC_Expr.Type->MPC_PointerType.Flag.Basic
			  )) {
			  SET_ERROR_TYPE;
			  yyt->MPC_NetCastExpr.Flag.Ignore = YES;
			  Make_Message(116, xxError, yyt->MPC_NetCastExpr.Pos, SELF);
			  
			  return;
			}
			if(NetCast_Node==NoTree) 
			                         
			  NetCast_Node = SELF;
		  
if(yyt->MPC_NetCastExpr.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 1376 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			yyt->MPC_NetCastExpr.Flag.Ignore |= yyt->MPC_NetCastExpr.Operand->MPC_Expr.Flag.Ignore;
			if(yyt->MPC_NetCastExpr.Flag.Ignore) { SET_ERROR_TYPE; return; }

                        NetCast_Node = NoTree;   

		        yyt->MPC_NetCastExpr.Type = yyt->MPC_NetCastExpr.Operand->MPC_Expr.Type;
			{
			  tTree t=yyt->MPC_NetCastExpr.Type;
			  if(t->Kind==kMPC_PointerType &&
			     t->MPC_PointerType.ElementType->Kind==kMPC_FunctionType)
			    t = t->MPC_PointerType.ElementType;
			  if(t->Kind==kMPC_FunctionType && t->MPC_FunctionType.Flag.Basic)
			  
			    t = t->MPC_FunctionType.ResultType;
			  if(Is_VoidType(TerminalType(t))) {
			    Make_Message(110, xxError, yyt->MPC_NetCastExpr.Pos, SELF);
		
			    return;
			  }
			}
			yyt->MPC_NetCastExpr.Flag.Lvalue = yyt->MPC_NetCastExpr.Operand->MPC_Expr.Flag.Lvalue;
			yyt->MPC_NetCastExpr.Flag.Const  = yyt->MPC_NetCastExpr.Operand->MPC_Expr.Flag.Const;
			REMAKE_IF_BLOCKING(&yyt->MPC_NetCastExpr.Operand);
		    
yyVisit1 (yyt->MPC_NetCastExpr.Type);
 yyt->MPC_NetCastExpr.Flag.Peculiarity = yyt->MPC_NetCastExpr.Operand->MPC_Expr.Flag.Peculiarity ? _INH_ : _NO_; ;
 yyt->MPC_NetCastExpr.Flag.SideEffects = yyt->MPC_NetCastExpr.Operand->MPC_Expr.Flag.SideEffects; ;
 yyt->MPC_NetCastExpr.Flag.DistrComma = yyt->MPC_NetCastExpr.Operand->MPC_Expr.Flag.DistrComma; ;
/* line 831 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			yyt->MPC_NetCastExpr.Repl = yyt->MPC_NetCastExpr.Operand->MPC_Expr.Repl;
/* line 690 "../../../../HeteroMPI/mpC/front/mpc.ag" */

                          if(yyt->MPC_NetCastExpr.StoreNet!=NoTree && yyt->MPC_NetCastExpr.EvalNet!=NoTree) 
                            return;  

			  if(yyt->MPC_NetCastExpr.Operand->MPC_Expr.Flag.Ignore) {
			    yyt->MPC_NetCastExpr.Flag.Ignore = YES;
			    return;
			  }
			  if(yyt->MPC_NetCastExpr.StoreNet!=NoTree && yyt->MPC_NetCastExpr.StoreNet->Kind==kMPC_Subnet &&
			     yyt->MPC_NetCastExpr.StoreNet->MPC_Subnet.Flexible) {
			    int Save_agContext=agContext;
			    tTree Save_agNetContext=agNetContext;
			    yyt->MPC_NetCastExpr.Flag.Ignore |= Go(yyt->MPC_NetCastExpr.StoreNet,agContext,false,agNetContext,agFKind);
			    agContext = Save_agContext;
			    agNetContext = Save_agNetContext;
			    yyt->MPC_NetCastExpr.Flexible = true;
			    if(yyt->MPC_NetCastExpr.StoreNet->MPC_NetOrSubnet.Ident==NoIdent &&
			       !yyt->MPC_NetCastExpr.StoreNet->MPC_NetOrSubnet.SingleNode) {
			      yyt->MPC_NetCastExpr.Flag.Ignore = YES;
			      Make_Message(117, xxRestriction, yyt->MPC_NetCastExpr.StoreNet->MPC_Subnet.Pos, yyt->MPC_NetCastExpr.StoreNet);
		
			    }
			  }
			  yyt->MPC_NetCastExpr.Flag.Distributed = YES;
			  if(yyt->MPC_NetCastExpr.StoreNet!=NoTree && (yyt->MPC_NetCastExpr.StoreNet->MPC_NetOrSubnet.SingleNode))
			    yyt->MPC_NetCastExpr.Flag.Distributed = NO;
			  if(yyt->MPC_NetCastExpr.StoreNet!=NoTree && yyt->MPC_NetCastExpr.StoreNet->Kind==kMPC_Subnet &&
			     !yyt->MPC_NetCastExpr.StoreNet->MPC_Subnet.Predicate->MPC_Expr.Flag.Asynchr) {
			    yyt->MPC_NetCastExpr.Flag.Ignore = YES;
			    if(!yyt->MPC_NetCastExpr.StoreNet->MPC_Subnet.Predicate->MPC_Expr.Flag.Ignore && yyt->MPC_NetCastExpr.Flag.Source)
			      Make_Message(488 , xxError, yyt->MPC_NetCastExpr.StoreNet->MPC_Subnet.Predicate->MPC_Expr.Pos,
					   yyt->MPC_NetCastExpr.StoreNet->MPC_Subnet.Predicate);
		
			  }
			  if(Is_Subnet(yyt->MPC_NetCastExpr.StoreNet, yyt->MPC_NetCastExpr.Operand->MPC_Expr.StoreNet)  ||
			     yyt->MPC_NetCastExpr.Operand->MPC_Expr.StoreNet->Kind==kMPC_Net &&
			     yyt->MPC_NetCastExpr.StoreNet==yyt->MPC_NetCastExpr.Operand->MPC_Expr.StoreNet->MPC_Net.Distribution) { 
			    
			    
			    if(yyt->MPC_NetCastExpr.Operand->Kind==kMPC_Ident || yyt->MPC_NetCastExpr.Operand->MPC_Expr.StoreNet==CONST_NET
                                
			       || yyt->MPC_NetCastExpr.Operand->MPC_Expr.Flag.Asynchr && !yyt->MPC_NetCastExpr.Operand->MPC_Expr.Flag.SideEffects ) {
			      tTree tmp;
			      tmp = mMPC_FreeNode(SELF);
			      yyt->MPC_NetCastExpr.EvalNet = Clean_OutAttributes(
					  mMPC_NetList(tmp, tmp, yyt->MPC_NetCastExpr.StoreNet)
					);
			    }
			    else
			      yyt->MPC_NetCastExpr.EvalNet = yyt->MPC_NetCastExpr.Operand->MPC_Expr.EvalNet;
			    
			    yyt->MPC_NetCastExpr.Flag.Asynchr = yyt->MPC_NetCastExpr.Operand->MPC_Expr.Flag.Asynchr; 
			  }
			  else if(yyt->MPC_NetCastExpr.Operand->Kind==kMPC_Ident && 
                                   (yyt->MPC_NetCastExpr.Operand->MPC_Ident.Store!=NoTree &&
				    yyt->MPC_NetCastExpr.Operand->MPC_Ident.Store->Kind==kMPC_Var &&
				    yyt->MPC_NetCastExpr.Operand->MPC_Ident.Store->MPC_Var.Distribution==SINGLE_NODE ||
                                      yyt->MPC_NetCastExpr.Operand->MPC_Ident.Store==NoTree &&
                                      yyt->MPC_NetCastExpr.Operand->MPC_Ident.Type==Default_FunctionType)) {
			    
			    yyt->MPC_NetCastExpr.EvalNet = Make_NetList(yyt->MPC_NetCastExpr.StoreNet);
			  }
			  else if(agFKind==NETWORK && yyt->MPC_NetCastExpr.Flag.Source) {
			    Make_Message(104, xxError, yyt->MPC_NetCastExpr.Pos, SELF);
		
			    yyt->MPC_NetCastExpr.Flag.Ignore = YES;
			  }
			  else if(yyt->MPC_NetCastExpr.Flag.Source) {
			    Make_Message(105, xxError, yyt->MPC_NetCastExpr.Pos, SELF);
		
			    if(yyt->MPC_NetCastExpr.StoreNet->Kind==kMPC_Subnet && yyt->MPC_NetCastExpr.StoreNet->MPC_Subnet.Flexible ||
			       yyt->MPC_NetCastExpr.Operand->MPC_Expr.StoreNet->Kind==kMPC_Subnet &&
				 yyt->MPC_NetCastExpr.Operand->MPC_Expr.StoreNet->MPC_Subnet.Flexible)
			      Make_Message(29, xxRestriction, yyt->MPC_NetCastExpr.Pos, SELF);
		
			    yyt->MPC_NetCastExpr.Flag.Ignore = YES;
			  }
			  else if(!yyt->MPC_NetCastExpr.Flag.Source &&
				  (yyt->MPC_NetCastExpr.Operand->Kind==kMPC_NetCastExpr || yyt->MPC_NetCastExpr.Operand->Kind==kMPC_Ident) &&
				  Is_Subnet(yyt->MPC_NetCastExpr.Operand->MPC_Expr.StoreNet, yyt->MPC_NetCastExpr.StoreNet)) {
			    
			    *((tTree *)(SELF->MPC_NetCastExpr.ExprPtr)) = yyt->MPC_NetCastExpr.Operand;
			  }
			  else if(yyt->MPC_NetCastExpr.Operand->Kind==kMPC_Ident && !yyt->MPC_NetCastExpr.Flag.Source) {
				 
			    tPosition label_pos;
			    label_pos = RealPosition(yyt->MPC_NetCastExpr.Pos);
			    yyt->MPC_NetCastExpr.Flag.Ignore = YES;
			    Make_MessageI(106, xxError, yyt->MPC_NetCastExpr.Pos, xxIdent,
					  (char*)&(yyt->MPC_NetCastExpr.Operand->MPC_Ident.Ident), SELF);
		
			    Make_MessageI(43 , xxInformation, yyt->MPC_NetCastExpr.Pos, xxShort,
					  (char*)&(label_pos.Line), SELF);
		
			    
			  }
			  else if(yyt->MPC_NetCastExpr.Operand->Kind==kMPC_NetCastExpr &&
				  !yyt->MPC_NetCastExpr.Flag.Source && !yyt->MPC_NetCastExpr.Operand->MPC_Expr.Flag.Source) {
			         
			    tPosition extern_label_pos;
			    extern_label_pos = RealPosition(yyt->MPC_NetCastExpr.Operand->MPC_Expr.Pos);
			    yyt->MPC_NetCastExpr.Flag.Ignore = YES;
			    Make_Message(107, xxError, yyt->MPC_NetCastExpr.Pos, NoTree );
		
			    Make_MessageI(30, xxInformation, yyt->MPC_NetCastExpr.Pos, xxShort,
					  (char*)&(extern_label_pos.Line), NoTree );
		
			    if(yyt->MPC_NetCastExpr.StoreNet->Kind==kMPC_Subnet && yyt->MPC_NetCastExpr.StoreNet->MPC_Subnet.Flexible ||
			       yyt->MPC_NetCastExpr.Operand->MPC_Expr.StoreNet->Kind==kMPC_Subnet &&
				 yyt->MPC_NetCastExpr.Operand->MPC_Expr.StoreNet->MPC_Subnet.Flexible)
			      Make_Message(31, xxRestriction, yyt->MPC_NetCastExpr.Pos, NoTree );
		
			  }
			  else if(yyt->MPC_NetCastExpr.Operand->Kind==kMPC_NetCastExpr && !yyt->MPC_NetCastExpr.Flag.Source) {
			         
			    tPosition extern_label_pos;
			    extern_label_pos = RealPosition(yyt->MPC_NetCastExpr.Operand->MPC_Expr.Pos);
			    yyt->MPC_NetCastExpr.Flag.Ignore = YES;
			    Make_Message(108, xxError, yyt->MPC_NetCastExpr.Pos, NoTree );
		
			    Make_MessageI(32, xxInformation, yyt->MPC_NetCastExpr.Pos, xxShort,
					 (char*)&(extern_label_pos.Line), NoTree );
		
			    if(yyt->MPC_NetCastExpr.StoreNet->Kind==kMPC_Subnet && yyt->MPC_NetCastExpr.StoreNet->MPC_Subnet.Flexible ||
			       yyt->MPC_NetCastExpr.Operand->MPC_Expr.StoreNet->Kind==kMPC_Subnet &&
				 yyt->MPC_NetCastExpr.Operand->MPC_Expr.StoreNet->MPC_Subnet.Flexible)
			      Make_Message(31, xxRestriction, yyt->MPC_NetCastExpr.Pos, NoTree );
		
			  }
			
break;

case kMPC_CoordExpr:
/* line 322 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			if(yyt->MPC_CoordExpr.Operand->MPC_Expr.Flag.Ignore) {
			  SET_ERROR_TYPE;
			  yyt->MPC_CoordExpr.Flag.Ignore = YES;
			  return;
			}
		  
if(yyt->MPC_CoordExpr.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

yyVisit1 (yyt->MPC_CoordExpr.Operand);
/* line 1403 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			yyt->MPC_CoordExpr.Flag.Ignore |= yyt->MPC_CoordExpr.Operand->MPC_Expr.Flag.Ignore;
			if(yyt->MPC_CoordExpr.Flag.Ignore) { SET_ERROR_TYPE; return; }
		        yyt->MPC_CoordExpr.Type = IntType;
			REMAKE_IF_BLOCKING(&yyt->MPC_CoordExpr.Operand);
		    
yyVisit1 (yyt->MPC_CoordExpr.Type);
/* line 835 "../../../../HeteroMPI/mpC/front/mpc.ag" */


                          if(yyt->MPC_CoordExpr.StoreNet!=NoTree && yyt->MPC_CoordExpr.EvalNet!=NoTree) 
                            return;  


			  yyt->MPC_CoordExpr.Repl = NO;
			  if(yyt->MPC_CoordExpr.Operand->MPC_Expr.Flag.Ignore) {
			    yyt->MPC_CoordExpr.Flag.Ignore = YES;
			    return;
			  }
			  if(yyt->MPC_CoordExpr.Operand->MPC_Expr.Flag.Distributed &&
			     yyt->MPC_CoordExpr.Operand->MPC_Expr.StoreNet!=COMPUTING_SPACE &&
			     yyt->MPC_CoordExpr.Operand->MPC_Expr.StoreNet!=SINGLE_NODE &&
			     yyt->MPC_CoordExpr.Operand->MPC_Expr.StoreNet!=CONST_NET) {
			    yyt->MPC_CoordExpr.Flag.Distributed = YES, yyt->MPC_CoordExpr.Flag.Asynchr = YES;
			  }
			  else {
			    Make_Message(291, xxError, yyt->MPC_CoordExpr.Operand->MPC_Expr.Pos, SELF);
		
			    yyt->MPC_CoordExpr.Flag.Ignore = YES;
			    return;
			  }
			  yyt->MPC_CoordExpr.EvalNet = yyt->MPC_CoordExpr.Operand->MPC_Expr.EvalNet;
			  yyt->MPC_CoordExpr.StoreNet = yyt->MPC_CoordExpr.Operand->MPC_Expr.StoreNet;
			  yyt->MPC_CoordExpr.Flag.Ignore |= Eval_CoordNumber(SELF, &yyt->MPC_CoordExpr.CoordNumber);
			
 yyt->MPC_CoordExpr.Flag.Peculiarity = _NO_; ;
 yyt->MPC_CoordExpr.Flag.SideEffects = _NO_; ;
 yyt->MPC_CoordExpr.Flag.DistrComma = NO; ;
break;

case kMPC_SizeofExpr:
if(yyt->MPC_SizeofExpr.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 197 "../../../../HeteroMPI/mpC/front/mpc.ag" */

yyVisit1 (yyt->MPC_SizeofExpr.Type);
/* line 199 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 197 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 197 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 197 "../../../../HeteroMPI/mpC/front/mpc.ag" */

break;

case kMPC_Size_Of_Value:
/* line 330 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			if(yyt->MPC_Size_Of_Value.Operand->MPC_Expr.Flag.Ignore) {
			  SET_ERROR_TYPE;
			  yyt->MPC_Size_Of_Value.Flag.Ignore = YES;
			  return;
			}
		  
if(yyt->MPC_Size_Of_Value.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

yyVisit1 (yyt->MPC_Size_Of_Value.Operand);
/* line 1411 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			yyt->MPC_Size_Of_Value.Flag.Const = YES;  
		    
yyVisit1 (yyt->MPC_Size_Of_Value.Type);
 yyt->MPC_Size_Of_Value.Flag.Peculiarity = yyt->MPC_Size_Of_Value.Operand->MPC_Expr.Flag.Peculiarity ? _INH_ : _NO_; ;
 yyt->MPC_Size_Of_Value.Flag.SideEffects = _NO_; ;
 yyt->MPC_Size_Of_Value.Flag.DistrComma = NO; ;
/* line 199 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 865 "../../../../HeteroMPI/mpC/front/mpc.ag" */


                          if(yyt->MPC_Size_Of_Value.StoreNet!=NoTree && yyt->MPC_Size_Of_Value.EvalNet!=NoTree) 
                            return;  

			  yyt->MPC_Size_Of_Value.Repl = true;
			  if(yyt->MPC_Size_Of_Value.Flag.Ignore) return;
			    if(yyt->MPC_Size_Of_Value.Operand->MPC_Expr.Flag.Distributed)
			      yyt->MPC_Size_Of_Value.Flag.Distributed = YES;
			    if(yyt->MPC_Size_Of_Value.Operand->MPC_Expr.Flag.Asynchr)
			      yyt->MPC_Size_Of_Value.Flag.Asynchr = YES;
			    if(yyt->MPC_Size_Of_Value.Operand->MPC_Expr.Flag.PartAsynchr)
			      yyt->MPC_Size_Of_Value.Flag.PartAsynchr = YES;
			    yyt->MPC_Size_Of_Value.StoreNet = yyt->MPC_Size_Of_Value.Operand->MPC_Expr.StoreNet;
			    yyt->MPC_Size_Of_Value.EvalNet = yyt->MPC_Size_Of_Value.Operand->MPC_Expr.EvalNet;
			
break;

case kMPC_Size_Of_Type:
/* line 338 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			if(yyt->MPC_Size_Of_Type.Operand->MPC_Type.Flag.Ignore) {
			  SET_ERROR_TYPE;
			  yyt->MPC_Size_Of_Type.Flag.Ignore = YES;
			  return;
			}
		  
if(yyt->MPC_Size_Of_Type.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

yyVisit1 (yyt->MPC_Size_Of_Type.Operand);
/* line 1416 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			yyt->MPC_Size_Of_Type.Flag.Const = YES;  
		    
yyVisit1 (yyt->MPC_Size_Of_Type.Type);
/* line 199 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 884 "../../../../HeteroMPI/mpC/front/mpc.ag" */


                          if(yyt->MPC_Size_Of_Type.StoreNet!=NoTree && yyt->MPC_Size_Of_Type.EvalNet!=NoTree) 
                            return;  

			  yyt->MPC_Size_Of_Type.Repl = true;
			  if(yyt->MPC_Size_Of_Type.Flag.Ignore) return;
			  yyt->MPC_Size_Of_Type.Flag.Asynchr = YES;
			  yyt->MPC_Size_Of_Type.StoreNet = CONST_NET;
			  yyt->MPC_Size_Of_Type.EvalNet  = CONST_NET_LIST;
			
break;

case kMPC_TimeofExpr:
/* line 347 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			if(agContext!=NET_ARG_LIST) {
			  Inside_TimeofExpr = true;
			  Prev_agContext = agContext;
			  yyt->MPC_TimeofExpr.Flag.Ignore = Go(SELF->MPC_TimeofExpr.NetDecl, agContext, true ,
					   COMPUTING_SPACE , agFKind
				        );
			  agContext = Prev_agContext;
		    	  yyt->MPC_TimeofExpr.Flag.Ignore |= Check_NetTypeSpecifier(SELF->MPC_TimeofExpr.NetDecl);
		    	  yyt->MPC_TimeofExpr.Flag.Ignore |= Check_SingleNodeParent(SELF->MPC_TimeofExpr.NetDecl);
			  Inside_TimeofExpr = false;
			}
			if(yyt->MPC_TimeofExpr.Flag.Ignore) return;
		  
if(yyt->MPC_TimeofExpr.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 197 "../../../../HeteroMPI/mpC/front/mpc.ag" */

yyVisit1 (yyt->MPC_TimeofExpr.Type);
 yyt->MPC_TimeofExpr.Flag.Peculiarity = _SRC_;
			  NET_ARG_LIST_DIAGNOSTIC(SELF); ;
 yyt->MPC_TimeofExpr.Flag.DistrComma = NO; ;
/* line 899 "../../../../HeteroMPI/mpC/front/mpc.ag" */


                      if(yyt->MPC_TimeofExpr.StoreNet!=NoTree && yyt->MPC_TimeofExpr.EvalNet!=NoTree) 
                        return;  

		      yyt->MPC_TimeofExpr.Repl = false;
		      if(yyt->MPC_TimeofExpr.Flag.Ignore) return;
		      yyt->MPC_TimeofExpr.Flag.Distributed = YES;
		      yyt->MPC_TimeofExpr.Flag.Asynchr = YES;
		   
break;

case kMPC_UnaryExpr:
/* line 363 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			Undeclared_Ident_Possible = false;
			if(yyt->MPC_UnaryExpr.Operand->MPC_Expr.Flag.Ignore) {
			  SET_ERROR_TYPE;
			  yyt->MPC_UnaryExpr.Flag.Ignore = YES;
			  return;
			}
			else
			  yyt->MPC_UnaryExpr.Flag.Ignore = Check_Expression(SELF);
		  
if(yyt->MPC_UnaryExpr.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

yyVisit1 (yyt->MPC_UnaryExpr.Operand);
/* line 1421 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			yyt->MPC_UnaryExpr.Flag.Ignore |= yyt->MPC_UnaryExpr.Operand->MPC_Expr.Flag.Ignore;
			if(yyt->MPC_UnaryExpr.Flag.Ignore) { SET_ERROR_TYPE; return; }
			
			if(yyt->MPC_UnaryExpr.OpCode==BRACKETS && yyt->MPC_UnaryExpr.Operand->MPC_Expr.Type->Kind==kMPC_ArrayType)
			  yyt->MPC_UnaryExpr.Flag.Lvalue = YES;
			if(yyt->MPC_UnaryExpr.OpCode==STAR) {  
			  yyt->MPC_UnaryExpr.Flag.Lvalue =YES; 
			}
			
			Eval_TypeOfUnaryExpr(SELF);    
			if(agContext==SCHEME_DECL &&
			   yyt->MPC_UnaryExpr.Operand->MPC_Expr.Flag.FixPoint &&
			   !(yyt->MPC_UnaryExpr.Operand->MPC_Expr.Type->Kind==kMPC_BasicType &&
			     yyt->MPC_UnaryExpr.Operand->MPC_Expr.Type->MPC_BasicType.TypeConstructor==DOUBLE))
			  yyt->MPC_UnaryExpr.Flag.FixPoint = YES;
			if(yyt->MPC_UnaryExpr.Flag.Ignore) { SET_ERROR_TYPE; return; }
			REMAKE_IF_BLOCKING(&yyt->MPC_UnaryExpr.Operand);
		    
yyVisit1 (yyt->MPC_UnaryExpr.Type);

			yyt->MPC_UnaryExpr.Flag.Peculiarity = yyt->MPC_UnaryExpr.Operand->MPC_Expr.Flag.Peculiarity ? _INH_ : _NO_;
			if(yyt->MPC_UnaryExpr.OpCode>LINEAR || yyt->MPC_UnaryExpr.OpCode==BRACKETS ||
			   yyt->MPC_UnaryExpr.OpCode>=POST_INC && yyt->MPC_UnaryExpr.OpCode<=PRE_DEC &&
				(yyt->MPC_UnaryExpr.Type->Kind==kMPC_ArrayType && yyt->MPC_UnaryExpr.Type->MPC_ArrayType.Step!=1 ||
				 yyt->MPC_UnaryExpr.Type->Kind==kMPC_PointerType && yyt->MPC_UnaryExpr.Type->MPC_PointerType.Step!=1)
			  ) {
			  yyt->MPC_UnaryExpr.Flag.Peculiarity += _SRC_;
			  NET_ARG_LIST_DIAGNOSTIC(SELF);
			  if(agContext==PREDICATE) {
			    yyt->MPC_UnaryExpr.Flag.Ignore = YES;
			    Make_Message(324, xxError, yyt->MPC_UnaryExpr.Pos, SELF);
					 
			  }
			}
		  ;

			yyt->MPC_UnaryExpr.Flag.SideEffects = yyt->MPC_UnaryExpr.Operand->MPC_Expr.Flag.SideEffects;
			if(yyt->MPC_UnaryExpr.OpCode==POST_INC || yyt->MPC_UnaryExpr.OpCode==POST_DEC ||
			   yyt->MPC_UnaryExpr.OpCode==PRE_INC  || yyt->MPC_UnaryExpr.OpCode==PRE_DEC) {
			  yyt->MPC_UnaryExpr.Flag.SideEffects = _SRC_;
			  if(agContext==PREDICATE) {
			    yyt->MPC_UnaryExpr.Flag.Ignore = YES;
			    Make_Message(323, xxError, yyt->MPC_UnaryExpr.Pos, SELF);
					 
			  }
			}
		  ;
 yyt->MPC_UnaryExpr.Flag.DistrComma = yyt->MPC_UnaryExpr.Operand->MPC_Expr.Flag.DistrComma; ;
/* line 913 "../../../../HeteroMPI/mpC/front/mpc.ag" */


                          if(yyt->MPC_UnaryExpr.StoreNet!=NoTree && yyt->MPC_UnaryExpr.EvalNet!=NoTree) 
                            return;  

			  Push_PurePattern(yyt->MPC_UnaryExpr.Operand->MPC_Expr.Type);
			  op1_type = Make_Type();
			  while(op1_type->Kind==kMPC_VectorType)
			    op1_type = op1_type->MPC_VectorType.ElementType;

			  yyt->MPC_UnaryExpr.Repl = (yyt->MPC_UnaryExpr.OpCode>DISTRIBUTED ? true :
					(yyt->MPC_UnaryExpr.OpCode==ADDRESS ? false :
						(yyt->MPC_UnaryExpr.OpCode==STAR &&
						 op1_type->MPC_PointerType.ElementType->MPC_Type.Flag.Repl ?
							 true : yyt->MPC_UnaryExpr.Operand->MPC_Expr.Repl)));
			  if(yyt->MPC_UnaryExpr.Flag.Ignore) return;
			  yyt->MPC_UnaryExpr.Flag.Distributed = yyt->MPC_UnaryExpr.Operand->MPC_Expr.Flag.Distributed;
			  yyt->MPC_UnaryExpr.Flag.Asynchr = yyt->MPC_UnaryExpr.Operand->MPC_Expr.Flag.Asynchr && yyt->MPC_UnaryExpr.OpCode<DISTRIBUTED;
			  yyt->MPC_UnaryExpr.Flag.PartAsynchr = yyt->MPC_UnaryExpr.Operand->MPC_Expr.Flag.PartAsynchr && yyt->MPC_UnaryExpr.OpCode<DISTRIBUTED;
			  yyt->MPC_UnaryExpr.StoreNet = yyt->MPC_UnaryExpr.Operand->MPC_Expr.StoreNet;
			  yyt->MPC_UnaryExpr.EvalNet = yyt->MPC_UnaryExpr.Operand->MPC_Expr.EvalNet;
			  if(yyt->MPC_UnaryExpr.OpCode>DISTRIBUTED && yyt->MPC_UnaryExpr.StoreNet->Kind==kMPC_Subnet &&
			     yyt->MPC_UnaryExpr.StoreNet->MPC_Subnet.Flexible) {
			    yyt->MPC_UnaryExpr.Flag.Ignore = YES;
			    Make_Message(292, xxError, yyt->MPC_UnaryExpr.Pos, SELF);
		
			  }
			
break;

case kMPC_BinaryExpr:
/* line 374 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			Undeclared_Ident_Possible = false;
			if(yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Flag.Ignore ||
			   yyt->MPC_BinaryExpr.Roperand->MPC_Expr.Flag.Ignore) {
			  SET_ERROR_TYPE;
			  yyt->MPC_BinaryExpr.Flag.Ignore = YES;
			  return;
			}
			else
			  yyt->MPC_BinaryExpr.Flag.Ignore = Check_Expression(SELF);
			if(yyt->MPC_BinaryExpr.OpCode==DOT || yyt->MPC_BinaryExpr.OpCode==ARROW) ParentNode = SELF; 
		  
if(yyt->MPC_BinaryExpr.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

yyVisit1 (yyt->MPC_BinaryExpr.Roperand);
yyVisit1 (yyt->MPC_BinaryExpr.Loperand);
/* line 1442 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			yyt->MPC_BinaryExpr.Flag.Ignore |= yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Flag.Ignore || yyt->MPC_BinaryExpr.Roperand->MPC_Expr.Flag.Ignore;
			if(yyt->MPC_BinaryExpr.Flag.Ignore) { SET_ERROR_TYPE; return; }

			if(yyt->MPC_BinaryExpr.OpCode==INDEX) {
			  Eval_TypeOfIndexExpr(SELF);  
			  if(agContext==SCHEME_DECL &&
			     (yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Flag.FixPoint || yyt->MPC_BinaryExpr.Roperand->MPC_Expr.Flag.FixPoint))
			    yyt->MPC_BinaryExpr.Flag.FixPoint = YES;
			}
			else {
			  Eval_TypeOfBinaryExpr(SELF); 
			  if(agContext==SCHEME_DECL &&
			     yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Flag.FixPoint &&
			     !(yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Type->Kind==kMPC_BasicType &&
			       yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Type->MPC_BasicType.TypeConstructor==DOUBLE))
			    yyt->MPC_BinaryExpr.Flag.FixPoint = YES;
			  else if(agContext==SCHEME_DECL &&
			          yyt->MPC_BinaryExpr.Roperand->MPC_Expr.Flag.FixPoint &&
			          !(yyt->MPC_BinaryExpr.Roperand->MPC_Expr.Type->Kind==kMPC_BasicType &&
			            yyt->MPC_BinaryExpr.Roperand->MPC_Expr.Type->MPC_BasicType.TypeConstructor==DOUBLE))
			    yyt->MPC_BinaryExpr.Flag.FixPoint = YES;
			}
			if(yyt->MPC_BinaryExpr.Flag.Ignore) { SET_ERROR_TYPE; return; }
			REMAKE_IF_BLOCKING(&yyt->MPC_BinaryExpr.Loperand);
			REMAKE_IF_BLOCKING(&yyt->MPC_BinaryExpr.Roperand);
		    
yyVisit1 (yyt->MPC_BinaryExpr.Type);
 yyt->MPC_BinaryExpr.Flag.Peculiarity = (yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Flag.Peculiarity ||
					      yyt->MPC_BinaryExpr.Roperand->MPC_Expr.Flag.Peculiarity) ? _INH_ : _NO_; ;
 yyt->MPC_BinaryExpr.Flag.SideEffects = yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Flag.SideEffects ||
					     yyt->MPC_BinaryExpr.Roperand->MPC_Expr.Flag.SideEffects;
			  if(yyt->MPC_BinaryExpr.OpCode>=ASSIGN && yyt->MPC_BinaryExpr.OpCode<=INCL_OR_ASSIGN) {
			    yyt->MPC_BinaryExpr.Flag.SideEffects = _SRC_;
			    if(agContext==PREDICATE) {
			      yyt->MPC_BinaryExpr.Flag.Ignore = YES;
			      Make_Message(323, xxError, yyt->MPC_BinaryExpr.Pos, SELF);
				
			    }
			  }
		  ;

			  yyt->MPC_BinaryExpr.Flag.DistrComma = yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Flag.DistrComma ||
					      yyt->MPC_BinaryExpr.Roperand->MPC_Expr.Flag.DistrComma;
			  if(yyt->MPC_BinaryExpr.OpCode==COMMA && yyt->MPC_BinaryExpr.Loperand->MPC_Expr.StoreNet!=yyt->MPC_BinaryExpr.Roperand->MPC_Expr.StoreNet)
			    yyt->MPC_BinaryExpr.Flag.DistrComma = YES;
		 ;
/* line 944 "../../../../HeteroMPI/mpC/front/mpc.ag" */


                          if(yyt->MPC_BinaryExpr.StoreNet!=NoTree && yyt->MPC_BinaryExpr.EvalNet!=NoTree) 
                            return;  

			  Push_PurePattern(yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Type);
			  op1_type = Make_Type();
			  Push_PurePattern(yyt->MPC_BinaryExpr.Roperand->MPC_Expr.Type);
			  op2_type = Make_Type();

			  yyt->MPC_BinaryExpr.Repl = yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Repl && yyt->MPC_BinaryExpr.Roperand->MPC_Expr.Repl ||
				 yyt->MPC_BinaryExpr.OpCode==DOT && yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Repl ||
				 yyt->MPC_BinaryExpr.OpCode==ARROW && op1_type->Kind==kMPC_PointerType &&
				   op1_type->MPC_PointerType.ElementType->MPC_Type.Flag.Repl ||
			         yyt->MPC_BinaryExpr.OpCode==ASSIGN && yyt->MPC_BinaryExpr.Roperand->MPC_Expr.Repl  ?  true  :  false ||
				 yyt->MPC_BinaryExpr.OpCode==INDEX &&
                                   ( yyt->MPC_BinaryExpr.Roperand->MPC_Expr.Repl && op1_type->Kind==kMPC_ArrayType &&
				     op1_type->MPC_ArrayType.ElementType->
					MPC_Type.Flag.Repl ||
				     yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Repl && op2_type->Kind==kMPC_ArrayType &&
				     op2_type->MPC_ArrayType.ElementType->
					MPC_Type.Flag.Repl ||
				     yyt->MPC_BinaryExpr.Roperand->MPC_Expr.Repl && op1_type->Kind==kMPC_VectorType &&
				     op1_type->MPC_VectorType.ElementType->
					MPC_Type.Flag.Repl ||
				     yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Repl && op2_type->Kind==kMPC_VectorType &&
				     op2_type->MPC_VectorType.ElementType->
					MPC_Type.Flag.Repl ||
				     yyt->MPC_BinaryExpr.Roperand->MPC_Expr.Repl && op1_type->Kind==kMPC_PointerType &&
				     op1_type->MPC_PointerType.ElementType->
					MPC_Type.Flag.Repl ||
				     yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Repl && op2_type->Kind==kMPC_PointerType &&
				     op2_type->MPC_PointerType.ElementType->
					MPC_Type.Flag.Repl );
			  if(yyt->MPC_BinaryExpr.Flag.Ignore) return;
			  if(yyt->MPC_BinaryExpr.Loperand->MPC_Expr.StoreNet==CONST_NET &&
			     !yyt->MPC_BinaryExpr.Roperand->MPC_Expr.Flag.Const) {
			    yyt->MPC_BinaryExpr.StoreNet = yyt->MPC_BinaryExpr.Roperand->MPC_Expr.StoreNet;
			    yyt->MPC_BinaryExpr.EvalNet = yyt->MPC_BinaryExpr.Roperand->MPC_Expr.EvalNet;
			    yyt->MPC_BinaryExpr.Flag.Asynchr =
				 yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Flag.Asynchr && yyt->MPC_BinaryExpr.Roperand->MPC_Expr.Flag.Asynchr;
			    yyt->MPC_BinaryExpr.Flag.PartAsynchr = yyt->MPC_BinaryExpr.Roperand->MPC_Expr.Flag.PartAsynchr;
			  }
			  else if(yyt->MPC_BinaryExpr.Roperand->MPC_Expr.StoreNet==CONST_NET &&
			          !yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Flag.Const) {
			    yyt->MPC_BinaryExpr.StoreNet = yyt->MPC_BinaryExpr.Loperand->MPC_Expr.StoreNet;
			    yyt->MPC_BinaryExpr.EvalNet = yyt->MPC_BinaryExpr.Loperand->MPC_Expr.EvalNet;
			    yyt->MPC_BinaryExpr.Flag.Asynchr =
				 yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Flag.Asynchr && yyt->MPC_BinaryExpr.Roperand->MPC_Expr.Flag.Asynchr;
			    yyt->MPC_BinaryExpr.Flag.PartAsynchr = yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Flag.PartAsynchr;;
			  }
			  else if(yyt->MPC_BinaryExpr.Loperand->MPC_Expr.StoreNet==CONST_NET &&
			          yyt->MPC_BinaryExpr.Roperand->MPC_Expr.StoreNet==CONST_NET) {
			    yyt->MPC_BinaryExpr.StoreNet = CONST_NET;
			    yyt->MPC_BinaryExpr.EvalNet = CONST_NET_LIST;
			    yyt->MPC_BinaryExpr.Flag.Asynchr = YES;
			  }
			  else  
			    Eval_Distribution(SELF);
			  if(yyt->MPC_BinaryExpr.StoreNet!=NoTree && yyt->MPC_BinaryExpr.StoreNet!=SINGLE_NODE &&
			     yyt->MPC_BinaryExpr.StoreNet!=HOST && !yyt->MPC_BinaryExpr.StoreNet->MPC_NetOrSubnet.SingleNode)
			    yyt->MPC_BinaryExpr.Flag.Distributed = YES;
			  else
			    yyt->MPC_BinaryExpr.Flag.Distributed = NO;
			  if(yyt->MPC_BinaryExpr.OpCode==ASSIGN && yyt->MPC_BinaryExpr.Loperand->MPC_Expr.Repl)
			    yyt->MPC_BinaryExpr.Flag.Asynchr = NO;
			  if(yyt->MPC_BinaryExpr.Flag.Ignore) return;
			
break;

case kMPC_TernaryExpr:
/* line 387 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			Undeclared_Ident_Possible = false;
                        if(yyt->MPC_TernaryExpr.Soperand==NoTree || yyt->MPC_TernaryExpr.Toperand==NoTree) {
                          SET_ERROR_TYPE;
                          yyt->MPC_TernaryExpr.Flag.Ignore = YES;
                          Make_Message(318, xxError, yyt->MPC_TernaryExpr.Pos, SELF);
                                      
                          return;
                        }
			if(yyt->MPC_TernaryExpr.Foperand->MPC_Expr.Flag.Ignore  ||
			   yyt->MPC_TernaryExpr.Soperand!=NoTree &&
                             yyt->MPC_TernaryExpr.Soperand->Kind!=kMPC_FreeNode &&
                             yyt->MPC_TernaryExpr.Soperand->MPC_Expr.Flag.Ignore  ||
			   yyt->MPC_TernaryExpr.Toperand!=NoTree &&
                             yyt->MPC_TernaryExpr.Toperand->Kind!=kMPC_FreeNode &&
                             yyt->MPC_TernaryExpr.Toperand->MPC_Expr.Flag.Ignore) {
			  SET_ERROR_TYPE;
			  yyt->MPC_TernaryExpr.Flag.Ignore = YES;
			  return;
			}
			else
			  yyt->MPC_TernaryExpr.Flag.Ignore = Check_Expression(SELF);
		  
if(yyt->MPC_TernaryExpr.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

yyVisit1 (yyt->MPC_TernaryExpr.Toperand);
yyVisit1 (yyt->MPC_TernaryExpr.Soperand);
yyVisit1 (yyt->MPC_TernaryExpr.Foperand);
/* line 1471 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			yyt->MPC_TernaryExpr.Flag.Ignore |=  yyt->MPC_TernaryExpr.Foperand->MPC_Expr.Flag.Ignore || yyt->MPC_TernaryExpr.Soperand->MPC_Expr.Flag.Ignore ||
					yyt->MPC_TernaryExpr.Toperand->MPC_Expr.Flag.Ignore;
			if(yyt->MPC_TernaryExpr.Flag.Ignore) { SET_ERROR_TYPE; return; }
			Eval_TypeOfTernaryExpr(SELF);
			if(yyt->MPC_TernaryExpr.Flag.Ignore) { SET_ERROR_TYPE; return; }

			if(agContext==SCHEME_DECL &&
			   yyt->MPC_TernaryExpr.Foperand->MPC_Expr.Flag.FixPoint &&
			   !(yyt->MPC_TernaryExpr.Foperand->MPC_Expr.Type->Kind==kMPC_BasicType &&
			     yyt->MPC_TernaryExpr.Foperand->MPC_Expr.Type->MPC_BasicType.TypeConstructor==DOUBLE))
			  yyt->MPC_TernaryExpr.Flag.FixPoint = YES;
			if(agContext==SCHEME_DECL &&
			   yyt->MPC_TernaryExpr.Soperand->MPC_Expr.Flag.FixPoint &&
			   !(yyt->MPC_TernaryExpr.Soperand->MPC_Expr.Type->Kind==kMPC_BasicType &&
			     yyt->MPC_TernaryExpr.Soperand->MPC_Expr.Type->MPC_BasicType.TypeConstructor==DOUBLE))
			  yyt->MPC_TernaryExpr.Flag.FixPoint = YES;
			if(agContext==SCHEME_DECL &&
			   yyt->MPC_TernaryExpr.Toperand->MPC_Expr.Flag.FixPoint &&
			   !(yyt->MPC_TernaryExpr.Toperand->MPC_Expr.Type->Kind==kMPC_BasicType &&
			     yyt->MPC_TernaryExpr.Toperand->MPC_Expr.Type->MPC_BasicType.TypeConstructor==DOUBLE))
			  yyt->MPC_TernaryExpr.Flag.FixPoint = YES;

			REMAKE_IF_BLOCKING(&yyt->MPC_TernaryExpr.Foperand);
			REMAKE_IF_BLOCKING(&yyt->MPC_TernaryExpr.Soperand);
			REMAKE_IF_BLOCKING(&yyt->MPC_TernaryExpr.Toperand);
		    
yyVisit1 (yyt->MPC_TernaryExpr.Type);
 yyt->MPC_TernaryExpr.Flag.Peculiarity = (yyt->MPC_TernaryExpr.Foperand->MPC_Expr.Flag.Peculiarity ||
					      yyt->MPC_TernaryExpr.Soperand->MPC_Expr.Flag.Peculiarity ||
					      yyt->MPC_TernaryExpr.Toperand->MPC_Expr.Flag.Peculiarity) ? _INH_ : _NO_; ;
 yyt->MPC_TernaryExpr.Flag.SideEffects = yyt->MPC_TernaryExpr.Foperand->MPC_Expr.Flag.SideEffects ||
					     yyt->MPC_TernaryExpr.Soperand->MPC_Expr.Flag.SideEffects ||
					     yyt->MPC_TernaryExpr.Toperand->MPC_Expr.Flag.SideEffects; ;
 yyt->MPC_TernaryExpr.Flag.DistrComma = yyt->MPC_TernaryExpr.Foperand->MPC_Expr.Flag.DistrComma ||
					      yyt->MPC_TernaryExpr.Soperand->MPC_Expr.Flag.DistrComma ||
					      yyt->MPC_TernaryExpr.Toperand->MPC_Expr.Flag.DistrComma; ;
/* line 1015 "../../../../HeteroMPI/mpC/front/mpc.ag" */


                          if(yyt->MPC_TernaryExpr.StoreNet!=NoTree && yyt->MPC_TernaryExpr.EvalNet!=NoTree) 
                            return;  

			  if(yyt->MPC_TernaryExpr.Flag.Ignore) return;
			  if(!(yyt->MPC_TernaryExpr.Foperand->MPC_Expr.StoreNet==yyt->MPC_TernaryExpr.Soperand->MPC_Expr.StoreNet &&
			       yyt->MPC_TernaryExpr.Soperand->MPC_Expr.StoreNet==yyt->MPC_TernaryExpr.Toperand->MPC_Expr.StoreNet  ||
			       yyt->MPC_TernaryExpr.Foperand->MPC_Expr.StoreNet==yyt->MPC_TernaryExpr.Soperand->MPC_Expr.StoreNet &&
				 yyt->MPC_TernaryExpr.Toperand->MPC_Expr.StoreNet==CONST_NET  ||
			       yyt->MPC_TernaryExpr.Foperand->MPC_Expr.StoreNet==yyt->MPC_TernaryExpr.Toperand->MPC_Expr.StoreNet &&
				 yyt->MPC_TernaryExpr.Soperand->MPC_Expr.StoreNet==CONST_NET  ||
			       yyt->MPC_TernaryExpr.Soperand->MPC_Expr.StoreNet==yyt->MPC_TernaryExpr.Toperand->MPC_Expr.StoreNet &&
				 yyt->MPC_TernaryExpr.Foperand->MPC_Expr.StoreNet==CONST_NET  ||
			       yyt->MPC_TernaryExpr.Foperand->MPC_Expr.StoreNet==CONST_NET && yyt->MPC_TernaryExpr.Soperand->MPC_Expr.StoreNet==CONST_NET ||
			       yyt->MPC_TernaryExpr.Foperand->MPC_Expr.StoreNet==CONST_NET && yyt->MPC_TernaryExpr.Toperand->MPC_Expr.StoreNet==CONST_NET ||
			       yyt->MPC_TernaryExpr.Soperand->MPC_Expr.StoreNet==CONST_NET && yyt->MPC_TernaryExpr.Toperand->MPC_Expr.StoreNet==CONST_NET)) {
			    yyt->MPC_TernaryExpr.Flag.Ignore = YES;
			    Make_Message(293 , xxError, yyt->MPC_TernaryExpr.Pos, SELF);
		
			  }
			  else {
			    if(yyt->MPC_TernaryExpr.Foperand->MPC_Expr.StoreNet!=CONST_NET) yyt->MPC_TernaryExpr.StoreNet = yyt->MPC_TernaryExpr.Foperand->MPC_Expr.StoreNet;
			    else if(yyt->MPC_TernaryExpr.Soperand->MPC_Expr.StoreNet!=CONST_NET) yyt->MPC_TernaryExpr.StoreNet = yyt->MPC_TernaryExpr.Soperand->MPC_Expr.StoreNet;
			    else yyt->MPC_TernaryExpr.StoreNet = yyt->MPC_TernaryExpr.Toperand->MPC_Expr.StoreNet;
			    yyt->MPC_TernaryExpr.EvalNet = Join_NetList(
					yyt->MPC_TernaryExpr.Foperand->MPC_Expr.EvalNet,
					Join_NetList(yyt->MPC_TernaryExpr.Soperand->MPC_Expr.EvalNet, yyt->MPC_TernaryExpr.Toperand->MPC_Expr.EvalNet)
				      );
			    if(yyt->MPC_TernaryExpr.Foperand->MPC_Expr.Flag.Distributed ||
			       yyt->MPC_TernaryExpr.Soperand->MPC_Expr.Flag.Distributed ||
			       yyt->MPC_TernaryExpr.Toperand->MPC_Expr.Flag.Distributed) yyt->MPC_TernaryExpr.Flag.Distributed = YES;
			    if(yyt->MPC_TernaryExpr.Foperand->MPC_Expr.Flag.Asynchr &&
			       yyt->MPC_TernaryExpr.Soperand->MPC_Expr.Flag.Asynchr &&
			       yyt->MPC_TernaryExpr.Toperand->MPC_Expr.Flag.Asynchr) yyt->MPC_TernaryExpr.Flag.Asynchr = YES;
			    yyt->MPC_TernaryExpr.Repl = yyt->MPC_TernaryExpr.Soperand->MPC_Expr.Repl && yyt->MPC_TernaryExpr.Toperand->MPC_Expr.Repl;
			  }
			
break;

case kMPC_QuaternaryExpr:
/* line 411 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			Undeclared_Ident_Possible = false;
			if(yyt->MPC_QuaternaryExpr.Operand1->MPC_Expr.Flag.Ignore  ||
                           yyt->MPC_QuaternaryExpr.Operand2!=NoTree &&
			     yyt->MPC_QuaternaryExpr.Operand2->Kind!=kMPC_FreeNode &&
			     yyt->MPC_QuaternaryExpr.Operand2->MPC_Expr.Flag.Ignore  ||
			   yyt->MPC_QuaternaryExpr.Operand3!=NoTree &&
			     yyt->MPC_QuaternaryExpr.Operand3->Kind!=kMPC_FreeNode &&
			     yyt->MPC_QuaternaryExpr.Operand3->MPC_Expr.Flag.Ignore  ||
			   yyt->MPC_QuaternaryExpr.Operand4!=NoTree &&
			     yyt->MPC_QuaternaryExpr.Operand4->Kind!=kMPC_FreeNode &&
			     yyt->MPC_QuaternaryExpr.Operand4->MPC_Expr.Flag.Ignore) {
			  SET_ERROR_TYPE;
			  yyt->MPC_QuaternaryExpr.Flag.Ignore = YES;
			  return;
			}
			else
			  yyt->MPC_QuaternaryExpr.Flag.Ignore = Check_Expression(SELF);
		     
if(yyt->MPC_QuaternaryExpr.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

yyVisit1 (yyt->MPC_QuaternaryExpr.Operand4);
yyVisit1 (yyt->MPC_QuaternaryExpr.Operand3);
yyVisit1 (yyt->MPC_QuaternaryExpr.Operand2);
yyVisit1 (yyt->MPC_QuaternaryExpr.Operand1);
/* line 1500 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			yyt->MPC_QuaternaryExpr.Flag.Ignore |=
				yyt->MPC_QuaternaryExpr.Operand1->MPC_Expr.Flag.Ignore ||
				yyt->MPC_QuaternaryExpr.Operand2->Kind!=kMPC_FreeNode &&
						yyt->MPC_QuaternaryExpr.Operand2->MPC_Expr.Flag.Ignore ||
				yyt->MPC_QuaternaryExpr.Operand3->Kind!=kMPC_FreeNode &&
						yyt->MPC_QuaternaryExpr.Operand3->MPC_Expr.Flag.Ignore ||
				yyt->MPC_QuaternaryExpr.Operand4->Kind!=kMPC_FreeNode &&
						yyt->MPC_QuaternaryExpr.Operand4->MPC_Expr.Flag.Ignore;
			if(yyt->MPC_QuaternaryExpr.Flag.Ignore) { SET_ERROR_TYPE; return; }
			if(yyt->MPC_QuaternaryExpr.OpCode==GRID)
			  Eval_TypeOfGridExpr(SELF);   
                        else {  
                          Make_Message(44, xxRestriction, yyt->MPC_QuaternaryExpr.Pos, SELF);
                          yyt->MPC_QuaternaryExpr.Flag.Ignore = YES;
                        }
			if(yyt->MPC_QuaternaryExpr.Flag.Ignore) { SET_ERROR_TYPE; return; }

			if(agContext==SCHEME_DECL &&
			   yyt->MPC_QuaternaryExpr.Operand1->MPC_Expr.Flag.FixPoint &&
			   !(yyt->MPC_QuaternaryExpr.Operand1->MPC_Expr.Type->Kind==kMPC_BasicType &&
			     yyt->MPC_QuaternaryExpr.Operand1->MPC_Expr.Type->MPC_BasicType.TypeConstructor==DOUBLE))
			  yyt->MPC_QuaternaryExpr.Flag.FixPoint = YES;
			if(agContext==SCHEME_DECL &&
			   yyt->MPC_QuaternaryExpr.Operand2->MPC_Expr.Flag.FixPoint &&
			   !(yyt->MPC_QuaternaryExpr.Operand2->MPC_Expr.Type->Kind==kMPC_BasicType &&
			     yyt->MPC_QuaternaryExpr.Operand2->MPC_Expr.Type->MPC_BasicType.TypeConstructor==DOUBLE))
			  yyt->MPC_QuaternaryExpr.Flag.FixPoint = YES;
			if(agContext==SCHEME_DECL &&
			   yyt->MPC_QuaternaryExpr.Operand3->MPC_Expr.Flag.FixPoint &&
			   !(yyt->MPC_QuaternaryExpr.Operand3->MPC_Expr.Type->Kind==kMPC_BasicType &&
			     yyt->MPC_QuaternaryExpr.Operand3->MPC_Expr.Type->MPC_BasicType.TypeConstructor==DOUBLE))
			  yyt->MPC_QuaternaryExpr.Flag.FixPoint = YES;
			if(agContext==SCHEME_DECL &&
			   yyt->MPC_QuaternaryExpr.Operand4->MPC_Expr.Flag.FixPoint &&
			   !(yyt->MPC_QuaternaryExpr.Operand4->MPC_Expr.Type->Kind==kMPC_BasicType &&
			     yyt->MPC_QuaternaryExpr.Operand4->MPC_Expr.Type->MPC_BasicType.TypeConstructor==DOUBLE))
			  yyt->MPC_QuaternaryExpr.Flag.FixPoint = YES;

			REMAKE_IF_BLOCKING(&yyt->MPC_QuaternaryExpr.Operand1);
			REMAKE_IF_BLOCKING(&yyt->MPC_QuaternaryExpr.Operand2);
			REMAKE_IF_BLOCKING(&yyt->MPC_QuaternaryExpr.Operand3);
			REMAKE_IF_BLOCKING(&yyt->MPC_QuaternaryExpr.Operand4);
		    
yyVisit1 (yyt->MPC_QuaternaryExpr.Type);
 yyt->MPC_QuaternaryExpr.Flag.Peculiarity = (yyt->MPC_QuaternaryExpr.Operand1->MPC_Expr.Flag.Peculiarity ||
					         yyt->MPC_QuaternaryExpr.Operand2->MPC_Expr.Flag.Peculiarity  ||
					         yyt->MPC_QuaternaryExpr.Operand3->MPC_Expr.Flag.Peculiarity  ||
					         yyt->MPC_QuaternaryExpr.Operand4->MPC_Expr.Flag.Peculiarity) ?
								 _INH_ : _NO_;
			     if(yyt->MPC_QuaternaryExpr.OpCode==GRID) {
			       yyt->MPC_QuaternaryExpr.Flag.Peculiarity += _SRC_;
			       NET_ARG_LIST_DIAGNOSTIC(SELF);
			       if(agContext==PREDICATE) {
			         yyt->MPC_QuaternaryExpr.Flag.Ignore = YES;
			         Make_Message(324, xxError, yyt->MPC_QuaternaryExpr.Pos, SELF);
					      
			       }
			     }
		 ;
 yyt->MPC_QuaternaryExpr.Flag.SideEffects = yyt->MPC_QuaternaryExpr.Operand1->MPC_Expr.Flag.SideEffects ||
					     (yyt->MPC_QuaternaryExpr.Operand2->Kind==kMPC_FreeNode ? 0 : yyt->MPC_QuaternaryExpr.Operand2->MPC_Expr.Flag.SideEffects) ||
					     (yyt->MPC_QuaternaryExpr.Operand3->Kind==kMPC_FreeNode ? 0 : yyt->MPC_QuaternaryExpr.Operand3->MPC_Expr.Flag.SideEffects) ||
					     (yyt->MPC_QuaternaryExpr.Operand4->Kind==kMPC_FreeNode ? 0 : yyt->MPC_QuaternaryExpr.Operand4->MPC_Expr.Flag.SideEffects); ;
 yyt->MPC_QuaternaryExpr.Flag.DistrComma = yyt->MPC_QuaternaryExpr.Operand1->MPC_Expr.Flag.DistrComma ||
					         yyt->MPC_QuaternaryExpr.Operand2->MPC_Expr.Flag.DistrComma  ||
					         yyt->MPC_QuaternaryExpr.Operand3->MPC_Expr.Flag.DistrComma  ||
					         yyt->MPC_QuaternaryExpr.Operand4->MPC_Expr.Flag.DistrComma;
		 ;
/* line 1056 "../../../../HeteroMPI/mpC/front/mpc.ag" */


                          if(yyt->MPC_QuaternaryExpr.StoreNet!=NoTree && yyt->MPC_QuaternaryExpr.EvalNet!=NoTree) 
                            return;  

			  if(yyt->MPC_QuaternaryExpr.Flag.Ignore) return;
			  if(yyt->MPC_QuaternaryExpr.OpCode==GRID) {
			    if(yyt->MPC_QuaternaryExpr.Operand2->Kind!=kMPC_FreeNode &&
			       !(yyt->MPC_QuaternaryExpr.Operand2->MPC_Expr.StoreNet==yyt->MPC_QuaternaryExpr.Operand1->MPC_Expr.StoreNet ||
                                 yyt->MPC_QuaternaryExpr.Operand2->MPC_Expr.StoreNet==CONST_NET)) {
			      yyt->MPC_QuaternaryExpr.Flag.Ignore = YES;
			      Make_Message(294, xxError, yyt->MPC_QuaternaryExpr.Pos, SELF);
		
			    }
			    if(yyt->MPC_QuaternaryExpr.Operand3->Kind!=kMPC_FreeNode &&
			       !(yyt->MPC_QuaternaryExpr.Operand3->MPC_Expr.StoreNet==yyt->MPC_QuaternaryExpr.Operand1->MPC_Expr.StoreNet ||
                                 yyt->MPC_QuaternaryExpr.Operand3->MPC_Expr.StoreNet==CONST_NET)) {
			      yyt->MPC_QuaternaryExpr.Flag.Ignore = YES;
			      Make_Message(294, xxError, yyt->MPC_QuaternaryExpr.Pos, SELF);
		
			    }
			    if(yyt->MPC_QuaternaryExpr.Operand4->Kind!=kMPC_FreeNode &&
			       !(yyt->MPC_QuaternaryExpr.Operand4->MPC_Expr.StoreNet==yyt->MPC_QuaternaryExpr.Operand1->MPC_Expr.StoreNet ||
                                 yyt->MPC_QuaternaryExpr.Operand4->MPC_Expr.StoreNet==CONST_NET)) {
			      yyt->MPC_QuaternaryExpr.Flag.Ignore = YES;
			      Make_Message(294, xxError, yyt->MPC_QuaternaryExpr.Pos, SELF);
		
			    }
			    yyt->MPC_QuaternaryExpr.Flag.Distributed = yyt->MPC_QuaternaryExpr.Operand1->MPC_Expr.Flag.Distributed;
			    yyt->MPC_QuaternaryExpr.Flag.Asynchr = yyt->MPC_QuaternaryExpr.Operand1->MPC_Expr.Flag.Asynchr;
			    yyt->MPC_QuaternaryExpr.Flag.PartAsynchr = yyt->MPC_QuaternaryExpr.Operand1->MPC_Expr.Flag.PartAsynchr;
			    yyt->MPC_QuaternaryExpr.StoreNet = yyt->MPC_QuaternaryExpr.Operand1->MPC_Expr.StoreNet;
			    yyt->MPC_QuaternaryExpr.EvalNet  = yyt->MPC_QuaternaryExpr.Operand1->MPC_Expr.EvalNet;
			    yyt->MPC_QuaternaryExpr.Repl = yyt->MPC_QuaternaryExpr.Operand1->MPC_Expr.Repl;
			    if(yyt->MPC_QuaternaryExpr.Operand2->Kind!=kMPC_FreeNode) yyt->MPC_QuaternaryExpr.Repl &= yyt->MPC_QuaternaryExpr.Operand2->MPC_Expr.Repl;
			    if(yyt->MPC_QuaternaryExpr.Operand3->Kind!=kMPC_FreeNode) yyt->MPC_QuaternaryExpr.Repl &= yyt->MPC_QuaternaryExpr.Operand3->MPC_Expr.Repl;
			    if(yyt->MPC_QuaternaryExpr.Operand4->Kind!=kMPC_FreeNode) yyt->MPC_QuaternaryExpr.Repl &= yyt->MPC_QuaternaryExpr.Operand4->MPC_Expr.Repl;
			  }
                          else {  
                            yyt->MPC_QuaternaryExpr.StoreNet = ErrorNet;
                            yyt->MPC_QuaternaryExpr.EvalNet  = ErrorNetList;
                            yyt->MPC_QuaternaryExpr.Flag.Ignore = YES;  
                          }
			
break;

case kMPC_CallExpr:
/* line 431 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			Undeclared_Ident_Possible = true;
			if(yyt->MPC_CallExpr.Function->MPC_Expr.Flag.Ignore) {
			  SET_ERROR_TYPE;
			  yyt->MPC_CallExpr.Flag.Ignore = YES;
			  return;
			}
			if(!SELF->MPC_CallExpr.NetworkArgList)
			  SELF->MPC_CallExpr.NetworkArgList = mMPC_FreeNode(SELF);
			if(!SELF->MPC_CallExpr.ArgList)
			  SELF->MPC_CallExpr.ArgList = mMPC_FreeNode(SELF);

#ifndef __CB_COMPILER__
			if(DEMO_MODE) {
			  tTree func = yyt->MPC_CallExpr.Function;
			  while(func->Kind==kMPC_NetCastExpr)
			    func = func->MPC_NetCastExpr.Operand;
			  if(!(func->Kind==kMPC_Ident &&
			       WL_Contains(func->MPC_Ident.Ident))) {
			    SET_ERROR_TYPE;
			    yyt->MPC_CallExpr.Flag.Ignore = YES;
			    Make_Message(27, xxError, yyt->MPC_CallExpr.Pos, SELF);
		
			  }
			  else if(func->Kind==kMPC_Ident &&
				  WL_Contains(func->MPC_Ident.Ident) &&
				  func->MPC_Ident.Store!=NoTree &&
				  func->MPC_Ident.Store->
					MPC_Var.Type->Kind!=kMPC_FunctionType) {
			    SET_ERROR_TYPE;
			    yyt->MPC_CallExpr.Flag.Ignore = YES;
			    Make_Message(27, xxError, yyt->MPC_CallExpr.Pos, SELF);
		
			  }
			}
#endif
		  
if(yyt->MPC_CallExpr.Flag.Ignore) return;  ;
/* line 196 "../../../../HeteroMPI/mpC/front/mpc.ag" */

yyVisit1 (yyt->MPC_CallExpr.Function);
yyVisit1 (yyt->MPC_CallExpr.ArgList);
yyVisit1 (yyt->MPC_CallExpr.NetworkArgList);
/* line 1546 "../../../../HeteroMPI/mpC/front/mpc.ag" */

			if(yyt->MPC_CallExpr.Function->MPC_Expr.Flag.Ignore) { SET_ERROR_TYPE; yyt->MPC_CallExpr.Flag.Ignore = YES; return; }

			Push_PurePattern(yyt->MPC_CallExpr.Function->MPC_Expr.Type);
			op1_type = Make_Type();

			if(!(op1_type->Kind==kMPC_FunctionType  ||
			     op1_type->Kind==kMPC_PointerType &&
				op1_type->MPC_PointerType.
					ElementType->Kind==kMPC_FunctionType)) {
			  SET_ERROR_TYPE;
			  yyt->MPC_CallExpr.Function->MPC_Expr.Flag.Ignore = YES;
			  Make_Message(308, xxError, yyt->MPC_CallExpr.Function->MPC_Expr.Pos, SELF);
		
			}
			yyt->MPC_CallExpr.Flag.Ignore |= yyt->MPC_CallExpr.Function->MPC_Expr.Flag.Ignore;
			if(yyt->MPC_CallExpr.Flag.Ignore) {
			  SET_ERROR_TYPE;
			  return;
			}
			else {
			  tTree ftype;
			  tTree par_declaration;
			  ftype = op1_type;
			  if(ftype->Kind==kMPC_PointerType)
			    ftype = ftype->MPC_PointerType.ElementType;
			  Push_PurePattern(ftype->MPC_FunctionType.ResultType);
			  yyt->MPC_CallExpr.Type = Make_Type();
			  if(ftype->MPC_FunctionType.NumberOfComponents>0 &&
			     yyt->MPC_CallExpr.ArgList->Kind!=kMPC_FreeNode) { 
			    tTree par, par_var, arg;
			    par = ftype->MPC_FunctionType.ParamList;
			    arg = yyt->MPC_CallExpr.ArgList;
			    while(par->Kind!=kMPC_FreeNode &&
				  arg->Kind!=kMPC_FreeNode) {
			      if(par->Kind==kMPC_Ellipsis) break;
			      par_declaration = par_var = par;
			      if(par_var->Kind==kMPC_VarDecl)
				par_var = par_var->MPC_VarDecl.Var;
			      if(par->MPC_VarDecl.Var!=NoTree &&
				 par->MPC_VarDecl.Var->Kind==kMPC_Var)
				par_declaration = par->MPC_VarDecl.Var;
			      yyt->MPC_CallExpr.Flag.Ignore |= Check_ArgumentType(ARG_LIST,
						par_declaration, arg->MPC_Exprs.Expr
					     );
			      if(agContext==SCHEME_DECL &&
				 arg->MPC_Exprs.Expr->MPC_Expr.Flag.FixPoint &&
				 !(arg->MPC_Exprs.Expr->MPC_Expr.Type->Kind==kMPC_BasicType &&
				   arg->MPC_Exprs.Expr->MPC_Expr.Type->
					MPC_BasicType.TypeConstructor==DOUBLE)) {
				yyt->MPC_CallExpr.Flag.Ignore = YES;
				Make_Message(475, xxError, arg->MPC_Expr.Pos, SELF);
		
			      }
			      if(par_var!=NoTree && par_var->Kind==kMPC_Var &&
				 par_var->MPC_Var.Distribution!=SINGLE_NODE  &&
				 par_var->MPC_Var.Distribution->Kind==kMPC_Net &&
				 par_var->MPC_Var.Distribution->MPC_Net.Topology!=PARAMETER &&
				 par_var->MPC_Var.Distribution!=
					arg->MPC_Exprs.Expr->MPC_Expr.StoreNet &&
				 arg->MPC_Exprs.Expr->MPC_Expr.StoreNet!=CONST_NET) {
				tPosition par_pos;
				par_pos = RealPosition(par_var->MPC_Var.Pos);
				SET_ERROR_TYPE;
				yyt->MPC_CallExpr.Flag.Ignore = YES;
				Make_Message(309, xxError, arg->MPC_Expr.Pos, SELF);
		
				Make_MessageI(15, xxInformation, SourcePosition(arg->MPC_Expr.Pos,arg),
					      xxString, SourceFile(par_var->MPC_Var.Pos), par);
		
				Make_MessageI(16, xxInformation, SourcePosition(arg->MPC_Expr.Pos,arg),
					      xxShort, (char *)&(par_pos.Line), par);
		
			      }
			      REMAKE_IF_BLOCKING(&(arg->MPC_Exprs.Expr));
			      par = par->MPC_Decls.Next;
			      arg = arg->MPC_Exprs.Next;
			    } 
			    if(par->Kind==kMPC_FreeNode && arg->Kind!=kMPC_FreeNode) {
			      SET_ERROR_TYPE;
			      yyt->MPC_CallExpr.Flag.Ignore = YES;
			      Make_Message(310, xxError, arg->MPC_Exprs.Pos, SELF);
		
			    }
			    if(par->Kind!=kMPC_FreeNode && par->Kind!=kMPC_Ellipsis &&
			       arg->Kind==kMPC_FreeNode) {
			      SET_ERROR_TYPE;
			      yyt->MPC_CallExpr.Flag.Ignore = YES;
			      Make_Message(311, xxError, yyt->MPC_CallExpr.Pos, SELF);
		
			    }
			  }
			  else if(ftype->MPC_FunctionType.NumberOfComponents==0 &&
				  yyt->MPC_CallExpr.ArgList->Kind!=kMPC_FreeNode) {
			    SET_ERROR_TYPE;
			    yyt->MPC_CallExpr.Flag.Ignore = YES;
			    Make_Message(310, xxError, yyt->MPC_CallExpr.ArgList->MPC_Exprs.Pos, SELF);
		
			  }
			  else if(ftype->MPC_FunctionType.NumberOfComponents>0 &&
				  yyt->MPC_CallExpr.ArgList->Kind==kMPC_FreeNode) {
			    SET_ERROR_TYPE;
			    yyt->MPC_CallExpr.Flag.Ignore = YES;
			    Make_Message(312, xxError, yyt->MPC_CallExpr.Function->MPC_Expr.Pos, SELF);
		
			  }
			}
		    
yyVisit1 (yyt->MPC_CallExpr.Type);

			
			
#ifdef MPC_DEBUGGER
                        if(DBG_CODE)
                          yyt->MPC_CallExpr.Flag.Peculiarity = _SRC_;
                        else
#endif
                          {
			    yyt->MPC_CallExpr.Flag.Peculiarity = yyt->MPC_CallExpr.Function->MPC_Expr.Flag.Peculiarity ? _INH_ : _NO_;
			    {
			      tTree arg;
			      arg = yyt->MPC_CallExpr.ArgList;
			      while(arg!=NoTree && arg->Kind==kMPC_Exprs && !yyt->MPC_CallExpr.Flag.Peculiarity) {
			        yyt->MPC_CallExpr.Flag.Peculiarity =
				  arg->MPC_Exprs.Expr->MPC_Expr.Flag.Peculiarity ?
				  _INH_ : yyt->MPC_CallExpr.Flag.Peculiarity;
			        arg = arg->MPC_Exprs.Next;
			      }
			    }
                          }
			
		  ;

		    yyt->MPC_CallExpr.Flag.SideEffects = _SRC_;
		    if(agContext==PREDICATE) {
		      yyt->MPC_CallExpr.Flag.Ignore = YES;
		      Make_Message(323, xxError, yyt->MPC_CallExpr.Pos, SELF);
				   
		    }
		  ;

			yyt->MPC_CallExpr.Flag.DistrComma = yyt->MPC_CallExpr.Function->MPC_Expr.Flag.DistrComma;
			{
			  tTree arg;
			  arg = yyt->MPC_CallExpr.ArgList;
			  while(arg!=NoTree && arg->Kind==kMPC_Exprs && !yyt->MPC_CallExpr.Flag.DistrComma) {
			    yyt->MPC_CallExpr.Flag.DistrComma |=
				arg->MPC_Exprs.Expr->MPC_Expr.Flag.DistrComma;
			    arg = arg->MPC_Exprs.Next;
			  }
			}
		  ;
/* line 197 "../../../../HeteroMPI/mpC/front/mpc.ag" */

/* line 1103 "../../../../HeteroMPI/mpC/front/mpc.ag" */


                          if(yyt->MPC_CallExpr.StoreNet!=NoTree && yyt->MPC_CallExpr.EvalNet!=NoTree) 
                            return;  

			  if(yyt->MPC_CallExpr.Flag.Ignore) return;
			  SELF->MPC_Expr.Repl = yyt->MPC_CallExpr.Function->MPC_Expr.Repl;
			  if(yyt->MPC_CallExpr.Function->MPC_Expr.Type->MPC_Type.Flag.Basic) { 
			    yyt->MPC_CallExpr.Flag.Distributed = YES;
			    if(agFKind==NODAL || agFKind==NETWORK) {
			      yyt->MPC_CallExpr.Flag.Ignore = YES;
			      Make_Message(295, xxError, yyt->MPC_CallExpr.Pos, SELF);
		
			    }
			    if(
			       yyt->MPC_CallExpr.Function->MPC_Expr.StoreNet!=COMPUTING_SPACE) {
			      yyt->MPC_CallExpr.Flag.Ignore = YES;
			      Make_Message(296, xxError, yyt->MPC_CallExpr.Function->MPC_Expr.Pos, SELF);
		
			    }
			    if(yyt->MPC_CallExpr.NetworkArgList->Kind!=kMPC_FreeNode) {
			      yyt->MPC_CallExpr.Flag.Ignore = YES;
			      Make_Message(297, xxError, yyt->MPC_CallExpr.NetworkArgList->MPC_Exprs.Pos, SELF);
		
			    }
			    if(yyt->MPC_CallExpr.ArgList->Kind!=kMPC_FreeNode) { 
			      tTree arg;
			      arg = yyt->MPC_CallExpr.ArgList;
			      while(arg->Kind==kMPC_Exprs) {
				if(!(arg->MPC_Exprs.Expr->MPC_Expr.StoreNet==HOST ||
				    arg->MPC_Exprs.Expr->MPC_Expr.StoreNet==CONST_NET ||
				    arg->MPC_Exprs.Expr->MPC_Expr.StoreNet==COMPUTING_SPACE)){
				  yyt->MPC_CallExpr.Flag.Ignore = YES;
				  Make_Message(298, xxError, arg->MPC_Exprs.Pos, arg);
		
				}
				
				arg = arg->MPC_Exprs.Next;
			      }
			    }
			    SELF->MPC_Expr.Repl = true;
			    yyt->MPC_CallExpr.StoreNet = COMPUTING_SPACE; 
			    yyt->MPC_CallExpr.EvalNet = COMPUTING_SPACE_LIST;
			  }
			  else if(yyt->MPC_CallExpr.Function->MPC_Expr.Type->MPC_Type.Flag.Nodal) { 
			    yyt->MPC_CallExpr.Flag.Distributed = yyt->MPC_CallExpr.Function->MPC_Expr.Flag.Distributed; 
			    yyt->MPC_CallExpr.Flag.Asynchr = yyt->MPC_CallExpr.Function->MPC_Expr.Flag.Asynchr;
			    yyt->MPC_CallExpr.EvalNet = yyt->MPC_CallExpr.Function->MPC_Expr.EvalNet;   
			    if(yyt->MPC_CallExpr.ArgList->Kind!=kMPC_FreeNode) { 
			      tTree arg;
			      arg = yyt->MPC_CallExpr.ArgList;
			      while(arg->Kind==kMPC_Exprs) {
				if(arg->MPC_Exprs.Expr->MPC_Expr.
				   StoreNet!=yyt->MPC_CallExpr.Function->MPC_Expr.StoreNet &&
				   !Is_Equal_Net(arg->MPC_Exprs.Expr->MPC_Expr.StoreNet,
						 yyt->MPC_CallExpr.Function->MPC_Expr.StoreNet) &&
				   arg->MPC_Exprs.Expr->MPC_Expr.
				   StoreNet!=CONST_NET &&
				   arg->MPC_Exprs.Expr->MPC_Expr.
				   StoreNet!=SINGLE_NODE) {
				  yyt->MPC_CallExpr.Flag.Ignore = YES;
				  Make_Message(300, xxError, arg->MPC_Exprs.Pos, SELF);
		
				}
				if(!arg->MPC_Exprs.Expr->MPC_Expr.Flag.Asynchr)
				  yyt->MPC_CallExpr.Flag.Asynchr = NO;
				yyt->MPC_CallExpr.EvalNet = Join_NetList(yyt->MPC_CallExpr.EvalNet,
						       arg->MPC_Exprs.Expr->MPC_Expr.EvalNet);
				arg = arg->MPC_Exprs.Next;
			      }
			    }
			    if(yyt->MPC_CallExpr.NetworkArgList->Kind!=kMPC_FreeNode) {
			      yyt->MPC_CallExpr.Flag.Ignore = YES;
			      Make_Message(301, xxError, yyt->MPC_CallExpr.NetworkArgList->MPC_Exprs.Pos, SELF);
		
			    }
			    yyt->MPC_CallExpr.StoreNet = yyt->MPC_CallExpr.Function->MPC_Expr.StoreNet; 
		 
			    
			  }
			  else if(yyt->MPC_CallExpr.Function->MPC_Expr.Type->MPC_Type.Flag.Network) { 
			    if(yyt->MPC_CallExpr.Function->MPC_Expr.StoreNet->MPC_NetOrSubnet.SingleNode)
			      yyt->MPC_CallExpr.Flag.Distributed = NO;
			    else
			      yyt->MPC_CallExpr.Flag.Distributed = YES;

			    
			    if(!yyt->MPC_CallExpr.StoreNet)
			      if(yyt->MPC_CallExpr.Function->MPC_Expr.Type->MPC_FunctionType.NetParam->Kind==kMPC_Net &&
				 yyt->MPC_CallExpr.Function->MPC_Expr.Type->MPC_FunctionType.NetParam->
				 MPC_Net.Topology==PARAMETER) {
				Make_Message(302, xxError, yyt->MPC_CallExpr.Function->MPC_Expr.Pos, SELF
		
				);
				yyt->MPC_CallExpr.Flag.Ignore = YES;
				return; 
			      }
			      else  
			        yyt->MPC_CallExpr.StoreNet = yyt->MPC_CallExpr.Function->MPC_Expr.Type->MPC_FunctionType.NetParam;
			    
			    if(yyt->MPC_CallExpr.Function->Kind==kMPC_Ident &&
			       yyt->MPC_CallExpr.Function->MPC_Expr.Type->Kind==kMPC_FunctionType) { 
			      tTree tmp;
			      tmp = nMPC_FreeNode();
			      yyt->MPC_CallExpr.Function->MPC_Expr.StoreNet = yyt->MPC_CallExpr.StoreNet;
			      yyt->MPC_CallExpr.Function->MPC_Expr.EvalNet = yyt->MPC_CallExpr.EvalNet = 
						 Clean_OutAttributes(
							mMPC_NetList(tmp,tmp,yyt->MPC_CallExpr.StoreNet)
						 );
			    }
			    else
			      yyt->MPC_CallExpr.EvalNet = yyt->MPC_CallExpr.Function->MPC_Expr.EvalNet;

			    if(yyt->MPC_CallExpr.Function->MPC_Expr.Type->Kind==kMPC_PointerType &&
			       !Is_Subnet(yyt->MPC_CallExpr.StoreNet,yyt->MPC_CallExpr.Function->MPC_Expr.StoreNet)) {
			      yyt->MPC_CallExpr.Flag.Ignore = YES;
			      Make_Message(303, xxError, yyt->MPC_CallExpr.Function->MPC_Expr.Pos, SELF);
		
			    }
			    if(yyt->MPC_CallExpr.StoreNet->Kind==kMPC_Subnet && yyt->MPC_CallExpr.StoreNet->MPC_Subnet.Flexible &&
                               yyt->MPC_CallExpr.StoreNet->MPC_Subnet.Ident==NoIdent) {
			      yyt->MPC_CallExpr.Flag.Ignore = YES;
			      Make_Message(304, xxError, yyt->MPC_CallExpr.Pos, SELF);
		
			    }
			    if(yyt->MPC_CallExpr.Function->MPC_Expr.Type->Kind==kMPC_FunctionType) {
			      Check_NetworkArgs(SELF);  
			    }
			    if(yyt->MPC_CallExpr.ArgList->Kind!=kMPC_FreeNode) { 
			      tTree arg;
			      arg = yyt->MPC_CallExpr.ArgList;
			      while(arg->Kind==kMPC_Exprs) {
				if(arg->MPC_Exprs.Expr->MPC_Expr.
				   StoreNet!=yyt->MPC_CallExpr.StoreNet &&
				   arg->MPC_Exprs.Expr->MPC_Expr.
				   StoreNet!=CONST_NET) {
				  yyt->MPC_CallExpr.Flag.Ignore = YES;
				  Make_Message(305, xxError, arg->MPC_Exprs.Pos, SELF);
		
				}
				arg = arg->MPC_Exprs.Next;
			      }
			    }
			    if(yyt->MPC_CallExpr.NetworkArgList->Kind!=kMPC_FreeNode) { 
			      tTree arg;
			      arg = yyt->MPC_CallExpr.NetworkArgList;
			      while(arg->Kind==kMPC_Exprs) {
				if(!(arg->MPC_Exprs.Expr->MPC_Expr.
				     StoreNet==yyt->MPC_CallExpr.StoreNet ||
				     arg->MPC_Exprs.Expr->MPC_Expr.
				     StoreNet==CONST_NET) ) {
				  yyt->MPC_CallExpr.Flag.Ignore = YES;
				  Make_Message(306, xxError, arg->MPC_Exprs.Pos, SELF);
		
				}
				if(!arg->MPC_Exprs.Expr->MPC_Expr.Repl &&
				   !(arg->MPC_Exprs.Expr->MPC_Expr.Type->Kind==kMPC_PointerType &&
				     arg->MPC_Exprs.Expr->MPC_Expr.Type->
					  MPC_PointerType.ElementType->MPC_Type.Flag.Repl)) {
				  yyt->MPC_CallExpr.Flag.Ignore = YES;
				  Make_Message(307, xxError, arg->MPC_Exprs.Pos, arg);
		
				}
				arg = arg->MPC_Exprs.Next;
			      }
			    }
			  }
			  else
			    CompilerError("Undefined kind of function in MPC_CallExpr", yyt->MPC_CallExpr.Pos);
			
break;

case kMPC_Type:
break;

case kMPC_BasicType:
break;

case kMPC_EnumType:
break;

case kMPC_Typedef:
yyVisit1 (yyt->MPC_Typedef.Type);
 SELF->MPC_Type.Flag.Ignore = yyt->MPC_Typedef.Type->MPC_Type.Flag.Ignore; ;
break;

case kMPC_DerivedType:
break;

case kMPC_ArrayType:
yyVisit1 (yyt->MPC_ArrayType.ArraySize);
yyVisit1 (yyt->MPC_ArrayType.ElementType);
yyVisit1 (yyt->MPC_ArrayType.DynStep);

			SELF->MPC_Type.Flag.Ignore = yyt->MPC_ArrayType.ElementType->MPC_Type.Flag.Ignore;
			if(yyt->MPC_ArrayType.ArraySize!=NoTree && yyt->MPC_ArrayType.ArraySize->Kind!=kMPC_FreeNode) {
			  SELF->MPC_Type.Flag.Ignore |= yyt->MPC_ArrayType.ArraySize->MPC_Expr.Flag.Ignore;
                          if(Is_ReplArray && !(yyt->MPC_ArrayType.ArraySize->MPC_Expr.Repl ||
                                               yyt->MPC_ArrayType.ArraySize->MPC_Expr.Type->MPC_Type.Flag.Repl))
                            Make_Message(500, xxError, yyt->MPC_ArrayType.ArraySize->MPC_Expr.Pos, SELF);
                                        
                        }
			if(yyt->MPC_ArrayType.DynStep!=NoTree && yyt->MPC_ArrayType.DynStep->Kind!=kMPC_FreeNode) {
			  SELF->MPC_Type.Flag.Ignore |= yyt->MPC_ArrayType.DynStep->MPC_Expr.Flag.Ignore;
                          if(Is_ReplArray && !yyt->MPC_ArrayType.DynStep->MPC_Expr.Type->MPC_Type.Flag.Repl)
                            Make_Message(501, xxError, yyt->MPC_ArrayType.DynStep->MPC_Expr.Pos, SELF);
                                      
                        }
		  ;
break;

case kMPC_VectorType:
break;

case kMPC_PointerType:
yyVisit1 (yyt->MPC_PointerType.DynStep);
yyVisit1 (yyt->MPC_PointerType.ElementType);

			SELF->MPC_Type.Flag.Ignore = yyt->MPC_PointerType.ElementType->MPC_Type.Flag.Ignore;
			if(yyt->MPC_PointerType.DynStep!=NoTree && yyt->MPC_PointerType.DynStep->Kind!=kMPC_FreeNode)
			  SELF->MPC_Type.Flag.Ignore |= yyt->MPC_PointerType.DynStep->MPC_Expr.Flag.Ignore;
		  ;
break;

case kMPC_SU_Type:

			
		        if(!Undefined_SU_Possible &&
		           SELF->MPC_SU_Type.MemberDecls==NoTree &&
		           SELF->MPC_SU_Type.EquivType==NoTree) {
		          SELF->MPC_Type.Flag.Ignore = YES;
		          Make_MessageI(504, xxError, SELF->MPC_SU_Type.Pos,
		                        xxIdent, (char*)&(SELF->MPC_SU_Type.SU_Tag), SELF);
		                   
		        }
		  ;
break;

case kMPC_StructType:

			
		        if(!Undefined_SU_Possible &&
		           SELF->MPC_SU_Type.MemberDecls==NoTree &&
		           SELF->MPC_SU_Type.EquivType==NoTree) {
		          SELF->MPC_Type.Flag.Ignore = YES;
		          Make_MessageI(504, xxError, SELF->MPC_SU_Type.Pos,
		                        xxIdent, (char*)&(SELF->MPC_SU_Type.SU_Tag), SELF);
		                   
		        }
		  ;
break;

case kMPC_UnionType:

			
		        if(!Undefined_SU_Possible &&
		           SELF->MPC_SU_Type.MemberDecls==NoTree &&
		           SELF->MPC_SU_Type.EquivType==NoTree) {
		          SELF->MPC_Type.Flag.Ignore = YES;
		          Make_MessageI(504, xxError, SELF->MPC_SU_Type.Pos,
		                        xxIdent, (char*)&(SELF->MPC_SU_Type.SU_Tag), SELF);
		                   
		        }
		  ;
break;

case kMPC_FunctionType:
yyVisit1 (yyt->MPC_FunctionType.NetworkParamList);
 Current_FunctionType = SELF; ;
break;

case kMPC_Var:
yyVisit1 (yyt->MPC_Var.Next);
yyVisit1 (yyt->MPC_Var.Type);
break;

case kMPC_Exprs:
 Undeclared_Ident_Possible = false; ;
yyVisit1 (yyt->MPC_Exprs.Expr);
yyVisit1 (yyt->MPC_Exprs.Next);
break;

case kMPC_FreeNode:
break;
 default: ;
 }
}

void BeginmpcAttr ()
{
}

void ClosempcAttr ()
{
}
