# ifndef beginint
# define beginint(a)		
# endif
# ifndef closeint
# define closeint(a)		
# endif
# ifndef readint
# define readint(a)		(void) fscanf (yyf, "%d", & a);
# endif
# ifndef writeint
# define writeint(a)		(void) fprintf (yyf, "%d", a);
# endif
# ifndef getint
# define getint(a)		yyGet ((char *) & a, sizeof (a));
# endif
# ifndef putint
# define putint(a)		yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copyint
# define copyint(a, b)		
# endif
# ifndef equalint
# define equalint(a, b)		a == b
# endif
# ifndef beginshort
# define beginshort(a)		
# endif
# ifndef closeshort
# define closeshort(a)		
# endif
# ifndef readshort
# define readshort(a)		(void) fscanf (yyf, "%hd", & a);
# endif
# ifndef writeshort
# define writeshort(a)		(void) fprintf (yyf, "%hd", a);
# endif
# ifndef getshort
# define getshort(a)		yyGet ((char *) & a, sizeof (a));
# endif
# ifndef putshort
# define putshort(a)		yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copyshort
# define copyshort(a, b)		
# endif
# ifndef equalshort
# define equalshort(a, b)	a == b
# endif
# ifndef beginlong
# define beginlong(a)		
# endif
# ifndef closelong
# define closelong(a)		
# endif
# ifndef readlong
# define readlong(a)		(void) fscanf (yyf, "%ld", & a);
# endif
# ifndef writelong
# define writelong(a)		(void) fprintf (yyf, "%ld", a);
# endif
# ifndef getlong
# define getlong(a)		yyGet ((char *) & a, sizeof (a));
# endif
# ifndef putlong
# define putlong(a)		yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copylong
# define copylong(a, b)		
# endif
# ifndef equallong
# define equallong(a, b)	a == b
# endif
# ifndef begindouble
# define begindouble(a)		
# endif
# ifndef closedouble
# define closedouble(a)		
# endif
# ifndef readdouble
# define readdouble(a)		(void) fscanf (yyf, "%lg", & a);
# endif
# ifndef writedouble
# define writedouble(a)		(void) fprintf (yyf, "%lg", a);
# endif
# ifndef getdouble
# define getdouble(a)		yyGet ((char *) & a, sizeof (a));
# endif
# ifndef putdouble
# define putdouble(a)		yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copydouble
# define copydouble(a, b)		
# endif
# ifndef equaldouble
# define equaldouble(a, b)	a == b
# endif
# ifndef beginbool
# define beginbool(a)		
# endif
# ifndef closebool
# define closebool(a)		
# endif
# ifndef readbool
# define readbool(a)		a = fgetc (yyf) == 'T';
# endif
# ifndef writebool
# define writebool(a)		(void) fputc (a ? 'T' : 'F', yyf);
# endif
# ifndef getbool
# define getbool(a)		yyGet ((char *) & a, sizeof (a));
# endif
# ifndef putbool
# define putbool(a)		yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copybool
# define copybool(a, b)		
# endif
# ifndef equalbool
# define equalbool(a, b)	a == b
# endif
# ifndef beginchar
# define beginchar(a)		
# endif
# ifndef closechar
# define closechar(a)		
# endif
# ifndef readchar
# define readchar(a)		a = fgetc (yyf);
# endif
# ifndef writechar
# define writechar(a)		(void) fputc (a, yyf);
# endif
# ifndef getchar
# define getchar(a)		yyGet ((char *) & a, sizeof (a));
# endif
# ifndef putchar
# define putchar(a)		yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copychar
# define copychar(a, b)		
# endif
# ifndef equalchar
# define equalchar(a, b)	a == b
# endif
# ifndef begintString
# define begintString(a)	
# endif
# ifndef closetString
# define closetString(a)	
# endif
# ifndef readtString
# define readtString(a)		
# endif
# ifndef writetString
# define writetString(a)	(void) fputs (a, yyf);
# endif
# ifndef gettString
# define gettString(a)		
# endif
# ifndef puttString
# define puttString(a)		
# endif
# ifndef copytString
# define copytString(a, b)		
# endif
# ifndef equaltString
# define equaltString(a, b)	strcmp (a, b)
# endif
# ifndef begintIdent
# define begintIdent(a)		a = NoIdent;
# endif
# ifndef closetIdent
# define closetIdent(a)		
# endif
# ifndef readtIdent
# define readtIdent(a)		a = yyReadIdent ();
# endif
# ifndef writetIdent
# define writetIdent(a)		WriteIdent (yyf, a);
# endif
# ifndef gettIdent
# define gettIdent(a)		yyGetIdent (& a);
# endif
# ifndef puttIdent
# define puttIdent(a)		yyPutIdent (a);
# endif
# ifndef copytIdent
# define copytIdent(a, b)		
# endif
# ifndef equaltIdent
# define equaltIdent(a, b)	a == b
# endif
# ifndef begintPosition
# define begintPosition(a)	a = NoPosition;
# endif
# ifndef closetPosition
# define closetPosition(a)		
# endif
# ifndef readtPosition
# define readtPosition(a)	ReadPosition (yyf, & a);
# endif
# ifndef writetPosition
# define writetPosition(a)	WritePosition (yyf, a);
# endif
# ifndef gettPosition
# define gettPosition(a)	yyGet ((char *) & a, sizeof (a));
# endif
# ifndef puttPosition
# define puttPosition(a)	yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copytPosition
# define copytPosition(a, b)		
# endif
# ifndef equaltPosition
# define equaltPosition(a, b)	Compare (a, b) == 0
# endif
# ifndef begintTypeFlags
# define begintTypeFlags(a)
# endif
# ifndef closetTypeFlags
# define closetTypeFlags(a)
# endif
# ifndef readtTypeFlags
# define readtTypeFlags(a)	yyReadHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef writetTypeFlags
# define writetTypeFlags(a)	yyWriteHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef gettTypeFlags
# define gettTypeFlags(a)	yyGet ((char *) & a, sizeof (a));
# endif
# ifndef puttTypeFlags
# define puttTypeFlags(a)	yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copytTypeFlags
# define copytTypeFlags(a, b)
# endif
# ifndef equaltTypeFlags
# define equaltTypeFlags(a, b)	memcmp ((char *) & a, (char *) & b, sizeof (a)) == 0
# endif
# ifndef begintClass
# define begintClass(a)
# endif
# ifndef closetClass
# define closetClass(a)
# endif
# ifndef readtClass
# define readtClass(a)	yyReadHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef writetClass
# define writetClass(a)	yyWriteHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef gettClass
# define gettClass(a)	yyGet ((char *) & a, sizeof (a));
# endif
# ifndef puttClass
# define puttClass(a)	yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copytClass
# define copytClass(a, b)
# endif
# ifndef equaltClass
# define equaltClass(a, b)	memcmp ((char *) & a, (char *) & b, sizeof (a)) == 0
# endif
# ifndef begintDeclFlags
# define begintDeclFlags(a)
# endif
# ifndef closetDeclFlags
# define closetDeclFlags(a)
# endif
# ifndef readtDeclFlags
# define readtDeclFlags(a)	yyReadHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef writetDeclFlags
# define writetDeclFlags(a)	yyWriteHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef gettDeclFlags
# define gettDeclFlags(a)	yyGet ((char *) & a, sizeof (a));
# endif
# ifndef puttDeclFlags
# define puttDeclFlags(a)	yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copytDeclFlags
# define copytDeclFlags(a, b)
# endif
# ifndef equaltDeclFlags
# define equaltDeclFlags(a, b)	memcmp ((char *) & a, (char *) & b, sizeof (a)) == 0
# endif
# ifndef begintNodeType
# define begintNodeType(a)
# endif
# ifndef closetNodeType
# define closetNodeType(a)
# endif
# ifndef readtNodeType
# define readtNodeType(a)	yyReadHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef writetNodeType
# define writetNodeType(a)	yyWriteHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef gettNodeType
# define gettNodeType(a)	yyGet ((char *) & a, sizeof (a));
# endif
# ifndef puttNodeType
# define puttNodeType(a)	yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copytNodeType
# define copytNodeType(a, b)
# endif
# ifndef equaltNodeType
# define equaltNodeType(a, b)	memcmp ((char *) & a, (char *) & b, sizeof (a)) == 0
# endif
# ifndef begintLinkType
# define begintLinkType(a)
# endif
# ifndef closetLinkType
# define closetLinkType(a)
# endif
# ifndef readtLinkType
# define readtLinkType(a)	yyReadHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef writetLinkType
# define writetLinkType(a)	yyWriteHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef gettLinkType
# define gettLinkType(a)	yyGet ((char *) & a, sizeof (a));
# endif
# ifndef puttLinkType
# define puttLinkType(a)	yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copytLinkType
# define copytLinkType(a, b)
# endif
# ifndef equaltLinkType
# define equaltLinkType(a, b)	memcmp ((char *) & a, (char *) & b, sizeof (a)) == 0
# endif
# ifndef begintStatFlags
# define begintStatFlags(a)
# endif
# ifndef closetStatFlags
# define closetStatFlags(a)
# endif
# ifndef readtStatFlags
# define readtStatFlags(a)	yyReadHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef writetStatFlags
# define writetStatFlags(a)	yyWriteHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef gettStatFlags
# define gettStatFlags(a)	yyGet ((char *) & a, sizeof (a));
# endif
# ifndef puttStatFlags
# define puttStatFlags(a)	yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copytStatFlags
# define copytStatFlags(a, b)
# endif
# ifndef equaltStatFlags
# define equaltStatFlags(a, b)	memcmp ((char *) & a, (char *) & b, sizeof (a)) == 0
# endif
# ifndef begintExprFlags
# define begintExprFlags(a)
# endif
# ifndef closetExprFlags
# define closetExprFlags(a)
# endif
# ifndef readtExprFlags
# define readtExprFlags(a)	yyReadHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef writetExprFlags
# define writetExprFlags(a)	yyWriteHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef gettExprFlags
# define gettExprFlags(a)	yyGet ((char *) & a, sizeof (a));
# endif
# ifndef puttExprFlags
# define puttExprFlags(a)	yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copytExprFlags
# define copytExprFlags(a, b)
# endif
# ifndef equaltExprFlags
# define equaltExprFlags(a, b)	memcmp ((char *) & a, (char *) & b, sizeof (a)) == 0
# endif
# ifndef beginMPC_long_unsigned
# define beginMPC_long_unsigned(a)
# endif
# ifndef closeMPC_long_unsigned
# define closeMPC_long_unsigned(a)
# endif
# ifndef readMPC_long_unsigned
# define readMPC_long_unsigned(a)	yyReadHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef writeMPC_long_unsigned
# define writeMPC_long_unsigned(a)	yyWriteHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef getMPC_long_unsigned
# define getMPC_long_unsigned(a)	yyGet ((char *) & a, sizeof (a));
# endif
# ifndef putMPC_long_unsigned
# define putMPC_long_unsigned(a)	yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copyMPC_long_unsigned
# define copyMPC_long_unsigned(a, b)
# endif
# ifndef equalMPC_long_unsigned
# define equalMPC_long_unsigned(a, b)	memcmp ((char *) & a, (char *) & b, sizeof (a)) == 0
# endif
# ifndef beginMPC_long_double
# define beginMPC_long_double(a)
# endif
# ifndef closeMPC_long_double
# define closeMPC_long_double(a)
# endif
# ifndef readMPC_long_double
# define readMPC_long_double(a)	yyReadHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef writeMPC_long_double
# define writeMPC_long_double(a)	yyWriteHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef getMPC_long_double
# define getMPC_long_double(a)	yyGet ((char *) & a, sizeof (a));
# endif
# ifndef putMPC_long_double
# define putMPC_long_double(a)	yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copyMPC_long_double
# define copyMPC_long_double(a, b)
# endif
# ifndef equalMPC_long_double
# define equalMPC_long_double(a, b)	memcmp ((char *) & a, (char *) & b, sizeof (a)) == 0
# endif
# ifndef beginMPC_unsigned_short
# define beginMPC_unsigned_short(a)
# endif
# ifndef closeMPC_unsigned_short
# define closeMPC_unsigned_short(a)
# endif
# ifndef readMPC_unsigned_short
# define readMPC_unsigned_short(a)	yyReadHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef writeMPC_unsigned_short
# define writeMPC_unsigned_short(a)	yyWriteHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef getMPC_unsigned_short
# define getMPC_unsigned_short(a)	yyGet ((char *) & a, sizeof (a));
# endif
# ifndef putMPC_unsigned_short
# define putMPC_unsigned_short(a)	yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copyMPC_unsigned_short
# define copyMPC_unsigned_short(a, b)
# endif
# ifndef equalMPC_unsigned_short
# define equalMPC_unsigned_short(a, b)	memcmp ((char *) & a, (char *) & b, sizeof (a)) == 0
# endif
# ifndef beginpVoid
# define beginpVoid(a)
# endif
# ifndef closepVoid
# define closepVoid(a)
# endif
# ifndef readpVoid
# define readpVoid(a)	yyReadHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef writepVoid
# define writepVoid(a)	yyWriteHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef getpVoid
# define getpVoid(a)	yyGet ((char *) & a, sizeof (a));
# endif
# ifndef putpVoid
# define putpVoid(a)	yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copypVoid
# define copypVoid(a, b)
# endif
# ifndef equalpVoid
# define equalpVoid(a, b)	memcmp ((char *) & a, (char *) & b, sizeof (a)) == 0
# endif
# ifndef begintOptm_Attribute
# define begintOptm_Attribute(a)
# endif
# ifndef closetOptm_Attribute
# define closetOptm_Attribute(a)
# endif
# ifndef readtOptm_Attribute
# define readtOptm_Attribute(a)	yyReadHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef writetOptm_Attribute
# define writetOptm_Attribute(a)	yyWriteHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef gettOptm_Attribute
# define gettOptm_Attribute(a)	yyGet ((char *) & a, sizeof (a));
# endif
# ifndef puttOptm_Attribute
# define puttOptm_Attribute(a)	yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copytOptm_Attribute
# define copytOptm_Attribute(a, b)
# endif
# ifndef equaltOptm_Attribute
# define equaltOptm_Attribute(a, b)	memcmp ((char *) & a, (char *) & b, sizeof (a)) == 0
# endif
# ifndef begintLastNode
# define begintLastNode(a)
# endif
# ifndef closetLastNode
# define closetLastNode(a)
# endif
# ifndef readtLastNode
# define readtLastNode(a)	yyReadHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef writetLastNode
# define writetLastNode(a)	yyWriteHex ((unsigned char *) & a, sizeof (a));
# endif
# ifndef gettLastNode
# define gettLastNode(a)	yyGet ((char *) & a, sizeof (a));
# endif
# ifndef puttLastNode
# define puttLastNode(a)	yyPut ((char *) & a, sizeof (a));
# endif
# ifndef copytLastNode
# define copytLastNode(a, b)
# endif
# ifndef equaltLastNode
# define equaltLastNode(a, b)	memcmp ((char *) & a, (char *) & b, sizeof (a)) == 0
# endif
# ifndef begintTree
# define begintTree(a)	a = NoTree;
# endif
# ifndef closetTree
# define closetTree(a)	yyChild = a; a = NoTree; yyReleaseTree (yyChild);
# endif
# ifndef readtTree
# define readtTree(a)	yyReadTree (a);
# endif
# ifndef writetTree
# define writetTree(a)	yyWriteTree (a);
# endif
# ifndef gettTree
# define gettTree(a)	yyGetTree (a);
# endif
# ifndef puttTree
# define puttTree(a)	yyPutTree (a);
# endif
# ifndef copytTree
# define copytTree(a, b)	yyCopyTree (b, & a);
# endif
# ifndef equaltTree
# define equaltTree(a, b)	IsEqualTree (a, b)
# endif
