
#ifndef __HSCAL_CB_CCOPY_HSCALFUNC_HH
#define __HSCAL_CB_CCOPY_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_ccopy(
    int *n,
    int *incx,
    int *incy,
    double *tcomp
)
{
    *tcomp = 0.;

    if (*n <= 0) {
       return HSCAL_SUCCESS;
    }

    if (*incx == 1 && *incy == 1) {
       *tcomp += (*n * 4);
       return HSCAL_SUCCESS;
    }

    *tcomp += (*n * 6);

    return HSCAL_SUCCESS;
}

#endif


