
#ifndef __HSCAL_CB_CSSCAL_HSCALFUNC_HH
#define __HSCAL_CB_CSSCAL_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_csscal(
    int *n,
    char *csa,
    int *incx,
    double *tcomp
)
{
    *tcomp = 0.;

    if (*n <= 0 || *incx <= 0) {
	return HSCAL_SUCCESS;
    }

    if (*incx == 1) {
       *tcomp += 6 * (*n);
       return HSCAL_SUCCESS;
    }

    *tcomp += 6 * (*n);

    return HSCAL_SUCCESS;
}

#endif
