
#ifndef __HSCAL_CB_DASUM_HH
#define __HSCAL_CB_DASUM_HH



#include "../../../include/hscalapack.h"

int hscal_dasum(
    int    *n, 
    int    *incx,
    double *tcomp
)
{
    int i__1, i__2;
    int i__, m;
    int mp1;

    *tcomp = 0.;

    if (*n <= 0 || *incx <= 0) {
	return HSCAL_SUCCESS;
    }
    if (*incx == 1) {
	goto L20;
    }

    *tcomp += (*n);

    return HSCAL_SUCCESS;
L20:
    m = *n % 6;
    if (m == 0) {
	goto L40;
    }

    *tcomp += (m);

    if (*n < 6) {
	goto L60;
    }
L40:
    mp1 = m + 1;
    i__2 = *n;
    for (i__ = mp1; i__ <= i__2; i__ += 6) {
        *tcomp += 6;
    }
L60:

    return HSCAL_SUCCESS;
}

#endif
