
#ifndef __HSCAL_CB_DCOPY_HSCALFUNC_HH
#define __HSCAL_CB_DCOPY_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_dcopy(
    int *n,
    int *incx,
    int *incy,
    double *tcomp
)
{
    int m;

    *tcomp = 0.;

    if (*n <= 0) {
	return HSCAL_SUCCESS;
    }

    if (*incx == 1 && *incy == 1) {
       m = *n % 7;

       if (m == 0) {
          *tcomp += iceil((*n - m), 7)*7;
          return HSCAL_SUCCESS;
       }

       *tcomp += m;

       if (*n < 7) {
	  return HSCAL_SUCCESS;
       }

       *tcomp += iceil((*n - m), 7)*7;

       return HSCAL_SUCCESS;
    }

    *tcomp += (*n * 3);

    return HSCAL_SUCCESS;
}

#endif

