
#ifndef __HSCAL_CB_ISAMAX_HH
#define __HSCAL_CB_ISAMAX_HH



#include "../../../include/hscalapack.h"

int hscal_isamax(
    int    *n, 
    int    *incx,
    double *tcomp
)
{
    *tcomp = 0.;

    if (*n < 1 || *incx <= 0) {
	return HSCAL_SUCCESS;
    }

    if (*n == 1) {
	return HSCAL_SUCCESS;
    }

    if (*incx == 1) {
	goto L20;
    }

    *tcomp += (*n)*2;

    return HSCAL_SUCCESS;
L20:
    *tcomp += (*n)*2;

    return HSCAL_SUCCESS;
}

#endif
