
#ifndef __HSCAL_CB_ZAXPY_HSCALFUNC_HH
#define __HSCAL_CB_ZAXPY_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_zaxpy(
    int *n,
    char *cza,
    int *incx,
    int *incy,
    double *tcomp
)
{
    hscaldoublecomplex *za = (hscaldoublecomplex*)cza;

    *tcomp = 0.;

    if (*n <= 0) {
	return HSCAL_SUCCESS;
    }

    if (hscal_dcabs1(za) == 0.) {
	return HSCAL_SUCCESS;
    }

    if (*incx == 1 && *incy == 1) {
       *tcomp += (*n * 10);
       return HSCAL_SUCCESS;
    }

    *tcomp += (*n * 12);

    return HSCAL_SUCCESS;
}

#endif
