
#ifndef __HSCAL_PTZB_IMMDDA_HSCALFUNC_HH
#define __HSCAL_PTZB_IMMDDA_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_immdda(
    int *m, 
    int *n, 
    char *calpha, 
    int *lda, 
    char *cbeta,
    int *ldb,
    double *tcomp
)
{
    int a_dim1, a_offset, b_dim1, b_offset, i__1, i__2;
    int i__, j;

    int *alpha = (int*)calpha;
    int *beta = (int*)cbeta;
    hscaldoublereal tm, tn;

    *tcomp = 0.;

    tm = (double)(*m);
    tn = (double)(*n);

    if (*beta == 1) {
	if (*alpha == 0) {
          *tcomp += (tn * tm * 4);
	} else if (*alpha != 1) {
          *tcomp += (tn * tm * 8);
	} else {
           *tcomp += (tn * tm * 7);
	}
    } else if (*beta != 0) {
	if (*alpha == 0) {
          *tcomp += (tn * tm * 5);
	} else if (*alpha != 1) {
           *tcomp += (tn * tm * 9);
	} else {
           *tcomp += (tn * tm * 8);
	}
    } else {
	if (*alpha == 0) {
           *tcomp += (tn * tm * 2);
	} else if (*alpha != 1) {
           *tcomp += (tn * tm * 5);
	}
    }

    return HSCAL_SUCCESS;
}

#endif


