
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int     hscal_icamax_benchmark(
        int     *n, 
        hscalcomplex *cx, 
        int     *incx
)
{
    icamax_(
           n,
           (char*)cx,
           incx
    );

    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int     hscal_idamax_benchmark(
        int     *n, 
        hscaldoublereal *dx, 
        int     *incx
)
{
    idamax_(
           n,
           (char*)dx,
           incx
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int     hscal_isamax_benchmark(
        int     *n, 
        hscalreal    *sx, 
        int     *incx
)
{
    isamax_(
           n,
           (char*)sx,
           incx
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int     hscal_izamax_benchmark(
        int           *n, 
        hscaldoublecomplex *zx, 
        int           *incx
)
{
    izamax_(
           n,
           (char*)zx,
           incx
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

