
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

hscaldoublereal hscal_dasum_benchmark(
           int     *n,
           hscaldoublereal *dx,
           int     *incx
)
{
    return dasum_(
           n,
           (char*)dx,
           incx
    );
}

/*------------------------------------------------------------------*/

hscaldoublereal hscal_dzasum_benchmark(
           int     *n,
           hscaldoublecomplex *zx,
           int     *incx
)
{
    return dzasum_(
           n,
           (char*)zx,
           incx
    );
}

/*------------------------------------------------------------------*/

hscaldoublereal hscal_sasum_benchmark(
           int     *n,
           hscalreal    *sx,
           int     *incx
)
{
    return sasum_(
           n,
           (char*)sx,
           incx
    );
}

/*------------------------------------------------------------------*/

hscaldoublereal hscal_scasum_benchmark(
           int     *n,
           hscalcomplex *cx,
           int     *incx
)
{
    return scasum_(
           n,
           (char*)cx,
           incx
    );
}

/*------------------------------------------------------------------*/
