
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

hscaldoublereal hscal_ddot_benchmark(
           int        *n,
           hscaldoublereal *dx,
           int        *incx,
           hscaldoublereal *dy,
           int        *incy
)
{
    return ddot_(
           n,
           (char*)dx,
           incx,
           (char*)dy,
           incy
    );
}

/*------------------------------------------------------------------*/

hscaldoublereal hscal_sdot_benchmark(
           int     *n,
           hscalreal    *sx,
           int     *incx,
           hscalreal    *sy,
           int     *incy
)
{
    return sdot_(
           n,
           (char*)sx,
           incx,
           (char*)sy,
           incy
    );
}

/*------------------------------------------------------------------*/

