
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

void hscal_cdotc_benchmark(
     hscalcomplex *ret_val,
     int     *n,
     hscalcomplex *cx,
     int     *incx,
     hscalcomplex *cy,
     int     *incy
)
{
     cdotc_(
          (char*)ret_val,
          n,
          (char*)cx,
          incx,
          (char*)cy,
          incy
     );
}

/*------------------------------------------------------------------*/

void hscal_zdotc_benchmark(
     hscaldoublecomplex * ret_val,
     int           * n,
     hscaldoublecomplex * zx,
     int           * incx,
     hscaldoublecomplex * zy,
     int           * incy
)
{
     zdotc_(
          (char*)ret_val,
          n,
          (char*)zx,
          incx,
          (char*)zy,
          incy
     );
}

/*------------------------------------------------------------------*/

