
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_cgeru_benchmark(
    int     *m,
    int     *n,
    hscalcomplex *alpha,
    hscalcomplex *x,
    int     *incx,
    hscalcomplex *y,
    int     *incy,
    hscalcomplex *a,
    int     *lda
)
{
    cgeru_(
           m,
           n,
           (char*)alpha,
           (char*)x,
           incx,
           (char*)y,
           incy,
           (char*)a,
           lda
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

int hscal_zgeru_benchmark(
    int     *m,
    int     *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *x,
    int     *incx,
    hscaldoublecomplex *y,
    int     *incy,
    hscaldoublecomplex *a,
    int     *lda
)
{
    zgeru_(
           m,
           n,
           (char*)alpha,
           (char*)x,
           incx,
           (char*)y,
           incy,
           (char*)a,
           lda
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

