
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_chemm_benchmark(
    char    *side,
    char    *uplo,
    int     *m,
    int     *n,
    hscalcomplex *alpha,
    hscalcomplex *a,
    int     *lda,
    hscalcomplex *b,
    int     *ldb,
    hscalcomplex *beta,
    hscalcomplex *c__,
    int     *ldc
)
{
    chemm_(
           side,
           uplo,
           m,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb,
           (char*)beta,
           (char*)c__,
           ldc
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

int hscal_zhemm_benchmark(
    char          *side,
    char          *uplo,
    int           *m,
    int           *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    int           *lda,
    hscaldoublecomplex *b,
    int           *ldb,
    hscaldoublecomplex *beta,
    hscaldoublecomplex *c__,
    int           *ldc
)
{
    zhemm_(
           side,
           uplo,
           m,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb,
           (char*)beta,
           (char*)c__,
           ldc
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

