
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_cher2_benchmark(
    char    *uplo,
    int     *n,
    hscalcomplex *alpha,
    hscalcomplex *x,
    int     *incx,
    hscalcomplex *y,
    int     *incy,
    hscalcomplex *a,
    int     *lda
)
{
    cher2_(
           uplo,
           n,
           (char*)alpha,
           (char*)x,
           incx,
           (char*)y,
           incy,
           (char*)a,
           lda
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

int hscal_zher2_benchmark(
    char          *uplo,
    int           *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *x,
    int           *incx,
    hscaldoublecomplex *y,
    int           *incy,
    hscaldoublecomplex *a,
    int           *lda
)
{
    zher2_(
           uplo,
           n,
           (char*)alpha,
           (char*)x,
           incx,
           (char*)y,
           incy,
           (char*)a,
           lda
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

