
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_cher2k_benchmark(
    char *uplo,
    char *trans,
    int     *n,
    int     *k,
    hscalcomplex *alpha,
    hscalcomplex *a,
    int     *lda,
    hscalcomplex *b,
    int     *ldb,
    hscalreal *beta,
    hscalcomplex *c__,
    int     *ldc
)
{
    cher2k_(
           uplo,
           trans,
           n,
           k,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb,
           (char*)beta,
           (char*)c__,
           ldc
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

int hscal_zher2k_benchmark(
    char *uplo,
    char *trans,
    int     *n,
    int     *k,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    int     *lda,
    hscaldoublecomplex *b,
    int     *ldb,
    hscaldoublereal *beta,
    hscaldoublecomplex *c__,
    int     *ldc
)
{
    zher2k_(
           uplo,
           trans,
           n,
           k,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)b,
           ldb,
           (char*)beta,
           (char*)c__,
           ldc
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

