
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_cherk_benchmark(
    char *uplo,
    char *trans,
    int     *n,
    int     *k,
    hscalreal *alpha,
    hscalcomplex *a,
    int     *lda,
    hscalreal *beta,
    hscalcomplex *c__,
    int     *ldc
)
{
    cherk_(
           uplo,
           trans,
           n,
           k,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)beta,
           (char*)c__,
           ldc
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

int hscal_zherk_benchmark(
    char          *uplo,
    char          *trans,
    int           *n,
    int           *k,
    hscaldoublereal    *alpha,
    hscaldoublecomplex *a,
    int           *lda,
    hscaldoublereal    *beta,
    hscaldoublecomplex *c__,
    int           *ldc
)
{
    zherk_(
           uplo,
           trans,
           n,
           k,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)beta,
           (char*)c__,
           ldc
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

