
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_cswap_benchmark(
    int     *n,
    hscalcomplex *cx,
    int     *incx,
    hscalcomplex *cy,
    int     *incy
)
{
    cswap_(
           n,
           (char*)cx,
           incx,
           (char*)cy,
           incy
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_dswap_benchmark(
    int     *n,
    hscaldoublereal *dx,
    int     *incx,
    hscaldoublereal *dy,
    int     *incy
)
{
    dswap_(
           n,
           (char*)dx,
           incx,
           (char*)dy,
           incy
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_sswap_benchmark(
    int     *n,
    hscalreal *sx,
    int     *incx,
    hscalreal *sy,
    int     *incy
)
{
    sswap_(
           n,
           (char*)sx,
           incx,
           (char*)sy,
           incy
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_zswap_benchmark(
    int     *n,
    hscaldoublecomplex *zx,
    int     *incx,
    hscaldoublecomplex *zy,
    int     *incy
)
{
    zswap_(
           n,
           (char*)zx,
           incx,
           (char*)zy,
           incy
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

