
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_ssymv_benchmark(
    char *uplo,
    int     *n,
    hscalreal *alpha,
    hscalreal *a,
    int     *lda,
    hscalreal *x,
    int     *incx,
    hscalreal *beta,
    hscalreal *y,
    int     *incy
)
{
    ssymv_(
           uplo,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)x,
           incx,
           (char*)beta,
           (char*)y,
           incy
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_dsymv_benchmark(
    char *uplo,
    int     *n,
    hscaldoublereal * alpha,
    hscaldoublereal *a,
    int     *lda,
    hscaldoublereal *x,
    int     *incx,
    hscaldoublereal *beta,
    hscaldoublereal *y,
    int     *incy
)
{
    dsymv_(
           uplo,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)x,
           incx,
           (char*)beta,
           (char*)y,
           incy
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

