
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_dsyr2_benchmark(
    char       *uplo,
    int        *n,
    hscaldoublereal *alpha,
    hscaldoublereal *x,
    int        *incx,
    hscaldoublereal *y,
    int        *incy,
    hscaldoublereal *a,
    int        *lda
)
{
    dsyr2_(
           uplo,
           n,
           (char*)alpha,
           (char*)x,
           incx,
           (char*)y,
           incy,
           (char*)a,
           lda
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_ssyr2_benchmark(
    char    *uplo,
    int     *n,
    hscalreal    *alpha,
    hscalreal    *x,
    int     *incx,
    hscalreal    *y,
    int     *incy,
    hscalreal    *a,
    int     *lda
)
{
    ssyr2_(
           uplo,
           n,
           (char*)alpha,
           (char*)x,
           incx,
           (char*)y,
           incy,
           (char*)a,
           lda
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

