#!/bin/sh

declare -a hscal_routines

hscal_routines=( pdgemv pcgemv psgemv pzgemv pcagemv pdagemv psagemv pzagemv pchemv pzhemv pcahemv pzahemv pdsymv pssymv pdasymv psasymv pctrmv pdtrmv pstrmv pztrmv pcatrmv pdatrmv psatrmv pzatrmv pctrsv pdtrsv pstrsv pztrsv pcgerc pzgerc pcgeru pzgeru pdger psger pcher pzher pcher2 pzher2 pdsyr pssyr pdsyr2 pssyr2 )

for routine in ${hscal_routines[@]}
do
	echo "===============Running ${routine}===================="
	./run_hscal_${routine}_auto.sh > hscal_${routine}.txt 2>&1
done

exit 0
