#!/bin/sh

. ./cparameters.sh

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pcgeru_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pcgeru_parameters.h
	echo ""                                                     >> hscalapack_pcgeru_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pcgeru_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pcgeru_parameters.h
	echo "int     MB               = 32;"                       >> hscalapack_pcgeru_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pcgeru_parameters.h
	echo "float ALPHA[2]           = {1., 1.};"                 >> hscalapack_pcgeru_parameters.h
	echo "float BETA[2]            = {1., 1.};"                 >> hscalapack_pcgeru_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pcgeru_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pcgeru_parameters.h
	echo "int     IX               = 1;"                        >> hscalapack_pcgeru_parameters.h
	echo "int     JX               = 1;"                        >> hscalapack_pcgeru_parameters.h
	echo "int     IY               = 1;"                        >> hscalapack_pcgeru_parameters.h
	echo "int     JY               = 1;"                        >> hscalapack_pcgeru_parameters.h
	echo "int     INCX             = 1;"                        >> hscalapack_pcgeru_parameters.h
	echo "int     INCY             = 1;"                        >> hscalapack_pcgeru_parameters.h
	echo "int     CHECK_RESULT     = 0;"                        >> hscalapack_pcgeru_parameters.h
	echo ""                                                     >> hscalapack_pcgeru_parameters.h
	echo "#endif"                                               >> hscalapack_pcgeru_parameters.h

	./run_hscal.sh test_hscal_pcgeru_auto hscalapack_pcgeru_parameters.h

	let "PSIZE_COUNT = $PSIZE_COUNT + 1"

done
