#!/bin/sh

declare -a hscal_routines

hscal_routines=( pcgemm pdgemm psgemm pzgemm pcsymm pdsymm pssymm pzsymm pchemm pzhemm pcsyrk pdsyrk pssyrk pzsyrk pcsyr2k pdsyr2k pssyr2k pzsyr2k pcherk pzherk pctranc pztranc pctranu pztranu pdtran pstran pctrmm pdtrmm pstrmm pztrmm pctrsm pdtrsm pstrsm pztrsm pcgeadd pdgeadd psgeadd pzgeadd pctradd pdtradd pstradd pztradd )

for routine in ${hscal_routines[@]}
do
	echo "===============Running ${routine}===================="
	./run_hscal_${routine}_auto.sh > hscal_${routine}.txt 2>&1
done

exit 0
