#!/bin/sh

. ./cparameters.sh

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	P_COUNT=0
	NUMBER_OF_P_ITERATIONS=${#VALUES_OF_P[@]}

	while [ "$P_COUNT" -lt "$NUMBER_OF_P_ITERATIONS" ]
	do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > scalapack_pdpotrf_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> scalapack_pdpotrf_parameters.h
	echo ""                                                     >> scalapack_pdpotrf_parameters.h
	echo "int     UPLOI            = 'U';"                      >> scalapack_pdpotrf_parameters.h
	echo "int     N                = $PSIZE;"                   >> scalapack_pdpotrf_parameters.h
	echo "int     NB               = 64;"                       >> scalapack_pdpotrf_parameters.h
	echo "int     IA               = 1;"                        >> scalapack_pdpotrf_parameters.h
	echo "int     JA               = 1;"                        >> scalapack_pdpotrf_parameters.h
        echo "int     nprow            = ${VALUES_OF_P[$P_COUNT]};" >> scalapack_pdpotrf_parameters.h
        echo "int     npcol            = ${VALUES_OF_Q[$P_COUNT]};" >> scalapack_pdpotrf_parameters.h
	echo ""                                                     >> scalapack_pdpotrf_parameters.h
	echo "#endif"                                               >> scalapack_pdpotrf_parameters.h

	./run_scal.sh test_scal_pdpotrf scalapack_pdpotrf_parameters.h

	let "P_COUNT = $P_COUNT + 1"
	done

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

