
#ifndef __HSCAL_BLACS_BISMVCOPY_HSCALFUNC_HH
#define __HSCAL_BLACS_BISMVCOPY_HSCALFUNC_HH

#include "../../../../include/scalapack.h"

void hscal_BI_smvcopy_nocomm(
     int m, int n, int lda,
     int nprow, int npcol, int myrow, int mycol, 
     double *tcomp
)
{
   int i, j;

   if (tcomp == NULL)
   {
      return;
   }

   HSCAL_DEBUG(__FILE__, __FUNCTION__,__LINE__, "N %d", (m*n));

   if ( (m == lda) || (n == 1) )
   {
      TCOMP(myrow, mycol, nprow, npcol) += (n*m);
   }
   else if (m == 1)
   {
      TCOMP(myrow, mycol, nprow, npcol) += n;
   }
   else
   {
      TCOMP(myrow, mycol, nprow, npcol) += (n*m);
   }
} 

#endif

