
/*************************************************************************
*                                                                       *
*                 Heterogeneous Data Partitioning Interface             *
*                 =========================================             *
*                                                                       *
*  Copyright (c) 2002          Department of Computer Science,          *
*                              University College Dublin.               *
*                                                                       *
*  All rights reserved. We assume no responsibility for the use         *
*  or reliability of our software.                                      *
*                                                                       *
*************************************************************************/

   /************************************************/
   /* hmpi_partitioning - Partitioning interfaces  */
   /*                     for the HMPI Library     */
   /*                                              */
   /* Revision history                             */
   /* 19-05-2003  --      Initial version          */
   /************************************************/

   #ifndef __HMPI_PARTITIONING_HH
   #define __HMPI_PARTITIONING_HH

   #include "hmpi_partitioning_types.h"
   #include "hmpi_partitioning_sets.h"
   #include "hmpi_partitioning_internal.h"
   #include "hmpi_partitioning_matrices.h"
   #include "hmpi_partitioning_graphs.h"
   #include "hmpi_partitioning_trees.h"

   #endif  /* __HMPI_PARTITIONING_HH */
