/*
 * $Id: BackEnd.c,v 1.8 2002/12/12 09:39:48 posypkin Exp $
 */


#include "be_print.h"

/* NAMES:    main
   PURPOSE:  main Back End function
   SYNOPSYS: argc
             argv
   RETURNS:  void
*/

int back_end(int argc, char **argv)
{
/* main parameters */
    int ip, io, it, ih, in, iprt, imacro;
    tTree r;


    /*fprintf(stderr,"mpC code generator\n"); */
    for (iprt = 0; iprt < argc; iprt++) {
        if (strcmp(argv[iprt], "-prt") == 0) {
            prt = 1;
            break;
        }
    }
    if (prt)
        printf("iprt=%d prt=%d\n", iprt, prt);
    if (prt)
        printf("argc=%d\n", argc);
    for (ip = 0; ip < argc; ip++)
        if (prt)
            printf("arg %d: %s\n", ip, argv[ip]);
    eargc = argc;
    eargv = argv;
    for (io = 0; io < argc; io++) {
        if (strcmp(argv[io], "-out") == 0) {
            output = "stdout";
        } 
    }

    if (prt)
        printf("io=%d output=%s\n", io, output);
    for (imacro = 0; imacro < argc; imacro++) {
        if (strcmp(argv[imacro], "-macro") == 0) {
            macro = 0;
            break;
        }
    }
    if (prt)
        printf("imacro=%d macro=%d\n", imacro, macro);
    for (it = 0; it < argc; it++) {
        if (strcmp(argv[it], "-topo") == 0) {
            gen_topo_fun = 0;
            break;
        }
    }
    if (prt)
        printf("it=%d gen_topo_fun=%d\n", it, gen_topo_fun);
    for (in = 0; in < argc; in++) {
        if (strcmp(argv[in], "-null_init") == 0) {
            null_init = 1;
            break;
        }
    }
    if (prt)
        printf("in=%d null_init=%d\n", in, null_init);
    for (ih = 0; ih < argc; ih++) {
        if (strcmp(argv[ih], "-het") == 0) {
            not_host = 1;
            break;
        }
    }
    pass_number = 1;
    if (prt)
        printf("ih=%d not_host=%d\n", ih, not_host);
    if (prt)
        printf("\n pass number=%d\n\n", pass_number);
    r = TreeRoot;
    /*QueryTree(r); */
    File_print(r);
    if (not_host) {
        tTree pDecls = r->MPC_Root.Decls;
        PointerControl(pDecls);
        pass_number++;
        if (prt)
            printf("\n pass number=%d\n\n", pass_number);
        dummy = fopen("/dev/null", "w");
        File_print(r);
        fclose(dummy);
    }
    return 0;
}
