# include "Type.h"
# define yyALLOC(ptr, size)	if ((ptr = (tType) Type_PoolFreePtr) >= (tType) Type_PoolMaxPtr) \
  ptr = Type_Alloc (); \
  Type_PoolFreePtr += size;
# define yyFREE(ptr, size)	
# ifdef __cplusplus
extern "C" {
# include "rSystem.h"
# include "General.h"
# include "rMemory.h"
# include "DynArray.h"
# include "StringMem.h"
# include "Idents.h"
# include "Sets.h"
# include "Positions.h"
}
# else
# include "rSystem.h"
# include "General.h"
# include "rMemory.h"
# include "DynArray.h"
# include "StringMem.h"
# include "Idents.h"
# include "Sets.h"
# include "Positions.h"
# endif

char Type_module_does_not_match_evaluator_module_8688;
char generate_Type_module_without_option_0;

# line 14 "../../../../HeteroMPI/mpC/back/Type.ast"

#include <CocktailIO.h>  

# ifdef getchar
# undef getchar
# endif
# ifdef putchar
# undef putchar
# endif
# include "yyType.w"

static void yyExit () { rExit (1); }

void (* Type_Exit) () = yyExit;

# define yyBlockSize 20480

typedef struct yysBlock {
 char yyBlock [yyBlockSize];
 struct yysBlock * yySuccessor;
} yytBlock, * yytBlockPtr;

tType TypeRoot;
unsigned long Type_HeapUsed = 0;

static yytBlockPtr yyBlockList	= (yytBlockPtr) NoType;
char * Type_PoolFreePtr	= (char *) NoType;
char * Type_PoolMaxPtr	= (char *) NoType;
static unsigned short yyMaxSize	= 0;
unsigned short Type_NodeSize [2 + 1] = { 0,
 sizeof (yTypes),
 sizeof (yType),
};
char * Type_NodeName [2 + 1] = {
 "NoType",
 "Types",
 "Type",
};
static Type_tKind yyTypeRange [2 + 1] = { 0,
 kTypes,
 kType,
};

tType Type_Alloc ()
{
 register yytBlockPtr yyBlockPtr = yyBlockList;
 register int i;

 if (yyMaxSize == 0)
  for (i = 1; i <= 2; i ++) {
   Type_NodeSize [i] = (Type_NodeSize [i] + yyMaxAlign - 1) & yyAlignMasks [yyMaxAlign];
   yyMaxSize = Max (Type_NodeSize [i], yyMaxSize);
  }
 yyBlockList = (yytBlockPtr) Alloc (sizeof (yytBlock));
 yyBlockList->yySuccessor = yyBlockPtr;
 Type_PoolFreePtr = yyBlockList->yyBlock;
 Type_PoolMaxPtr = Type_PoolFreePtr + yyBlockSize - yyMaxSize + 1;
 Type_HeapUsed += yyBlockSize;
 return (tType) Type_PoolFreePtr;
}

tType MakeType
# if defined __STDC__ | defined __cplusplus
 (Type_tKind yyKind)
# else
 (yyKind) Type_tKind yyKind;
# endif
{
 register tType yyt;
 yyALLOC (yyt, Type_NodeSize [yyKind])
 yyt->Kind = yyKind;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

bool Type_IsType
# if defined __STDC__ | defined __cplusplus
 (register tType yyt, register Type_tKind yyKind)
# else
 (yyt, yyKind) register tType yyt; register Type_tKind yyKind;
# endif
{
 return yyt != NoType && yyKind <= yyt->Kind && yyt->Kind <= yyTypeRange [yyKind];
}

tType nTypes () {
 register tType yyt;
 yyALLOC (yyt, Type_NodeSize [kTypes])
 yyt->Kind = kTypes;
 yyt->yyHead.yyMark = 0;
 begintType(yyt->Types.Type)
 begintType(yyt->Types.Next)
 return yyt;
}

tType nType () {
 register tType yyt;
 yyALLOC (yyt, Type_NodeSize [kType])
 yyt->Kind = kType;
 yyt->yyHead.yyMark = 0;
 begintTree(yyt->Type.Origin)
 begintType(yyt->Type.Parent)
 beginint(yyt->Type.Number)
 begintType(yyt->Type.Children)
 beginint(yyt->Type.Gen)
 beginint(yyt->Type.Used)
 beginint(yyt->Type.Printed)
 begintType(yyt->Type.EquivType)
 begintType(yyt->Type.VectorType)
 begintType(yyt->Type.PointerType)
 return yyt;
}


tType mTypes
# if defined __STDC__ | defined __cplusplus
(tType pType, tType pNext)
# else
(pType, pNext)
tType pType;
tType pNext;
# endif
{
 register tType yyt;
 yyALLOC (yyt, Type_NodeSize [kTypes])
 yyt->Kind = kTypes;
 yyt->yyHead.yyMark = 0;
 yyt->Types.Type = pType;
 yyt->Types.Next = pNext;
 return yyt;
}

tType mType
# if defined __STDC__ | defined __cplusplus
(tTree pOrigin, tType pParent, int pNumber, tType pChildren, int pGen, int pUsed, int pPrinted)
# else
(pOrigin, pParent, pNumber, pChildren, pGen, pUsed, pPrinted)
tTree pOrigin;
tType pParent;
int pNumber;
tType pChildren;
int pGen;
int pUsed;
int pPrinted;
# endif
{
 register tType yyt;
 yyALLOC (yyt, Type_NodeSize [kType])
 yyt->Kind = kType;
 yyt->yyHead.yyMark = 0;
 yyt->Type.Origin = pOrigin;
 yyt->Type.Parent = pParent;
 yyt->Type.Number = pNumber;
 yyt->Type.Children = pChildren;
 yyt->Type.Gen = pGen;
 yyt->Type.Used = pUsed;
 yyt->Type.Printed = pPrinted;
 begintType(yyt->Type.EquivType)
 begintType(yyt->Type.VectorType)
 begintType(yyt->Type.PointerType)
 return yyt;
}

typedef tType * yyPtrtTree;

static FILE * yyf;

static void yyMark
# if defined __STDC__ | defined __cplusplus
 (register tType yyt)
# else
 (yyt) register tType yyt;
# endif
{
 for (;;) {
  if (yyt == NoType || ++ yyt->yyHead.yyMark > 1) return;

  switch (yyt->Kind) {
case kTypes:
yyMark (yyt->Types.Type);
yyt = yyt->Types.Next; break;
case kType:
yyMark (yyt->Type.Children);
yyMark (yyt->Type.EquivType);
yyMark (yyt->Type.VectorType);
yyt = yyt->Type.PointerType; break;
  default: return;
  }
 }
}

# define yyInitTreeStoreSize 32
# define yyMapToTree(yyLabel) yyTreeStorePtr [yyLabel]

static unsigned long yyTreeStoreSize = yyInitTreeStoreSize;
static tType yyTreeStore [yyInitTreeStoreSize];
static tType * yyTreeStorePtr = yyTreeStore;
static int yyLabelCount;
static short yyRecursionLevel = 0;

static Type_tLabel yyMapToLabel
# if defined __STDC__ | defined __cplusplus
 (tType yyt)
# else
 (yyt) tType yyt;
# endif
{
 register int yyi;
 for (yyi = 1; yyi <= yyLabelCount; yyi ++) if (yyTreeStorePtr [yyi] == yyt) return yyi;
 if (++ yyLabelCount == yyTreeStoreSize)
  ExtendArray ((char * *) & yyTreeStorePtr, & yyTreeStoreSize, sizeof (tType));
 yyTreeStorePtr [yyLabelCount] = yyt;
 return yyLabelCount;
}

static void yyWriteType ARGS((tType yyt));

static void yyWriteNl () { (void) putc ('\n', yyf); }

static void yyWriteSelector
# if defined __STDC__ | defined __cplusplus
 (char * yys)
# else
 (yys) char * yys;
# endif
{
 register int yyi = 16 - strlen (yys);
 (void) fputs (yys, yyf);
 while (yyi -- > 0) (void) putc (' ', yyf);
 (void) fputs (" = ", yyf);
}

static void yyWriteHex
# if defined __STDC__ | defined __cplusplus
 (unsigned char * yyx, int yysize)
# else
 (yyx, yysize) unsigned char * yyx; int yysize;
# endif
{ register int yyi; for (yyi = 0; yyi < yysize; yyi ++) (void) fprintf (yyf, "%02x ", yyx [yyi]); }

static void yyWriteAdr
# if defined __STDC__ | defined __cplusplus
 (tType yyt)
# else
 (yyt) tType yyt;
# endif
{
 if (yyt == NoType) (void) fputs ("NoType", yyf);
 else yyWriteHex ((unsigned char *) & yyt, sizeof (yyt));
 yyWriteNl ();
}

static void yWriteNodeTypes
# if defined __STDC__ | defined __cplusplus
 (tType yyt)
# else
 (yyt) tType yyt;
# endif
{
 yyWriteSelector ("Type"); yyWriteAdr (yyt->Types.Type);
 yyWriteSelector ("Next"); yyWriteAdr (yyt->Types.Next);
}

static void yWriteNodeType
# if defined __STDC__ | defined __cplusplus
 (tType yyt)
# else
 (yyt) tType yyt;
# endif
{
 yyWriteSelector ("Origin"); writetTree (yyt->Type.Origin) yyWriteNl ();
 yyWriteSelector ("Parent"); writetType (yyt->Type.Parent) yyWriteNl ();
 yyWriteSelector ("Number"); writeint (yyt->Type.Number) yyWriteNl ();
 yyWriteSelector ("Children"); yyWriteAdr (yyt->Type.Children);
 yyWriteSelector ("Gen"); writeint (yyt->Type.Gen) yyWriteNl ();
 yyWriteSelector ("Used"); writeint (yyt->Type.Used) yyWriteNl ();
 yyWriteSelector ("Printed"); writeint (yyt->Type.Printed) yyWriteNl ();
 yyWriteSelector ("EquivType"); yyWriteAdr (yyt->Type.EquivType);
 yyWriteSelector ("VectorType"); yyWriteAdr (yyt->Type.VectorType);
 yyWriteSelector ("PointerType"); yyWriteAdr (yyt->Type.PointerType);
}

void WriteTypeNode
# if defined __STDC__ | defined __cplusplus
 (FILE * yyyf, tType yyt)
# else
 (yyyf, yyt) FILE * yyyf; tType yyt;
# endif
{
 yyf = yyyf;
 if (yyt == NoType) { (void) fputs ("NoType\n", yyf); return; }

 switch (yyt->Kind) {
case kTypes: (void) fputs (Type_NodeName [kTypes], yyf); (void) fputc ('\n', yyf);
 yWriteNodeTypes (yyt); break;
case kType: (void) fputs (Type_NodeName [kType], yyf); (void) fputc ('\n', yyf);
 yWriteNodeType (yyt); break;
 default: ;
 }
}

static short yyIndentLevel;

void WriteType
# if defined __STDC__ | defined __cplusplus
 (FILE * yyyf, tType yyt)
# else
 (yyyf, yyt) FILE * yyyf; tType yyt;
# endif
{
 short yySaveLevel = yyIndentLevel;
 yyf = yyyf;
 if (yyRecursionLevel ++ == 0) yyLabelCount = 0;
 yyMark (yyt);
 yyIndentLevel = 0;
 yyWriteType (yyt);
 yyIndentLevel = yySaveLevel;
 yyRecursionLevel --;
 if (ferror (yyyf)) { (void) fputs ("Type: error in WriteType\n", stderr); Type_Exit (); }
}

static void yyIndentSelector
# if defined __STDC__ | defined __cplusplus
 (char * yys)
# else
 (yys) char * yys;
# endif
{
 register int yyi;
 for (yyi = 1; yyi <= yyIndentLevel; yyi ++) (void) putc (' ', yyf);
 yyWriteSelector (yys);
}

static void yyIndentSelectorTree
# if defined __STDC__ | defined __cplusplus
 (char * yys, tType yyt)
# else
 (yys, yyt) char * yys; tType yyt;
# endif
{ yyIndentSelector (yys); writetType (yyt) }

static void yWriteTypes
# if defined __STDC__ | defined __cplusplus
 (tType yyt)
# else
 (yyt) tType yyt;
# endif
{
 (void) fputs (Type_NodeName [kTypes], yyf); (void) fputc ('\n', yyf);
 yyIndentSelectorTree ("Type", yyt->Types.Type);
}

static void yWriteType
# if defined __STDC__ | defined __cplusplus
 (tType yyt)
# else
 (yyt) tType yyt;
# endif
{
 (void) fputs (Type_NodeName [kType], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Origin"); writetTree (yyt->Type.Origin) yyWriteNl ();
 yyIndentSelector ("Parent"); writetType (yyt->Type.Parent) yyWriteNl ();
 yyIndentSelector ("Number"); writeint (yyt->Type.Number) yyWriteNl ();
 yyIndentSelectorTree ("Children", yyt->Type.Children);
 yyIndentSelector ("Gen"); writeint (yyt->Type.Gen) yyWriteNl ();
 yyIndentSelector ("Used"); writeint (yyt->Type.Used) yyWriteNl ();
 yyIndentSelector ("Printed"); writeint (yyt->Type.Printed) yyWriteNl ();
 yyIndentSelectorTree ("EquivType", yyt->Type.EquivType);
 yyIndentSelectorTree ("VectorType", yyt->Type.VectorType);
}

static void yyWriteType
# if defined __STDC__ | defined __cplusplus
 (tType yyt)
# else
 (yyt) tType yyt;
# endif
{ unsigned short yyLevel = yyIndentLevel;
 for (;;) {
  if (yyt == NoType) { (void) fputs (" NoType\n", yyf); goto yyExit;
  } else if (yyt->yyHead.yyMark == 0) { (void) fprintf (yyf, "^%d\n", yyMapToLabel (yyt)); goto yyExit;
  } else if (yyt->yyHead.yyMark > 1) {
   register int yyi;
   (void) fprintf (yyf, "\n%06d:", yyMapToLabel (yyt));
   for (yyi = 8; yyi <= yyIndentLevel; yyi ++) (void) putc (' ', yyf);
  } else (void) putc (' ', yyf);
  yyt->yyHead.yyMark = 0;
  yyIndentLevel += 2;

  switch (yyt->Kind) {
case kTypes: yWriteTypes (yyt); yyIndentSelector ("Next"); yyt = yyt->Types.Next; break;
case kType: yWriteType (yyt); yyIndentSelector ("PointerType"); yyt = yyt->Type.PointerType; break;
  default: goto yyExit;
  }
 }
yyExit:
 yyIndentLevel = yyLevel;
}

# define yyNil	0374
# define yyNoLabel	0375
# define yyLabelDef	0376
# define yyLabelUse	0377

static tType yyChild;

static void yyReleaseType
# if defined __STDC__ | defined __cplusplus
 (tType yyt)
# else
 (yyt) tType yyt;
# endif
{
 if (yyt == NoType) return;
 switch (yyt->Kind) {
case kTypes:
closetType (yyt->Types.Type)
closetType (yyt->Types.Next)
break;
case kType:
closetType (yyt->Type.Children)
closetType (yyt->Type.EquivType)
closetType (yyt->Type.VectorType)
closetType (yyt->Type.PointerType)
break;
 default: ;
 }

 if (-- yyt->yyHead.yyMark == 0) {
  switch (yyt->Kind) {
case kType:
closetTree (yyt->Type.Origin)
closetType (yyt->Type.Parent)
closeint (yyt->Type.Number)
closeint (yyt->Type.Gen)
closeint (yyt->Type.Used)
closeint (yyt->Type.Printed)
break;
  default: ;
  }
  yyFREE (yyt, Type_NodeSize [yyt->Kind])
 }
}

void ReleaseType
# if defined __STDC__ | defined __cplusplus
 (tType yyt)
# else
 (yyt) tType yyt;
# endif
{
 yyMark (yyt);
 yyReleaseType (yyt);
}

static Type_tProcTree yyProc;

static void yyTraverseTypeTD
# if defined __STDC__ | defined __cplusplus
 (tType yyt)
# else
 (yyt) tType yyt;
# endif
{
 for (;;) {
  if (yyt == NoType || yyt->yyHead.yyMark == 0) return;
  yyt->yyHead.yyMark = 0;
  yyProc (yyt);

  switch (yyt->Kind) {
case kTypes:
yyTraverseTypeTD (yyt->Types.Type);
yyt = yyt->Types.Next; break;
case kType:
yyTraverseTypeTD (yyt->Type.Children);
yyTraverseTypeTD (yyt->Type.EquivType);
yyTraverseTypeTD (yyt->Type.VectorType);
yyt = yyt->Type.PointerType; break;
  default: return;
  }
 }
}

void TraverseTypeTD
# if defined __STDC__ | defined __cplusplus
 (tType yyt, Type_tProcTree yyyProc)
# else
 (yyt, yyyProc) tType yyt; Type_tProcTree yyyProc;
# endif
{
 yyMark (yyt);
 yyProc = yyyProc;
 yyTraverseTypeTD (yyt);
}

static void yyTraverseTypeBU
# if defined __STDC__ | defined __cplusplus
 (tType yyt)
# else
 (yyt) tType yyt;
# endif
{
 if (yyt == NoType || yyt->yyHead.yyMark == 0) return;
 yyt->yyHead.yyMark = 0;

 switch (yyt->Kind) {
case kTypes:
yyTraverseTypeBU (yyt->Types.Type);
yyTraverseTypeBU (yyt->Types.Next); break;
case kType:
yyTraverseTypeBU (yyt->Type.Children);
yyTraverseTypeBU (yyt->Type.EquivType);
yyTraverseTypeBU (yyt->Type.VectorType);
yyTraverseTypeBU (yyt->Type.PointerType); break;
 default: ;
 }
 yyProc (yyt);
}

void TraverseTypeBU
# if defined __STDC__ | defined __cplusplus
 (tType yyt, Type_tProcTree yyyProc)
# else
 (yyt, yyyProc) tType yyt; Type_tProcTree yyyProc;
# endif
{
 yyMark (yyt);
 yyProc = yyyProc;
 yyTraverseTypeBU (yyt);
}

# define yyInitOldToNewStoreSize 32

typedef struct { tType yyOld, yyNew; } yytOldToNew;
static unsigned long yyOldToNewStoreSize = yyInitOldToNewStoreSize;
static yytOldToNew yyOldToNewStore [yyInitOldToNewStoreSize];
static yytOldToNew * yyOldToNewStorePtr = yyOldToNewStore;
static int yyOldToNewCount;

static void yyStoreOldToNew
# if defined __STDC__ | defined __cplusplus
 (tType yyOld, tType yyNew)
# else
 (yyOld, yyNew) tType yyOld, yyNew;
# endif
{
 if (++ yyOldToNewCount == yyOldToNewStoreSize)
  ExtendArray ((char * *) & yyOldToNewStorePtr, & yyOldToNewStoreSize, sizeof (yytOldToNew));
 yyOldToNewStorePtr [yyOldToNewCount].yyOld = yyOld;
 yyOldToNewStorePtr [yyOldToNewCount].yyNew = yyNew;
}

static tType yyMapOldToNew
# if defined __STDC__ | defined __cplusplus
 (tType yyOld)
# else
 (yyOld) tType yyOld;
# endif
{
 register int yyi;
 for (yyi = 1; yyi <= yyOldToNewCount; yyi ++)
  if (yyOldToNewStorePtr [yyi].yyOld == yyOld) return yyOldToNewStorePtr [yyi].yyNew;
 return NoType;
}

static void yyCopyType
# if defined __STDC__ | defined __cplusplus
 (tType yyt, yyPtrtTree yyNew)
# else
 (yyt, yyNew) tType yyt; yyPtrtTree yyNew;
# endif
{
 for (;;) {
  if (yyt == NoType) { * yyNew = NoType; return; }
  if (yyt->yyHead.yyMark == 0) { * yyNew = yyMapOldToNew (yyt); return; }
  yyALLOC (* yyNew, Type_NodeSize [yyt->Kind])
  if (yyt->yyHead.yyMark > 1) { yyStoreOldToNew (yyt, * yyNew); }
  yyt->yyHead.yyMark = 0;

  switch (yyt->Kind) {
case kTypes: (* yyNew)->Types = yyt->Types;
copytType ((* yyNew)->Types.Type, yyt->Types.Type)
yyt = yyt->Types.Next;
yyNew = & (* yyNew)->Types.Next; break;
case kType: (* yyNew)->Type = yyt->Type;
copytTree ((* yyNew)->Type.Origin, yyt->Type.Origin)
copytType ((* yyNew)->Type.Parent, yyt->Type.Parent)
copyint ((* yyNew)->Type.Number, yyt->Type.Number)
copytType ((* yyNew)->Type.Children, yyt->Type.Children)
copyint ((* yyNew)->Type.Gen, yyt->Type.Gen)
copyint ((* yyNew)->Type.Used, yyt->Type.Used)
copyint ((* yyNew)->Type.Printed, yyt->Type.Printed)
copytType ((* yyNew)->Type.EquivType, yyt->Type.EquivType)
copytType ((* yyNew)->Type.VectorType, yyt->Type.VectorType)
yyt = yyt->Type.PointerType;
yyNew = & (* yyNew)->Type.PointerType; break;
  default: ;
  }
 }
}

tType CopyType
# if defined __STDC__ | defined __cplusplus
 (tType yyt)
# else
 (yyt) tType yyt;
# endif
{
 tType yyNew;
 yyMark (yyt);
 yyOldToNewCount = 0;
 yyCopyType (yyt, & yyNew);
 return yyNew;
}

# define yyyWrite	1
# define yyyRead	2
# define yyyQuit	3

static char yyyString [32], yyCh;
static int yyLength, yyState;

static bool yyyIsEqual
# if defined __STDC__ | defined __cplusplus
 (char * yya)
# else
 (yya) char * yya;
# endif
{
 register int yyi;
 if (yyLength >= 0 && yyyString [yyLength] == ' ') {
  if (yyLength != strlen (yya)) return false;
  for (yyi = 0; yyi < yyLength; yyi ++)
   if (yyyString [yyi] != yya [yyi]) return false;
 } else {
  if (yyLength >= strlen (yya)) return false;
  for (yyi = 0; yyi <= yyLength; yyi ++)
   if (yyyString [yyi] != yya [yyi]) return false;
 }
 return true;
}

void QueryType
# if defined __STDC__ | defined __cplusplus
 (tType yyt)
# else
 (yyt) tType yyt;
# endif
{
 yyState = yyyWrite;
 for (;;) {
  switch (yyState) {
  case yyyQuit : return;
  case yyyWrite: WriteTypeNode (stdout, yyt); yyState = yyyRead;
  case yyyRead : (void) printf ("? "); yyLength = -1; yyCh = getc (stdin);
   while (yyCh != '\n' && yyCh > 0)
    { yyyString [++ yyLength] = yyCh; yyCh = getc (stdin); }
   if (yyCh < 0) { (void) fputs ("QueryTree: eof reached\n", stderr);
    yyState = yyyQuit; return; }
   if      (yyyIsEqual ("parent")) { yyState = yyyWrite; return; }
   else if (yyyIsEqual ("quit"  )) { yyState = yyyQuit ; return; }
   else if (yyt != NoType) {
    switch (yyt->Kind) {
case kTypes: if (false) ;
else if (yyyIsEqual ("Type")) QueryType (yyt->Types.Type);
else if (yyyIsEqual ("Next")) QueryType (yyt->Types.Next);
break;
case kType: if (false) ;
else if (yyyIsEqual ("Children")) QueryType (yyt->Type.Children);
else if (yyyIsEqual ("EquivType")) QueryType (yyt->Type.EquivType);
else if (yyyIsEqual ("VectorType")) QueryType (yyt->Type.VectorType);
else if (yyyIsEqual ("PointerType")) QueryType (yyt->Type.PointerType);
break;
    default: ;
    }
   }
  }
 }
}

void BeginType ()
{
}

void CloseType ()
{
}
