#ifndef MPC_RTS
#define MPC_RTS

#define MAX_DISPMSG_SIZE 8

/******************** offsets for MPC_ERRHEAD message ************************/
#define MSG_LINE              0
#define MSG_COLUMN            1
#define MSG_FILENAME_LENGTH   2
#define MSG_ERRMSG_LENGTH     3

/******************** offsets for MPC_PRINTFHEAD message *********************/
#define MSG_PRINTF_LENGTH     0

/******************** offsets for MPC_ENDWORK message ************************/
#define MSG_EXITCODE          0

/******************** offsets for MPC_CREATENET message **********************/

#define MSG_NETNAME           0
#define MSG_TOPOLEN           1
#define MSG_PARAMLEN          2
#define MSG_PARENTRANK        3
#define MSG_POWER             4
#define MSG_ISSTATIC          5

/******************** offsets for MPC_BURSTCREATE message ********************/
#define MSG_BURSTNUMBER       0

/******************** offsets for MPC_FREENET message ************************/
#define MSG_LEADER            0
#define MSG_COUNTTOFREE       1

/******************** offsets for MPC_WAITBEGIN message **********************/
#define MSG_NETSTOFREE        0
#define MSG_NETSTOCREATE      1

/******************** offsets for the dispatcher messages ********************/
#define DSP_CMD               0
#define DSP_RANK              1
#define DSP_NAME              2
#define DSP_PARENT            3
#define DSP_PARAMLEN          4
#define DSP_LEADER            1
#define DSP_RUNOUT            2

/******************** offsets for the Set/Update processors'info messages ****/
#define MSG_SET_UPDATE        0

/*****************************************************************************/
#define MPC_NULL_LEADER      -1

/*****************************************************************************/
#endif
