/******************************************************/
#ifndef _MPC_TTOPO
#define _MPC_TTOPO
#include "mpCinternal.h"

Int MPC_Trivial_free_topology(MPC_Net* net);

Int MPC_Trivial_topology_data(
  MPC_Net* net,          
  Int *plenght,
  MPC_Topology *atopology,
  MPC_Topology_free *afreetopology);

Int MPC_Trivial_init_strategy(void);

Int MPC_Trivial_strategy(
  MPC_Node parent,       
  Int parent_rank,       
  Int power,             
  Int topology_length,   
  MPC_Topology topology, 
  Int total_nodes,       
  Int* map );
             
Int MPC_Trivial_processors_info(
  Int* num_of_processors,
  double** relative_performance );

Int MPC_Trivial_get_env( 
  Int power, 
  char *rtopofile,
  Int* penv_length, 
  Int** penvironment,
  Int node_table_size,
  Int *np_node_map,
  char (*node_table)[MPC_MAX_PROCESSOR_NAME]
);

#endif
