/*****************************************************************************/
/* mpCtype.h - MPC_Rts_datatype constructors.                                */
/* Coded by Dm. Arapov for A.Lastovtsky 1995-1996                            */
/* Release 1.10.96                                                           */
/*****************************************************************************/
#ifndef _MPC_TYPE
#define _MPC_TYPE
#include "mpCinternal.h"
#include "mpCtree.h"
  
Int MPC_Datatype_array(
  Int count,
  Int stride,
  MPC_Datatype elemtype,
  MPC_Rts_datatype* pnewtype );

Int MPC_Datatype_record(
  Int count,
  const MPC_Datatype* datatypes,
  MPC_Rts_datatype* pnewtype );

Int iMPC_Type_commit( MPC_Rts_datatype * pdatatype );

Int MPC_Type_free(MPC_Rts_datatype* pdatatype);

MPC_Rts_datatype MPC_Get_element_type(MPC_Datatype datatype);
#endif
