SCANNER mpcScan
EXPORT	{

/* set of keywords: */


#include "Tree.h"
#include "context.h"
#include "options.h"
#include "mpc_diag.h"
#include "mpc_pass1.h"

#ifdef __WRK

#  include "c2mpC.h"

bool EmptyHeader;
#else
bool EmptyHeader;
#endif

extern int LinesInFile;

/* extern int NativeMode; -- declared in mpc_pass1.h and defined in make_ast.h; */

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; tIdent Ident; } yyIDENTIFIER;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; tIdent Ident; } yyNETorSUBNETname;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; tIdent Ident; } yyTYPEDEFname;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; double FloatConst; } yyFLOATINGconstant;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; int IntConst; } yyINTEGERconstant;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; int OctConst; } yyOCTALconstant;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; int HexConst; } yyHEXconstant;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; int CharConst; } yyCHARACTERconstant;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; tString StrLit; } yySTRINGliteral;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; } yyHEADER;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; short Length; } yySOURCE;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; } yyOMP_DECL;
typedef struct { tPosition yyPos; tString SymForm; bool Ignore; } yyOMP_STAT;
typedef struct { tPosition yyPos; bool Ignore; } yybench;
typedef struct { tPosition yyPos; bool Ignore; } yycoord;
typedef struct { tPosition yyPos; bool Ignore; } yycoordof;
typedef struct { tPosition yyPos; bool Ignore; } yyfan;
typedef struct { tPosition yyPos; bool Ignore; } yyfast;
typedef struct { tPosition yyPos; bool Ignore; } yyflex;
typedef struct { tPosition yyPos; bool Ignore; } yyhost;
typedef struct { tPosition yyPos; bool Ignore; } yylength;
typedef struct { tPosition yyPos; bool Ignore; } yylink;
typedef struct { tPosition yyPos; bool Ignore; } yymemory;
typedef struct { tPosition yyPos; bool Ignore; } yynet;
typedef struct { tPosition yyPos; bool Ignore; } yynettype;
typedef struct { tPosition yyPos; bool Ignore; } yynode;
typedef struct { tPosition yyPos; bool Ignore; } yyparent;
typedef struct { tPosition yyPos; bool Ignore; } yyrecon;
typedef struct { tPosition yyPos; bool Ignore; } yyrelation;
typedef struct { tPosition yyPos; bool Ignore; } yyrepl;
typedef struct { tPosition yyPos; bool Ignore; } yyscalar;
typedef struct { tPosition yyPos; bool Ignore; } yyslow;
typedef struct { tPosition yyPos; bool Ignore; } yysubnet;
typedef struct { tPosition yyPos; bool Ignore; } yyvector;
typedef struct { tPosition yyPos; bool Ignore; } yypar;
typedef struct { tPosition yyPos; bool Ignore; } yyscheme;
typedef struct { tPosition yyPos; bool Ignore; } yytimeof;

typedef union {
 tPosition Position;
 yyIDENTIFIER IDENTIFIER;
 yyNETorSUBNETname NETorSUBNETname;
 yyTYPEDEFname TYPEDEFname;
 yyFLOATINGconstant FLOATINGconstant;
 yyINTEGERconstant INTEGERconstant;
 yyOCTALconstant OCTALconstant;
 yyHEXconstant HEXconstant;
 yyCHARACTERconstant CHARACTERconstant;
 yySTRINGliteral STRINGliteral;
 yyHEADER HEADER;
 yySOURCE SOURCE;
 yyOMP_DECL OMP_DECL;
 yyOMP_STAT OMP_STAT;
 yybench bench;
 yycoord coord;
 yycoordof coordof;
 yyfan fan;
 yyfast fast;
 yyflex flex;
 yyhost host;
 yylength length;
 yylink link;
 yymemory memory;
 yynet net;
 yynettype nettype;
 yynode node;
 yyparent parent;
 yyrecon recon;
 yyrelation relation;
 yyrepl repl;
 yyscalar scalar;
 yyslow slow;
 yysubnet subnet;
 yyvector vector;
 yypar par;
 yyscheme scheme;
 yytimeof timeof;
} mpcScan_tScanAttribute;

extern void mpcScan_ErrorAttribute ARGS((int Token, mpcScan_tScanAttribute * pAttribute));

}

GLOBAL {

    /* Copyright (C) 1993 Ilya N. Ledovskikh, All rights reserved.
       Portions Copyright (C) 1989,1990 James A. Roskind.          */

# include <string.h>
# include <errno.h>
# include <stdlib.h>


void mpcScan_ErrorAttribute
# if defined __STDC__ | defined __cplusplus
 (int Token, mpcScan_tScanAttribute * pAttribute)
# else
 (Token, pAttribute) int Token; mpcScan_tScanAttribute * pAttribute;
# endif
{
 pAttribute->Position = mpcScan_Attribute.Position;
 switch (Token) {
 case /* IDENTIFIER */ 1: 
 pAttribute->IDENTIFIER.SymForm=NULL;
 pAttribute->IDENTIFIER.Ignore=YES;
 pAttribute->IDENTIFIER.Length=0;
 ;
 pAttribute->IDENTIFIER.Ident=NoIdent;
 ;
 break;
 case /* NETorSUBNETname */ 2: 
 pAttribute->NETorSUBNETname.SymForm=NULL;
 pAttribute->NETorSUBNETname.Ignore=YES;
 pAttribute->NETorSUBNETname.Length=0;
 ;
 pAttribute->NETorSUBNETname.Ident=NoIdent;
 ;
 break;
 case /* TYPEDEFname */ 3: 
 pAttribute->TYPEDEFname.SymForm=NULL;
 pAttribute->TYPEDEFname.Ignore=YES;
 pAttribute->TYPEDEFname.Length=0;
 ;
 pAttribute->TYPEDEFname.Ident=NoIdent;
 ;
 break;
 case /* FLOATINGconstant */ 4: 
 pAttribute->FLOATINGconstant.SymForm=NULL;
 pAttribute->FLOATINGconstant.Ignore=YES;
 pAttribute->FLOATINGconstant.Length=0;
 ;
 pAttribute->FLOATINGconstant.FloatConst=0.0;
 ;
 break;
 case /* INTEGERconstant */ 5: 
 pAttribute->INTEGERconstant.SymForm=NULL;
 pAttribute->INTEGERconstant.Ignore=YES;
 pAttribute->INTEGERconstant.Length=0;
 ;
 pAttribute->INTEGERconstant.IntConst=0;
 ;
 break;
 case /* OCTALconstant */ 6: 
 pAttribute->OCTALconstant.SymForm=NULL;
 pAttribute->OCTALconstant.Ignore=YES;
 pAttribute->OCTALconstant.Length=0;
 ;
 pAttribute->OCTALconstant.OctConst=0;
 ;
 break;
 case /* HEXconstant */ 7: 
 pAttribute->HEXconstant.SymForm=NULL;
 pAttribute->HEXconstant.Ignore=YES;
 pAttribute->HEXconstant.Length=0;
 ;
 pAttribute->HEXconstant.HexConst=0;
 ;
 break;
 case /* CHARACTERconstant */ 8: 
 pAttribute->CHARACTERconstant.SymForm=NULL;
 pAttribute->CHARACTERconstant.Ignore=YES;
 pAttribute->CHARACTERconstant.Length=0;
 ;
 pAttribute->CHARACTERconstant.CharConst=0;
 ;
 break;
 case /* STRINGliteral */ 9: 
 pAttribute->STRINGliteral.SymForm=NULL;
 pAttribute->STRINGliteral.Ignore=YES;
 pAttribute->STRINGliteral.Length=0;
 ;
 pAttribute->STRINGliteral.StrLit=NULL;
 ;
 break;
 case /* HEADER */ 10: 
 pAttribute->HEADER.SymForm=NULL;
 pAttribute->HEADER.Ignore=YES;
 pAttribute->HEADER.Length=0;
 ;
 break;
 case /* SOURCE */ 11: 
 pAttribute->SOURCE.SymForm=NULL;
 pAttribute->SOURCE.Ignore=YES;
 pAttribute->SOURCE.Length=0;
 ;
 break;
 case /* OMP_DECL */ 12: 
 pAttribute->OMP_DECL.SymForm=NULL;
 pAttribute->OMP_DECL.Ignore=YES;
 ;
 break;
 case /* OMP_STAT */ 13: 
 pAttribute->OMP_STAT.SymForm=NULL;
 pAttribute->OMP_STAT.Ignore=YES;
 ;
 break;
 case /* bench */ 14: 
pAttribute->bench.Ignore=true;
 break;
 case /* coord */ 15: 
pAttribute->coord.Ignore=true;
 break;
 case /* coordof */ 16: 
pAttribute->coordof.Ignore=true;
 break;
 case /* fan */ 17: 
pAttribute->fan.Ignore=true;
 break;
 case /* fast */ 18: 
pAttribute->fast.Ignore=true;
 break;
 case /* flex */ 19: 
pAttribute->flex.Ignore=true;
 break;
 case /* host */ 20: 
pAttribute->host.Ignore=true;
 break;
 case /* length */ 21: 
pAttribute->length.Ignore=true;
 break;
 case /* link */ 22: 
pAttribute->link.Ignore=true;
 break;
 case /* memory */ 23: 
pAttribute->memory.Ignore=true;
 break;
 case /* net */ 24: 
pAttribute->net.Ignore=true;
 break;
 case /* nettype */ 25: 
pAttribute->nettype.Ignore=true;
 break;
 case /* node */ 26: 
pAttribute->node.Ignore=true;
 break;
 case /* parent */ 27: 
pAttribute->parent.Ignore=true;
 break;
 case /* recon */ 28: 
pAttribute->recon.Ignore=true;
 break;
 case /* relation */ 29: 
pAttribute->relation.Ignore=true;
 break;
 case /* repl */ 30: 
pAttribute->repl.Ignore=true;
 break;
 case /* scalar */ 31: 
pAttribute->scalar.Ignore=true;
 break;
 case /* slow */ 32: 
pAttribute->slow.Ignore=true;
 break;
 case /* subnet */ 33: 
pAttribute->subnet.Ignore=true;
 break;
 case /* vector */ 34: 
pAttribute->vector.Ignore=true;
 break;
 case /* par */ 35: 
pAttribute->par.Ignore=true;
 break;
 case /* scheme */ 36: 
pAttribute->scheme.Ignore=true;
 break;
 case /* timeof */ 37: 
pAttribute->timeof.Ignore=true;
 break;
 }
}



int LinesInFile = 0;

int  isaTYPE(tIdent Ident) {
  tTree tree;
  int res;
  if(tree=Find_Ident(Ident, IDENT)) {
    res = Tree_IsType(tree, kMPC_Typedef);
    return res;
  }
  return 0;
}

int  isaNET(tIdent Ident) {
  tTree tree;
  int res;
  if(tree=Find_Ident(Ident, IDENT)) {
    res = Tree_IsType(tree, kMPC_NetOrSubnet);
    return res;
  }
  return 0;
}

int Treat_As_Ident(void) {
  char Word[32];
  int length;
  length = mpcScan_GetWord (Word);
  mpcScan_Attribute.IDENTIFIER.Ignore = NO;
  mpcScan_Attribute.IDENTIFIER.Ident =
    MakeIdent (Word, length);
  if(isaTYPE (mpcScan_Attribute.IDENTIFIER.Ident)) {
    return 3;
  }
  else if(isaNET(mpcScan_Attribute.IDENTIFIER.Ident)) {
    return 2;
  }
  else {
    return 1;
  }

}

# define MAX_BYTE_VALUE 256    /** tmp-definition!!! **/

static int Get_Oct_Code(char *Image, int *Next_Char_Index)
{
  int code=0, i;
  for(i=0; i<3; i++){
    switch( *(Image + i) ){
      case '0': code = code * 8; break;
      case '1': code = code * 8 + 1; break;
      case '2': code = code * 8 + 2; break;
      case '3': code = code * 8 + 3; break;
      case '4': code = code * 8 + 4; break;
      case '5': code = code * 8 + 5; break;
      case '6': code = code * 8 + 6; break;
      case '7': code = code * 8 + 7; break;
      default: goto DONE;
    }
  }
  DONE: *Next_Char_Index += i;
  return code;
}

static int Get_Hex_Code(char *Image, int *Next_Char_Index)
{
  int code=0, i;
  for(i=0; i<3; i++){
    switch( *(Image + i) ){
      case '0': code = code * 16; break;
      case '1': code = code * 16 + 1; break;
      case '2': code = code * 16 + 2; break;
      case '3': code = code * 16 + 3; break;
      case '4': code = code * 16 + 4; break;
      case '5': code = code * 16 + 5; break;
      case '6': code = code * 16 + 6; break;
      case '7': code = code * 16 + 7; break;
      case '8': code = code * 16 + 8; break;
      case '9': code = code * 16 + 9; break;
      case 'a':
      case 'A': code = code * 16 + 10; break;
      case 'b':
      case 'B': code = code * 16 + 11; break;
      case 'c':
      case 'C': code = code * 16 + 12; break;
      case 'd':
      case 'D': code = code * 16 + 13; break;
      case 'e':
      case 'E': code = code * 16 + 14; break;
      case 'f':
      case 'F': code = code * 16 + 15; break;
      default: goto DONE;
    }
  }
  DONE: *Next_Char_Index += i;
  return code;
}

static int Str_to_Char (char *Image, tPosition Position)
{
  int value=0, index=1 /* first character after \'; */;

  while(Image[index] && Image[index]!='\''){
    switch(Image[index]){
      case '\\':
	switch(Image[++index]){
	  case '\'': value = MAX_BYTE_VALUE*value + '\''; index++; break;
	  case '"' : value = MAX_BYTE_VALUE*value + '"';  index++; break;
	  case '?' : value = MAX_BYTE_VALUE*value + '?';  index++; break;
	  case '\\': value = MAX_BYTE_VALUE*value + '\\'; index++; break;
	  case 'a' : value = MAX_BYTE_VALUE*value + '\a'; index++; break;
	  case 'b' : value = MAX_BYTE_VALUE*value + '\b'; index++; break;
	  case 'f' : value = MAX_BYTE_VALUE*value + '\f'; index++; break;
	  case 'n' : value = MAX_BYTE_VALUE*value + '\n'; index++; break;
	  case 'r' : value = MAX_BYTE_VALUE*value + '\r'; index++; break;
	  case 't': value = MAX_BYTE_VALUE*value + '\t'; index++; break;
	  case 'v': value = MAX_BYTE_VALUE*value + '\v'; index++; break;
	  default:
	    if(Image[index]>='0' && Image[index]<='7') {  /* octal code: */
	      value = MAX_BYTE_VALUE*value +
			Get_Oct_Code(Image+index, &index);
	    }
	    else if(Image[index]=='x')
	      value = MAX_BYTE_VALUE*value +
			Get_Hex_Code(Image + ++index, &index);
	    else
	      Make_Message(50, xxError, Position, NoTree); break;
		/* "Invalid escape sequence in character constant" */
	}
	break;
      default:
	value = MAX_BYTE_VALUE*value + Image[index++];
    }
  }
  return value;
}

}

LOCAL   {

#define MAX_TOKEN_LENGTH 2048

          char Word[MAX_TOKEN_LENGTH]; 
	  short length;
	  char OMP_prefix[]="#pragma omp ";
          const short OMP_prefix_length=12;
	  int index;
	  tPosition Pos;
	  static tString CurrentFileName;
#ifdef __CB_COMPILER__
	  bool EmptyHeader;   /* only for correct compilation of scanner... */
#endif
}

DEFAULT	{
  Make_MessageI(51, xxError, mpcScan_Attribute.Position, xxCharacter, mpcScan_TokenPtr, NoTree);
		/* "Illegal character" */
  /********
  switch(yyStartState) {
    case comment: printf("---- comment ----\n"); break;
    case linecomment: printf("---- linecomment ----\n"); break;
    case position: printf("---- position ----\n"); break;
    case file: printf("---- file ----\n"); break;
    case pragma: printf("---- pragma ----\n"); break;
    case keywords: printf("---- keywords ----\n"); break;
    case native: printf("---- native ----\n"); break;
    case unused: printf("---- unused ----\n"); break;
    default: printf("---- STD ----\n"); break;
  }*******/

  if(yyStartState==position || yyStartState==pragma || yyStartState==unused) {
    Make_Message(52, xxInformation, mpcScan_Attribute.Position, NoTree);
		/* "Maybe your 'cpp' don't allows some ANSI C facilities" */
    Print_Messages();
    exit(1);
  }
}

EOF     { if( yyStartState == comment )
            Make_Message(53, xxError, mpcScan_Attribute.Position, NoTree);
		/* "Unclosed comment" */
}

DEFINE
   allch		= - {\n} .
   blank                =   {" "\t} .
   commentch            = - {$*\t\n} .
   identifier		= {a-zA-Z_}{0-9a-zA-Z_}* .
   exponent_part	= {eE}{\-+}?{0-9}+ .
   fractional_constant	= ({0-9}*"."{0-9}+)|({0-9}+".") .
   floating_constant	= ((fractional_constant exponent_part ?)|({0-9}+ exponent_part)){FfLl}? .
   integer_suffix_opt	= ({uU}?{lL}?)|({lL}{uU}) .
   decimal_constant	= {1-9}{0-9}* integer_suffix_opt .
   octal_constant	= "0"{0-7}* integer_suffix_opt .
   hex_constant		= "0"{xX}{0-9a-fA-F}+ integer_suffix_opt .
   simple_escape	= {abfnrtv'"?\\} .
   octal_escape		= {0-7}[1-3] .
   hex_escape		= "x"{0-9a-fA-F}+ .
   escape_sequence	= \\ ( simple_escape | octal_escape | hex_escape) .
   c_char		= - {'\\\n}| escape_sequence .
   s_char		= - {"\\\n}| escape_sequence .

START  comment linecomment pseudocomment
       position file pragma openmp header
       keywords native unused

RULE

           "/*"  : { yyStart(comment); }
#comment#  "*/"  : { yyStart(STD); }
#comment#  {*\t} | commentch + : {}
#comment#  {\n}  : {yyEol(0); LinesInFile++; }
/***/
#comment#  "$trace:"  :- { yyStart(pseudocomment); }
/***/
#comment#  "$"   : {}

               "//"  : { yyStart(linecomment); }
#linecomment#  \n    : { yyEol(0); yyStart(STD); LinesInFile++; }
#linecomment#  {*\t} | commentch +  : {}

/***
                 "/*"blank*"$trace:"  :- { yyStart(pseudocomment); }
***/
#pseudocomment#  "*/"         :- { yyStart(STD);}
#pseudocomment#  {\n}         :- { yyEol(0); LinesInFile++; }
#pseudocomment#  {*\t} | commentch +  :- {
		   length = mpcScan_GetWord(Word);
		   mpcScan_Attribute.OMP_STAT.Ignore = NO;  /* dirty trick, this is not OMP */
		   mpcScan_Attribute.OMP_STAT.SymForm = (tString)malloc(length);
		   (void)strcpy(mpcScan_Attribute.OMP_STAT.SymForm,Word);
                   return 13;
                 }

		"#ident"	:- { yyStart(unused); }
		"#pragma"	:  { yyStart(pragma); yyLineCount++; }
	   	"#"		: { yyStart(position); }
#position# \n			: { yyStart(STD); }
#position# decimal_constant	: {
		length = mpcScan_GetWord(Word);
		Pos.Line = atoi(Word);
		LinesInFile = Pos.Line-1;
		Pos.Column = 1;
		yyStart(file);
}
#file#     \n			: {
		mpcScan_Attribute.Position.Line = ++yyLineCount;
		New_SourceFile(CurrentFileName,
			       mpcScan_Attribute.Position, Pos);
		yyStart(STD);
}
#file#     \" s_char * \"	: {
		tString s;

		length = mpcScan_GetWord(Word);
		mpcScan_Attribute.Position.Line = ++yyLineCount;
		mpcScan_Attribute.Position.Column += length;/**********/
	/*printf("#include file: %d %d\n", mpcScan_Attribute.Position.Line, mpcScan_Attribute.Position.Column);******/
		s = (tString)malloc(length+1);
		for(index=0;index<length;index++) *(s+index) = Word[index];
		*(s+length) = '\0';
		New_SourceFile(s, mpcScan_Attribute.Position, Pos);
		CurrentFileName = s;
		yyStart(unused);
}
#position# " " +		: {}
#file#	   (" " | \t) +		: {}

#unused#   allch * \n		:- { yyStart(STD);
				     if(Pos.Line>LinesInFile+1) {
					LinesInFile++;
				     }
                                   }

#pragma#	identifier	:- {
				     length = mpcScan_GetWord(Word);
				     if(!strcmp(Word,"keywords"))
				       {yyStart(keywords);}
				     else if(!strcmp(Word,"native"))
				       {yyStart(native);}
				     else if(!strcmp(Word,"omp"))
				       {yyStart(openmp);}

# ifdef __WRK
#  ifndef __CB_COMPILER__
				     else if(!strcmp(Word,"header")) {
					C_2_MPC_SOURCE = false;
					//HEADER_NAME_GENERATED = false;
					//EmptyHeader = true;
					yyStart(header);
				     }
				     else if(!strcmp(Word,"source")) {
					C_2_MPC_SOURCE = true;
					//PRAGMA_SOURCE_GENERATED = false;
					yyStart(unused);
					return 11;
				     }
#  endif
# endif

				     else
				       {yyStart(unused);}
				   }
#openmp#  allch * \n            :- {
				     bool omp_decl=false;
				     short i;
				     length = mpcScan_GetWord(Word);
				     for(i=0;i<length && !isalpha(Word[i]);i++);
				     if(!strncmp(Word+i,"threadprivate",13))
				       omp_decl = true;
				     mpcScan_Attribute.OMP_DECL.Ignore = NO;
				     mpcScan_Attribute.OMP_DECL.SymForm = (tString)malloc(OMP_prefix_length + length);
				     (void)strcpy(mpcScan_Attribute.OMP_DECL.SymForm,OMP_prefix);
				     (void)strcat(mpcScan_Attribute.OMP_DECL.SymForm,Word);
				     LinesInFile++;

				     yyStart(STD);
				     if(omp_decl)
				       return 12;
                                     else
				       return 13;
				   }

#keywords#	"ANSI"		:- { KEYWORDS = K_ANSI; yyStart(unused); }
#keywords#	"SHORT"		:- { KEYWORDS = K_SHORT; yyStart(unused); }
#keywords#	"LONG"		:- { KEYWORDS = K_LONG; yyStart(unused); }
#keywords#	"ALL"		:- { KEYWORDS = K_ALL; yyStart(unused); }

#native#	"mpC"		:- { NativeMode = NATIVE_MPC; yyStart(unused); }
#native#	"C[]"		:- { NativeMode = NATIVE_CBR; yyStart(unused); }
#native#	"C"		:- { NativeMode = NATIVE_C; yyStart(unused); }

#header#     \" s_char * \" | \< s_char * \>	: {
#ifdef __WRK

#  ifndef __CB_COMPILER__
		tString s;

		length = mpcScan_GetWord(Word);
		mpcScan_Attribute.Position.Line = ++yyLineCount;
		mpcScan_Attribute.Position.Column += length;/**********/
		s = (tString)malloc(length+1);
		for(index=0;index<length;index++) *(s+index) = Word[index];
		*(s+length) = '\0';
		mpcScan_Attribute.HEADER.SymForm = s;
		//CurrentHeaderName = s;
		yyStart(unused);
		return 10;
#  endif

#endif
}

/**********************
#position# ","			:- { yyStart(column); }
#column#   decimal_constant	:- {
		length = mpcScan_GetWord(Word);
		mpcScan_Attribute.Position.Column = atoi(Word);
}
#column#  \n			:- {yyStart(STD);}
#column#  " " +			:- {}
**********************/

 #STD#\[	: { return 38; }
 #STD#\]	: { return 39; }
 #STD#\[\*\]	: { return 40; }
 #STD#\(	: { return 41; }
 #STD#\,	: { return 42; }
 #STD#\)	: { return 43; }
 #STD#\:	: { return 44; }
 #STD#\[\]	: { return 45; }
 #STD#\.	: { return 46; }
 #STD#\-\>	: { return 47; }
 #STD#\+\+	: { return 48; }
 #STD#\-\-	: { return 49; }
 #STD#\[\?\<\]	: { return 50; }
 #STD#\[\?\>\]	: { return 51; }
 #STD#\[\+\]	: { return 52; }
 #STD#\[\&\]	: { return 53; }
 #STD#\[\^\]	: { return 54; }
 #STD#\[\|\]	: { return 55; }
 #STD#\[\&\&\]	: { return 56; }
 #STD#\[\|\|\]	: { return 57; }
 #STD#\[\<	: { return 58; }
 #STD#\>\]	: { return 59; }
 #STD#\[\>	: { return 60; }
 #STD#\<\]	: { return 61; }
 #STD#\&	: { return 62; }
 #STD#\*	: { return 63; }
 #STD#\+	: { return 64; }
 #STD#\-	: { return 65; }
 #STD#\~	: { return 66; }
 #STD#\!	: { return 67; }
 #STD#sizeof	: { return 68; }
 #STD#mpc_sizeof	: { return 69; }
 #STD#void	: { return 70; }
 #STD#char	: { return 71; }
 #STD#short	: { return 72; }
 #STD#int	: { return 73; }
 #STD#long	: { return 74; }
 #STD#float	: { return 75; }
 #STD#double	: { return 76; }
 #STD#signed	: { return 77; }
 #STD#unsigned	: { return 78; }
 #STD#const	: { return 79; }
 #STD#volatile	: { return 80; }
 #STD#struct	: { return 81; }
 #STD#union	: { return 82; }
 #STD#\{	: { return 83; }
 #STD#typedef	: { return 84; }
 #STD#extern	: { return 85; }
 #STD#static	: { return 86; }
 #STD#auto	: { return 87; }
 #STD#register	: { return 88; }
 #STD#\/	: { return 89; }
 #STD#\%	: { return 90; }
 #STD#\?\<	: { return 91; }
 #STD#\?\>	: { return 92; }
 #STD#\<\<	: { return 93; }
 #STD#\>\>	: { return 94; }
 #STD#\<	: { return 95; }
 #STD#\>	: { return 96; }
 #STD#\<\=	: { return 97; }
 #STD#\>\=	: { return 98; }
 #STD#\=\=	: { return 99; }
 #STD#\!\=	: { return 100; }
 #STD#\^	: { return 101; }
 #STD#\|	: { return 102; }
 #STD#\&\&	: { return 103; }
 #STD#\|\|	: { return 104; }
 #STD#\?	: { return 105; }
 #STD#\;	: { return 106; }
 #STD#\}	: { return 107; }
 #STD#enum	: { return 108; }
 #STD#\=	: { return 109; }
 #STD#\.\.\.	: { return 110; }
 #STD#\*\=	: { return 111; }
 #STD#\/\=	: { return 112; }
 #STD#\%\=	: { return 113; }
 #STD#\+\=	: { return 114; }
 #STD#\-\=	: { return 115; }
 #STD#\<\<\=	: { return 116; }
 #STD#\>\>\=	: { return 117; }
 #STD#\&\=	: { return 118; }
 #STD#\^\=	: { return 119; }
 #STD#\|\=	: { return 120; }
 #STD#\<\-	: { return 121; }
 #STD#\@	: { return 122; }
 #STD#\@\@	: { return 123; }
 #STD#default	: { return 124; }
 #STD#\<\-\>	: { return 125; }
 #STD#case	: { return 126; }
 #STD#if	: { return 127; }
 #STD#else	: { return 128; }
 #STD#switch	: { return 129; }
 #STD#while	: { return 130; }
 #STD#do	: { return 131; }
 #STD#for	: { return 132; }
 #STD#goto	: { return 133; }
 #STD#continue	: { return 134; }
 #STD#break	: { return 135; }
 #STD#return	: { return 136; }
 #STD#\%\%	: { return 137; }


   /***** mpC - keywords : *****/

#STD# "bench"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.bench.Ignore = NO; 
					    return 14;
			    }
			  }
#STD# "mpc_bench"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.bench.Ignore = NO; 
					    return 14;
			    }
			  }

#STD# "coord"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.coord.Ignore = NO; 
					    return 15;
			    }
			  }
#STD# "mpc_coord"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.coord.Ignore = NO; 
					    return 15;
			    }
			  }

#STD# "coordof"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.coordof.Ignore = NO; 
					    return 16;
			    }
			  }
#STD# "mpc_coordof"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.coordof.Ignore = NO; 
					    return 16;
			    }
			  }

#STD# "fan"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.fan.Ignore = NO; 
					    return 17;
			    }
			  }
#STD# "mpc_fan"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.fan.Ignore = NO; 
					    return 17;
			    }
			  }

#STD# "fast"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.fast.Ignore = NO; 
					    return 18;
			    }
			  }
#STD# "mpc_fast"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.fast.Ignore = NO; 
					    return 18;
			    }
			  }

#STD# "flex"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.flex.Ignore = NO; 
					    return 19;
			    }
			  }
#STD# "mpc_flex"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.flex.Ignore = NO; 
					    return 19;
			    }
			  }

#STD# "host"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.host.Ignore = NO; 
					    return 20;
			    }
			  }
#STD# "mpc_host"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.host.Ignore = NO; 
					    return 20;
			    }
			  }

#STD# "length"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.length.Ignore = NO; 
					    return 21;
			    }
			  }
#STD# "mpc_length"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.length.Ignore = NO; 
					    return 21;
			    }
			  }

#STD# "link"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.link.Ignore = NO; 
					    return 22;
			    }
			  }
#STD# "mpc_link"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.link.Ignore = NO; 
					    return 22;
			    }
			  }

#STD# "memory"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.memory.Ignore = NO; 
					    return 23;
			    }
			  }
#STD# "mpc_memory"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.memory.Ignore = NO; 
					    return 23;
			    }
			  }

#STD# "net"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.net.Ignore = NO; 
					    return 24;
			    }
			  }
#STD# "mpc_net"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.net.Ignore = NO; 
					    return 24;
			    }
			  }

#STD# "nettype"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.nettype.Ignore = NO; 
					    return 25;
			    }
			  }
#STD# "mpc_nettype"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.nettype.Ignore = NO; 
					    return 25;
			    }
			  }

#STD# "algorithm"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.nettype.Ignore = NO; 
					    return 25;
			    }
			  }
#STD# "mpc_algorithm"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.nettype.Ignore = NO; 
					    return 25;
			    }
			  }

#STD# "node"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.node.Ignore = NO; 
					    return 26;
			    }
			  }
#STD# "mpc_node"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.node.Ignore = NO; 
					    return 26;
			    }
			  }



#STD# "par"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.par.Ignore = NO; 
					    return 35;
			    }
			  }
#STD# "mpc_par"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.par.Ignore = NO; 
					    return 35;
			    }
			  }


#STD# "parent"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.parent.Ignore = NO; 
					    return 27;
			    }
			  }
#STD# "mpc_parent"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.parent.Ignore = NO; 
					    return 27;
			    }
			  }

#STD# "recon"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.recon.Ignore = NO; 
					    return 28;
			    }
			  }
#STD# "mpc_recon"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.recon.Ignore = NO; 
					    return 28;
			    }
			  }

#STD# "relation"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.relation.Ignore = NO; 
					    return 29;
			    }
			  }
#STD# "mpc_relation"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.relation.Ignore = NO; 
					    return 29;
			    }
			  }

#STD# "repl"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.repl.Ignore = NO; 
					    return 30;
			    }
			  }
#STD# "mpc_repl"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.repl.Ignore = NO; 
					    return 30;
			    }
			  }

#STD# "scalar"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.scalar.Ignore = NO; 
					    return 31;
			    }
			  }
#STD# "mpc_scalar"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.scalar.Ignore = NO; 
					    return 31;
			    }
			  }



#STD# "scheme"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.scheme.Ignore = NO; 
					    return 36;
			    }
			  }
#STD# "mpc_scheme"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.scheme.Ignore = NO; 
					    return 36;
			    }
			  }


#STD# "slow"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.slow.Ignore = NO; 
					    return 32;
			    }
			  }
#STD# "mpc_slow"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.slow.Ignore = NO; 
					    return 32;
			    }
			  }

#STD# "subnet"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.subnet.Ignore = NO; 
					    return 33;
			    }
			  }
#STD# "mpc_subnet"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.subnet.Ignore = NO; 
					    return 33;
			    }
			  }



#STD# "timeof"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.timeof.Ignore = NO; 
					    return 37;
			    }
			  }
#STD# "mpc_timeof"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.timeof.Ignore = NO; 
					    return 37;
			    }
			  }


#STD# "vector"		: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_LONG:  return Treat_As_Ident();
			      case K_SHORT:
			      case K_ALL:   mpcScan_Attribute.vector.Ignore = NO; 
					    return 34;
			    }
			  }
#STD# "mpc_vector"	: { EmptyHeader = false;
			    switch(KEYWORDS) {
			      case K_ANSI:
			      case K_SHORT: return Treat_As_Ident();
			      case K_LONG:
			      case K_ALL:   mpcScan_Attribute.vector.Ignore = NO; 
					    return 34;
			    }
			  }

   /****************************/

#STD# identifier 	: { EmptyHeader = false;
			    mpcScan_Attribute.IDENTIFIER.Length =
			    		length = mpcScan_GetWord (Word);
			    mpcScan_Attribute.IDENTIFIER.Ignore = NO;
                            mpcScan_Attribute.IDENTIFIER.Ident =
					 MakeIdent (Word, length);
			    if (isaTYPE (
				mpcScan_Attribute.IDENTIFIER.Ident)) {
                                return 3;
			    }
                            else if(isaNET(
				    mpcScan_Attribute.IDENTIFIER.Ident)) {
				    return 2;
			    }
			    else {
				return 1;
			    }
			  }

#STD# decimal_constant 	: { EmptyHeader = false;
			    mpcScan_Attribute.INTEGERconstant.Length = 
			    		length = mpcScan_GetWord (Word);
			    mpcScan_Attribute.INTEGERconstant.Ignore = NO;
			    mpcScan_Attribute.INTEGERconstant.IntConst =
				(int) strtol(Word, (char**)NULL, 10);
					/*atoi (Word);*/
			    if(errno) {
			      INIT_Warning((55, xxWarning, mpcScan_Attribute.Position, NoTree));
			      errno = 0;
			    }
			    mpcScan_Attribute.INTEGERconstant.SymForm =
						(char*)malloc(length+1);
			    for(index=0;index<length;index++)
				*(mpcScan_Attribute.INTEGERconstant.SymForm+index) =
							Word[index];
			    *(mpcScan_Attribute.INTEGERconstant.SymForm+length) = '\0';
                  	    return 5; }
#STD# octal_constant 	: { EmptyHeader = false;
			    mpcScan_Attribute.OCTALconstant.Length =
			    		length = mpcScan_GetWord (Word);
			    mpcScan_Attribute.OCTALconstant.Ignore = NO;
                            mpcScan_Attribute.OCTALconstant.OctConst =
				(int) strtol (Word, (char * *)NULL, 8);
			    if(errno) {
			      INIT_Warning((55, xxWarning, mpcScan_Attribute.Position, NoTree));
			      errno = 0;
			    }
			    mpcScan_Attribute.OCTALconstant.SymForm =
						(char*)malloc(length+1);
			    for(index=0;index<length;index++)
				*(mpcScan_Attribute.OCTALconstant.SymForm+index) =
							Word[index];
			    *(mpcScan_Attribute.OCTALconstant.SymForm+length) = '\0';
                            return 6; }
#STD# hex_constant 	: { EmptyHeader = false;
			    mpcScan_Attribute.HEXconstant.Length =
			    		length = mpcScan_GetWord (Word);
                            mpcScan_Attribute.HEXconstant.Ignore = NO;
                            mpcScan_Attribute.HEXconstant.HexConst =
				(int) strtol (Word, (char * *)NULL, 16);
			    if(errno) {
			      INIT_Warning((55, xxWarning, mpcScan_Attribute.Position, NoTree));
			      errno = 0;
			    }
			    mpcScan_Attribute.HEXconstant.SymForm =
						(char*)malloc(length+1);
			    for(index=0;index<length;index++)
				*(mpcScan_Attribute.HEXconstant.SymForm+index) =
							Word[index];
			    *(mpcScan_Attribute.HEXconstant.SymForm+length) = '\0';
                            return 7	; }
#STD# floating_constant	: { EmptyHeader = false;
			    mpcScan_Attribute.FLOATINGconstant.Length =
			    		length = mpcScan_GetWord (Word);
			    mpcScan_Attribute.FLOATINGconstant.Ignore = NO;
			    mpcScan_Attribute.FLOATINGconstant.FloatConst = strtod (Word, (char**)NULL);
				/* atof (Word); */
///***/printf("##### %e  errno=%d\n", mpcScan_Attribute.FLOATINGconstant.FloatConst, errno);
			    if(errno) {
			      INIT_Warning((55, xxWarning, mpcScan_Attribute.Position, NoTree));
			      errno = 0;
			    }
			    mpcScan_Attribute.FLOATINGconstant.SymForm =
						(char*)malloc(length+1);
			    for(index=0;index<length;index++)
				*(mpcScan_Attribute.FLOATINGconstant.SymForm+index) =
							Word[index];
			    *(mpcScan_Attribute.FLOATINGconstant.SymForm+length) = '\0';
                            return 4; }
#STD# L ? \' c_char + \': { EmptyHeader = false;
			    mpcScan_Attribute.CHARACTERconstant.Length =
			    		length = mpcScan_GetWord (Word);
			    mpcScan_Attribute.CHARACTERconstant.Ignore = NO;
			    mpcScan_Attribute.CHARACTERconstant.CharConst =
					Str_to_Char (Word,
						     mpcScan_Attribute.Position);
				/***	Str_to_Char (PutString(Word, length));*/
			    mpcScan_Attribute.CHARACTERconstant.SymForm =
						(char*)malloc(length+1);
			    for(index=0;index<length;index++)
				*(mpcScan_Attribute.CHARACTERconstant.SymForm+index) =
							Word[index];
			    *(mpcScan_Attribute.CHARACTERconstant.SymForm+length) = '\0';
                            return 8; }
#STD# L ? \" s_char * \": { int i;
			    EmptyHeader = false;
			    mpcScan_Attribute.STRINGliteral.Length =
			    		length = mpcScan_GetWord (Word);
			/**************************************/
			    mpcScan_Attribute.STRINGliteral.Ignore = NO;
			    mpcScan_Attribute.STRINGliteral.SymForm = 
						(char*)malloc(length+1);
			    *(Word+length) = '\0';
			    mpcScan_Attribute.STRINGliteral.SymForm =
				memcpy (mpcScan_Attribute.STRINGliteral.SymForm,
					Word, length+1);
			    length -= 2;   /* remove begin- and end-'"',then *
					    * convert esc. seq. to code:     */
			    for(index=i=1; index<=length; index++,i++) {
			      if(Word[index]=='\\') { /* escape sequence: */
				index++;
				switch(Word[index]){
				  case'\'': Word[i] = '\''; break;
				  case'"': Word[i] = '\"'; break;
				  case'?': Word[i] = '\?'; break;
				  case'\\': Word[i] = '\\'; break;
				  case'a': Word[i] = '\a'; break;
				  case'b': Word[i] = '\b'; break;
				  case'f': Word[i] = '\f'; break;
				  case'n': Word[i] = '\n'; break;
				  case'r': Word[i] = '\r'; break;
				  case't': Word[i] = '\t'; break;
				  case'v': Word[i] = '\v'; break;
				  default:
				    if(Word[index]>='0' && Word[index]<='7')
					Word[i] = Get_Oct_Code(
							Word+index, &index);
				    else
				    if(Word[index]=='x')
					Word[i] = Get_Hex_Code(
							Word + ++index, &index);
				    else
				      Make_Message(
					54, xxError, mpcScan_Attribute.Position, NoTree);
				/* "Invalid escape sequence in string literal" */
				    index--;
				}
			      }
			      else
				Word[i] = Word[index];
			    }
			    length = i-1;
			    mpcScan_Attribute.STRINGliteral.Length = i; /*bytes*/
			    mpcScan_Attribute.STRINGliteral.StrLit =
						(char*)malloc(i);
			    for(index=0;index<length;index++)
				*(mpcScan_Attribute.STRINGliteral.StrLit+index) =
							Word[index+1];
			    *(mpcScan_Attribute.STRINGliteral.StrLit+length) = '\0';
                            return 9; }

      \n		:- { yyEol(0); LinesInFile++; }

#STD# \f | \r		:- {}








