/************** compiler options (see "options.h"): **************/

#include "context.h"
#include "options.h"

int	
#ifdef __CB_COMPILER__
	CBRACKETS = YES,
#else
	CBRACKETS = NO,
#endif
        MPF_SRC = NO,
	C_2_MPC = NO,
	DEMO_MODE = NO,
	SEE_OMP = NO,
	VERBOSE = NO,
	MPCC_DEBUG = NO,
	DUMP = NO,
#ifdef MPC_DEBUGGER
	MPC_DBG_TRACE = NO,
#endif
	STORE_MESSAGES = YES,
	EVAL_CONST = YES,
	BLOCK_TO_GRID = NO,
	PUT_TREE = NO,
	GET_TREE = NO,
	WRITE_TREE = NO,
	READ_TREE = NO,
	KEYWORDS =
#ifdef __CB_COMPILER__
		   K_ANSI,
#else
		   K_SHORT, /* ANSI_C + mpC 'short' keywords (without 'mpc_') */
#endif
	MAX_NET = 64,
	PRAGMA_BIG = YES,
	xopt = 0,
	XOPT = 0,

#ifdef MPC_DEBUGGER
        DBG_CODE = NO,
#endif

	OPT_LEVEL = 0;      /* no optimization; */
