
  #include <stdio.h>

  /*----------------------------------------------------------*/

  int
  Get_width
  (
     int i, int j, int k, int l,
     int n, int b,
     int p, int q
  )
  {
     int w[p*q*p*q], h[p*q*p*q], trow[p*q], tcol[p*q];
     int MSIZE = n/b;

     HMPI_Partition_matrix_2d(
         p, q, 1, NULL, NULL, NULL,
         MSIZE, MSIZE,
         HMPI_COLUMN_BASED,
         w, h, trow, tcol,
         NULL, NULL
     );

     return w[HMPI_RECT_INDEX(i, j, k, l, p, q)];
  }

  /*----------------------------------------------------------*/

  int
  Get_height
  (
     int i, int j, int k, int l,
     int n, int b,
     int p, int q
  )
  {
     int w[p*q*p*q], h[p*q*p*q], trow[p*q], tcol[p*q];
     int MSIZE = n/b;

     HMPI_Partition_matrix_2d(
         p, q, 1, NULL, NULL, NULL,
         MSIZE, MSIZE,
         HMPI_COLUMN_BASED,
         w, h, trow, tcol,
         NULL, NULL
     );

     return h[HMPI_RECT_INDEX(i, j, k, l, p, q)];
  }

  /*----------------------------------------------------------*/


