
#ifndef __HSCAL_CB_SDOT_HSCALFUNC_HH
#define __HSCAL_CB_SDOT_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_sdot(
    int *n, 
    int *incx, 
    int *incy,
    double *tcomp
)
{
    int i__1;
    int i__, m;
    int mp1;

    *tcomp = 0.;

    if (*n <= 0) {
	return HSCAL_SUCCESS;
    }

    if (*incx == 1 && *incy == 1) {
	goto L20;
    }

    *tcomp += 4 * (*n);

    return HSCAL_SUCCESS;

L20:
    m = *n % 5;
    if (m == 0) {
	goto L40;
    }

    *tcomp += 2 * m;

    if (*n < 5) {
	goto L60;
    }
L40:
    mp1 = m + 1;
    i__1 = *n;
    for (i__ = mp1; i__ <= i__1; i__ += 5) {
        *tcomp += 10;
    }
L60:
    return HSCAL_SUCCESS;
}

#endif
