
#ifndef __HSCAL_CB_SSWAP_HSCALFUNC_HH
#define __HSCAL_CB_SSWAP_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_sswap(
    int *n,
    int *incx,
    int *incy,
    double *tcomp
)
{
    int i__1;
    int i__, m;
    int mp1;

    *tcomp = 0.;

    if (*n <= 0) {
	return HSCAL_SUCCESS;
    }
    if (*incx == 1 && *incy == 1) {
	goto L20;
    }

    *tcomp += (*n * 5);

    return HSCAL_SUCCESS;


L20:
    m = *n % 3;
    if (m == 0) {
	goto L40;
    }

    *tcomp += (m * 3);

    if (*n < 3) {
	return HSCAL_SUCCESS;
    }
L40:
    mp1 = m + 1;
    i__1 = *n;
    for (i__ = mp1; i__ <= i__1; i__ += 3) {
        *tcomp += 9;
    }
    return HSCAL_SUCCESS;
}

#endif
