
#ifndef __HSCAL_CB_ZDOTC_HSCALFUNC_HH
#define __HSCAL_CB_ZDOTC_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_zdotc(
    int *n, 
    int *incx, 
    int *incy,
    double *tcomp
)
{
    *tcomp = 0.;

    if (*n <= 0) {
	return HSCAL_SUCCESS;
    }

    if (*incx == 1 && *incy == 1) {
	goto L20;
    }

    *tcomp += 15 * (*n);

    return HSCAL_SUCCESS;

L20:

    *tcomp += 13 * (*n);

    return HSCAL_SUCCESS;
}

#endif
