
#ifndef __HSCAL_CB_ZSCAL_HH
#define __HSCAL_CB_ZSCAL_HH



#include "../../../include/hscalapack.h"

int hscal_zscal(
    int *n,
    char *cza,
    int *incx,
    double *tcomp
)
{
    hscaldoublecomplex *za = (hscaldoublecomplex*)cza;

    *tcomp = 0.;

    if (*n <= 0 || *incx <= 0) {
       return HSCAL_SUCCESS;
    }

    if (*incx == 1) {
       *tcomp += (*n * 10);
       return HSCAL_SUCCESS;
    }

    *tcomp += (*n * 11);

    return HSCAL_SUCCESS;
}


#endif
