
#ifndef __HSCAL_CB_ZSWAP_HSCALFUNC_HH
#define __HSCAL_CB_ZSWAP_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_zswap(
    int *n,
    int *incx,
    int *incy,
    double *tcomp
)
{
    *tcomp = 0.;

    if (*n <= 0) {
	return HSCAL_SUCCESS;
    }
    if (*incx == 1 && *incy == 1) {
	goto L20;
    }

    *tcomp += (*n * 8);

    return HSCAL_SUCCESS;

L20:
    *tcomp += (*n * 6);

    return HSCAL_SUCCESS;
}

#endif
