
#ifndef __HSCAL_PTZB_CMMCADD_HSCALFUNC_HH
#define __HSCAL_PTZB_CMMCADD_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_cmmcadd(
    int *m, 
    int *n, 
    char *calpha, 
    int *lda, 
    char *cbeta,
    int *ldb,
    double *tcomp
)
{
hscalcomplex *alpha = (hscalcomplex*)calpha;
hscalcomplex *beta = (hscalcomplex*)cbeta;
int c__1 = 1;
hscaldoublereal tm, tn;

*tcomp = 0.;

{
    int i__1, i__2, i__3, i__4;
    int i__, j;

    tm = (double)(*m);
    tn = (double)(*n);

    if (alpha->r == 1.f && alpha->i == 0.f) {
	if (beta->r == 0.f && beta->i == 0.f) {
           *tcomp += tn * tm * 9;
	} else if (beta->r != 1.f || beta->i != 0.f) {
           *tcomp += tn * tm * 19;
	} else {
           *tcomp += tn * tm * 13;
	}
    } else if (alpha->r != 0.f || alpha->i != 0.f) {
	if (beta->r == 0.f && beta->i == 0.f) {
           *tcomp += tn * tm * 15;
	} else if (beta->r != 1.f || beta->i != 0.f) {
           *tcomp += tn * tm * 25;
	} else {
           *tcomp += tn * tm * 19;
	}
    } else {
	if (beta->r == 0.f && beta->i == 0.f) {
           *tcomp += tn * tm * 4;
	} else if (beta->r != 1.f || beta->i != 0.f) {
            hscal_cscal(
                m, cbeta, &c__1, tcomp
            );
            *tcomp *= *n;
	}
    }
}

return HSCAL_SUCCESS;
}

#endif

