
#ifndef __HSCAL_PTZB_CRSHFT_HSCALFUNC_HH
#define __HSCAL_PTZB_CRSHFT_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_crshft(
    int *m, 
    int *n, 
    int *offset,
    int *lda, 
    double *tcomp
)
{
    int a_dim1, a_offset, i__1, i__2, i__3, i__4;
    int i__, j;
    hscaldoublereal tm, tn;
    
    *tcomp = 0.;

    if (*offset == 0 || *m <= 0 || *n <= 0) {
	return HSCAL_SUCCESS;
    }

    tm = (double)(*m);
    tn = (double)(*n);

    if (*offset > 0) {
       *tcomp += tn*tm*7;
    } else {
       *tcomp += tn*tm*7;
    }

    return HSCAL_SUCCESS;
}

#endif
