
#ifndef __HSCAL_PTZB_ZMMCADD_HSCALFUNC_HH
#define __HSCAL_PTZB_ZMMCADD_HSCALFUNC_HH



#include "../../../include/hscalapack.h"

int hscal_zmmcadd(
    int *m, 
    int *n, 
    char *calpha,
    int *lda, 
    char *cbeta,
    int *ldb,
    double *tcomp
)
{
int c__1 = 1;
hscaldoublecomplex *alpha = (hscaldoublecomplex*)calpha;
hscaldoublecomplex *beta = (hscaldoublecomplex*)cbeta;
hscaldoublereal tm, tn;

*tcomp = 0.;
{
    int a_dim1, a_offset, b_dim1, b_offset, i__1, i__2, i__3, i__4;
    int i__, j;

    tm = (double)(*m);
    tn = (double)(*n);

    if (alpha->r == 1. && alpha->i == 0.) {
	if (beta->r == 0. && beta->i == 0.) {
            *tcomp += (tn * tm * 9);
	} else if (beta->r != 1. || beta->i != 0.) {
            *tcomp += (tn * tm * 19);
	} else {
            *tcomp += (tn * tm * 13);
	}
    } else if (alpha->r != 0. || alpha->i != 0.) {
	if (beta->r == 0. && beta->i == 0.) {
            *tcomp += (tn * tm * 15);
	} else if (beta->r != 1. || beta->i != 0.) {
            *tcomp += (tn * tm * 25);
	} else {
            *tcomp += (tn * tm * 19);
	}
    } else {
	if (beta->r == 0. && beta->i == 0.) {
            *tcomp += (tn * tm * 4);
	} else if (beta->r != 1. || beta->i != 0.) {
	    {
                double t;
		hscal_zscal(
                     m, cbeta, &c__1,
                     &t
                );
                *tcomp += t*tn;
	    }
	}
    }
}

return HSCAL_SUCCESS;
}

#endif

