
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_ctranu_benchmark(
    int     *m, 
    int     *n, 
    hscalcomplex *alpha, 
    hscalcomplex *a, 
    int     *lda, 
    hscalcomplex *beta, 
    hscalcomplex *c__,
    int     *ldc
)
{
    return hscal_ctranu_benchmark_i(
           (hscalinteger*)m,
           (hscalinteger*)n,
           alpha,
           a,
           (hscalinteger*)lda,
           beta,
           c__,
           (hscalinteger*)ldc
    );
}

/*------------------------------------------------------------------*/

int hscal_ctranu_benchmark_i(
    hscalinteger *m, 
    hscalinteger *n, 
    hscalcomplex *alpha, 
    hscalcomplex *a, 
    hscalinteger *lda, 
    hscalcomplex *beta, 
    hscalcomplex *c__,
    hscalinteger *ldc
)
{
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_ztranu_benchmark(
    int     *m, 
    int     *n, 
    hscaldoublecomplex *alpha, 
    hscaldoublecomplex *a, 
    int     *lda, 
    hscaldoublecomplex *beta, 
    hscaldoublecomplex *c__, 
    int     *ldc
)
{
    return hscal_ztranu_benchmark_i(
           (hscalinteger*)m,
           (hscalinteger*)n,
           alpha,
           a,
           (hscalinteger*)lda,
           beta,
           c__,
           (hscalinteger*)ldc
    );
}

/*------------------------------------------------------------------*/

int hscal_ztranu_benchmark_i(
    hscalinteger *m, 
    hscalinteger *n, 
    hscaldoublecomplex *alpha, 
    hscaldoublecomplex *a, 
    hscalinteger *lda, 
    hscaldoublecomplex *beta, 
    hscaldoublecomplex *c__, 
    hscalinteger *ldc
)
{
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/
