
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_dger_benchmark(
    int     *m,
    int     *n,
    hscaldoublereal *alpha,
    hscaldoublereal *x,
    int     *incx,
    hscaldoublereal *y,
    int     *incy,
    hscaldoublereal *a,
    int     *lda
)
{
    dger_(
           m,
           n,
           (char*)alpha,
           (char*)x,
           incx,
           (char*)y,
           incy,
           (char*)a,
           lda
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

int hscal_sger_benchmark(
    int     *m,
    int     *n,
    hscalreal *alpha,
    hscalreal *x,
    int     *incx,
    hscalreal *y,
    int     *incy,
    hscalreal *a,
    int     *lda
)
{
    sger_(
           m,
           n,
           (char*)alpha,
           (char*)x,
           incx,
           (char*)y,
           incy,
           (char*)a,
           lda
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

