
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_chemv_benchmark(
    char    *uplo,
    int     *n,
    hscalcomplex *alpha,
    hscalcomplex *a,
    int     *lda,
    hscalcomplex *x,
    int     *incx,
    hscalcomplex *beta,
    hscalcomplex *y,
    int     *incy
)
{
    chemv_(
           uplo,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)x,
           incx,
           (char*)beta,
           (char*)y,
           incy
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

int hscal_zhemv_benchmark(
    char *uplo,
    int     *n,
    hscaldoublecomplex *alpha,
    hscaldoublecomplex *a,
    int     *lda,
    hscaldoublecomplex *x,
    int     *incx,
    hscaldoublecomplex *beta,
    hscaldoublecomplex *y,
    int     *incy
)
{
    zhemv_(
           uplo,
           n,
           (char*)alpha,
           (char*)a,
           lda,
           (char*)x,
           incx,
           (char*)beta,
           (char*)y,
           incy
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

