
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_cher_benchmark(
    char    *uplo,
    int     *n,
    hscalreal    *alpha,
    hscalcomplex *x,
    int     *incx,
    hscalcomplex *a,
    int     *lda
)
{
    cher_(
           uplo,
           n,
           (char*)alpha,
           (char*)x,
           incx,
           (char*)a,
           lda
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

int hscal_zher_benchmark(
    char          *uplo,
    int           *n,
    hscaldoublereal    *alpha,
    hscaldoublecomplex *x,
    int           *incx,
    hscaldoublecomplex *a,
    int           *lda
)
{
    zher_(
           uplo,
           n,
           (char*)alpha,
           (char*)x,
           incx,
           (char*)a,
           lda
    );

    return HSCAL_SUCCESS;

}

/*------------------------------------------------------------------*/

