
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

hscaldoublereal hscal_dnrm2_benchmark(
           int     *n,
           hscaldoublereal *x,
           int     *incx
)
{
    return dnrm2_(
           n,
           (char*)x,
           incx
    );
}

/*------------------------------------------------------------------*/

hscaldoublereal hscal_dznrm2_benchmark(
           int     *n,
           hscaldoublecomplex *x,
           int     *incx
)
{
    return dznrm2_(
           n,
           (char*)x,
           incx
    );
}

/*------------------------------------------------------------------*/

hscaldoublereal hscal_snrm2_benchmark(
           int  *n,
           hscalreal *x,
           int  *incx
)
{
    return snrm2_(
           n,
           (char*)x,
           incx
    );
}

/*------------------------------------------------------------------*/

hscaldoublereal hscal_scnrm2_benchmark(
           int     *n,
           hscalcomplex *x,
           int     *incx
)
{
    return scnrm2_(
           n,
           (char*)x,
           incx
    );
}

/*------------------------------------------------------------------*/

