
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_dsyr_benchmark(
    char       *uplo,
    int        *n,
    hscaldoublereal *alpha,
    hscaldoublereal *x,
    int        *incx,
    hscaldoublereal *a,
    int        *lda
)
{
    dsyr_(
           uplo,
           n,
           (char*)alpha,
           (char*)x,
           incx,
           (char*)a,
           lda
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_ssyr_benchmark(
    char    *uplo,
    int     *n,
    hscalreal    *alpha,
    hscalreal    *x,
    int     *incx,
    hscalreal    *a,
    int     *lda
)
{
    ssyr_(
           uplo,
           n,
           (char*)alpha,
           (char*)x,
           incx,
           (char*)a,
           lda
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

