
#include <math.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>

#include "../../include/hscalapack.h"

/*------------------------------------------------------------------*/

int hscal_ctrmv_benchmark(
    char *uplo,
    char *trans,
    char *diag,
    int     *n,
    hscalcomplex *a,
    int     *lda,
    hscalcomplex *x,
    int     *incx
)
{
    ctrmv_(
           uplo,
           trans,
           diag,
           n,
           (char*)a,
           lda,
           (char*)x,
           incx
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_dtrmv_benchmark(
    char *uplo,
    char *trans,
    char *diag,
    int     *n,
    double *a,
    int     *lda,
    double *x,
    int     *incx
)
{
    dtrmv_(
           uplo,
           trans,
           diag,
           n,
           (char*)a,
           lda,
           (char*)x,
           incx
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_strmv_benchmark(
    char *uplo,
    char *trans,
    char *diag,
    int     *n,
    hscalreal *a,
    int     *lda,
    hscalreal *x,
    int     *incx
)
{
    strmv_(
           uplo,
           trans,
           diag,
           n,
           (char*)a,
           lda,
           (char*)x,
           incx
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

int hscal_ztrmv_benchmark(
    char *uplo,
    char *trans,
    char *diag,
    int     *n,
    hscaldoublecomplex *a,
    int     *lda,
    hscaldoublecomplex *x,
    int     *incx
)
{
    ztrmv_(
           uplo,
           trans,
           diag,
           n,
           (char*)a,
           lda,
           (char*)x,
           incx
    );
    return HSCAL_SUCCESS;
}

/*------------------------------------------------------------------*/

