
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK                          *
*                 =======================                          *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_INCLUDE_HH
#define __HMPI_SCALAPACK_INCLUDE_HH

#include <hmpi.h>
#include "scalapack.h"
#include "hscalpblasbenchmarki.h"
#include "hscalpblaslevel1.h"
#include "hscalpblaslevel2.h"
#include "hscalpblaslevel3.h"
#include "hscalpblaspmodels.h"
#include "hscalheuristicfns.h"
#include "hscalenvironment.h"
#include "hscalpblasctxt.h"
#include "hscalapackctxt.h"
#include "hscalpblasoptimals.h"
#include "hscalpblaspautof.h"
#include "hscalapackpmodels.h"
#include "hscalapackgroupmgmt.h"  
#include "hscalblacsbuff.h"

/*
* ------------------------------------------------------------------
*       EXPLICIT BUILT-IN 'C' FUNCTION DECLARATIONS
*       TO AVOID COMPILER WARNINGS
* ------------------------------------------------------------------
*/
#include "hscalblacsbuiltins.h"

#endif /* __HMPI_SCALAPACK_INCLUDE_HH */
