
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK                          *
*                     BUILTIN FUNCTIONS                            *
*                         (INTERNAL)                               *
*                 =======================                          *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_BUILTIN_FUNCTIONS_HH
#define __HMPI_SCALAPACK_BUILTIN_FUNCTIONS_HH

hscalinteger indxg2p_(
        hscalinteger *indxglob, 
        hscalinteger *nb, 
        hscalinteger *iproc, 
        hscalinteger *isrcproc, 
        hscalinteger *nprocs
);

int infog2l_(
    hscalinteger *grindx, 
    hscalinteger *gcindx, 
    hscalinteger *desc,
    hscalinteger *nprow, 
    hscalinteger *npcol, 
    hscalinteger *myrow, 
    hscalinteger *mycol,
    hscalinteger *lrindx, 
    hscalinteger *lcindx, 
    hscalinteger *rsrc, 
    hscalinteger *csrc
);

int descset_(
    hscalinteger *desc, 
    hscalinteger *m, 
    hscalinteger *n, 
    hscalinteger *mb, 
    hscalinteger *nb, 
    hscalinteger *irsrc, 
    hscalinteger *icsrc, 
    hscalinteger *ictxt,
    hscalinteger *lld
);

hscalinteger numroc_(
        hscalinteger *n, 
        hscalinteger *nb, 
        hscalinteger *iproc, 
        hscalinteger *isrcproc,
        hscalinteger *nprocs
);

#endif  /* __HMPI_SCALAPACK_BUILTIN_FUNCTIONS_HH */

