
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK                          *
*                 =======================                          *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HSCALAPACK_ENVP_HH_
#define __HSCALAPACK_ENVP_HH_

/*
* There are two modes of execution of performance models
* HSCAL_TSLAVES_EXP
* -- In this mode, all the iterations are used for the estimation
*    This is a expensive mode
* HSCAL_TSLAVES_INEXP
* -- In this mode, only one iteration is used
*    This is an inexpensive mode
*/
int hscal_timeof_slaves_exp();

#endif /* __HSCALAPACK_ENVP_HH_ */

