
/*******************************************************************
*                                                                  *
*                 Heterogeneous ScaLAPACK Optimal                  *
*                 Determination functions (PBLAS)                  *
*                 ===============================                  *
*                                                                  *
*  Copyright (c) 2006   School of Computer Science and Informatics *
*                              University College Dublin.          *
*                                                                  *
*  All rights reserved. We assume no responsibility for the use    *
*  or reliability of our software.                                 *
*                                                                  *
********************************************************************/

#ifndef __HMPI_SCALAPACK_PBLAS_OPTIMALS_INCLUDE_HH
#define __HMPI_SCALAPACK_PBLAS_OPTIMALS_INCLUDE_HH

/*
* pzgemm optimal block size
*/
int hscal_pack_pzgemm_modelp_noauto_optimal_b(
   F_CHAR_T TRANSA,
   F_CHAR_T TRANSB,
   int * M,
   int * N,
   int * K,
   double * ALPHA,
   int * IA,
   int * JA,
   int * DESCA,
   int * IB,
   int * JB,
   int * DESCB,
   double * BETA,
   int * IC,
   int * JC,
   int * DESCC,
   int * reconm,
   int * reconn,
   int * OPTIMALB,
   int * nprow,
   int * npcol,
   int **model_params,
   int *model_count
);

#endif  /* __HMPI_SCALAPACK_OPTIMALS_PBLAS_INCLUDE_HH */
