#!/bin/sh

declare -a hscal_routines

hscal_routines=( pcswap pdswap psswap pzswap pcsscal pcscal pzdscal pdscal psscal pzscal pccopy pdcopy picopy pscopy pzcopy pcaxpy pdaxpy psaxpy pzaxpy pcamax pdamax psamax pzamax pdasum psasum pdzasum pscasum pdnrm2 psnrm2 pdznrm2 pscnrm2 pcdotc pzdotc pcdotu pzdotu pddot psdot )

for routine in ${hscal_routines[@]}
do
	echo "===============Running ${routine}===================="
	./run_hscal_${routine}_auto.sh > hscal_${routine}.txt 2>&1
done

exit 0
