#!/bin/sh

. ./cparameters.sh

PSIZE_COUNT=1

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pscnrm2_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pscnrm2_parameters.h
	echo ""                                                     >> hscalapack_pscnrm2_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pscnrm2_parameters.h
	echo "int     NB               = 32;"                       >> hscalapack_pscnrm2_parameters.h
	echo "int     IX               = 1;"                        >> hscalapack_pscnrm2_parameters.h
	echo "int     JX               = 1;"                        >> hscalapack_pscnrm2_parameters.h
	echo "int     INCX             = 1;"                        >> hscalapack_pscnrm2_parameters.h
	echo "int     CHECK_RESULT     = 0;"                        >> hscalapack_pscnrm2_parameters.h
	echo ""                                                     >> hscalapack_pscnrm2_parameters.h
	echo "#endif"                                               >> hscalapack_pscnrm2_parameters.h

	./run_hscal.sh test_hscal_pscnrm2_auto hscalapack_pscnrm2_parameters.h

	let "PSIZE_COUNT = $PSIZE_COUNT + 1"

done
