#!/bin/sh

. ./cparameters.sh

PSIZE_COUNT=16

while [ "$PSIZE_COUNT" -le "$NUMBER_OF_PSIZE_ITERATIONS" ]
do

	P_COUNT=0
	NUMBER_OF_P_ITERATIONS=${#VALUES_OF_P[@]}

	while [ "$P_COUNT" -lt "$NUMBER_OF_P_ITERATIONS" ]
	do

	let "PSIZE=$PSIZE_COUNT*$PSIZE_INCREMENT"

	echo "#ifndef _PROBLEM_PARAMETERS_HH"                        > hscalapack_pdgetrf_parameters.h
	echo "#define _PROBLEM_PARAMETERS_HH"                       >> hscalapack_pdgetrf_parameters.h
	echo ""                                                     >> hscalapack_pdgetrf_parameters.h
	echo "int     M                = $PSIZE;"                   >> hscalapack_pdgetrf_parameters.h
	echo "int     N                = $PSIZE;"                   >> hscalapack_pdgetrf_parameters.h
	echo "int     MB               = 64;"                       >> hscalapack_pdgetrf_parameters.h
	echo "int     NB               = 64;"                       >> hscalapack_pdgetrf_parameters.h
	echo "int     IA               = 1;"                        >> hscalapack_pdgetrf_parameters.h
	echo "int     JA               = 1;"                        >> hscalapack_pdgetrf_parameters.h
	echo "int     IB               = 1;"                        >> hscalapack_pdgetrf_parameters.h
	echo "int     JB               = 1;"                        >> hscalapack_pdgetrf_parameters.h
	echo ""                                                     >> hscalapack_pdgetrf_parameters.h
	echo "#endif"                                               >> hscalapack_pdgetrf_parameters.h

	./run_hscal.sh test_hscal_pdgetrf hscalapack_pdgetrf_parameters.h

	let "P_COUNT = $P_COUNT + 1"
	done

let "PSIZE_COUNT = $PSIZE_COUNT + 1"
done

